/**
 * 
 */
package kfmes.jateon.plugin;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;

import kfmes.jateon.swt.MainFrame;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.SwitchBoardSession;
import kfmes.natelib.entity.NateFriend;

/**
 * 플러그인을 컨트롤 하기위한 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: Control.java,v 1.6 2007/11/19 10:13:36 kfmes Exp $
 */
public class Control {
	private NateonMessenger nate = null;
	private MainFrame mainFrm = null;
	private SwitchBoardSession ss = null;
	private NateFriend natefriend = null;
	
	
	/**
	 * 
	 * @param mainfrm
	 * @param nate
	 */
	public Control(MainFrame mainfrm,  NateonMessenger nate) {
		this.nate = nate;
		this.mainFrm= mainfrm;

	}
	
	/**
	 * SS 가 필요한 경우 사용
	 * @param ss
	 */
	public void setSS(SwitchBoardSession ss){
		this.ss = ss;
	}
	/**
	 * SS 가 필요한 경우 사용
	 * @param ss
	 */
	public SwitchBoardSession getSS(){
		return ss;
	}
	
	/**
	 * 
	 * @param f
	 */
	public void setNateFriend(NateFriend f){
		this.natefriend  = f;
	}
	
	/**
	 * MainFrame의 shell 을 얻어온다.
	 * @return shell 
	 */
	public Shell getMainFrameShell(){
		return MainFrame.shell;
	}
	
	/**
	 * 새로 shell 을 생성한경우 반드시 불러줘야한다
	 * @param composite
	 */
	public void addWindow(Composite composite){
		mainFrm.addWindow(composite);		
	}
	/**
	 * shell 이 dispose 전에 반드시 불러줘야한다
	 * @param composite
	 */
	public void removeWindow(Composite composite){
		mainFrm.removeWindow(composite);
	}

	/**
	 * nateon messenger 를 얻어온다.
	 * @return nateon messenger
	 */
	public NateonMessenger getNateonMessenger(){
		return nate;
	}
	
	
	
	
	
	

}
