package kfmes.jateon.plugin;

/**
 * 플러그인에서 구현해야 하는 인터페이스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: Plugin.java,v 1.7 2007/11/19 10:13:36 kfmes Exp $
 */
public interface Plugin {
	
	/**
	 * 플러그인 텍스트 설정
	 * @param text
	 */
	public void setText(String text);
	/**
	 * 플러그인 텍스트 가져오기
	 * @return
	 */
	public String getText();
	
	/**
	 * 플러그인 이름을 얻어온다
	 * @return
	 */
	public String getPluginName();
	
	/**
	 * 플러그인 버전을 얻어온다
	 * @return
	 */
	public String getPlugVersoin();
	
	/**
	 * 플러그인 정보를 얻어온다.
	 * @return
	 */
	public String getPluginInfo();
	//public void init(MainFrame jateon, NateonMessenger nate);
	
	/**
	 * 컨트롤을 초기화 한다.
	 */
	public void initControl(Control control);
	
	public void runPlugin();
	
	
}
