/**
 * 
 */
package kfmes.jateon.plugin;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.InputStream;
import java.net.URLClassLoader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

/**
 * 플러그인 로더
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: PluginLoader.java,v 1.7 2007/11/19 10:13:36 kfmes Exp $
 *
 */
public class PluginLoader {

	private URLClassLoader cl = null;
	private String plugPath = null;
	private ArrayList<Plugin>list = new ArrayList<Plugin>();
	private HashMap<String, PluginEntry>pluginLIst = new HashMap<String, PluginEntry>();
	//private ArrayList<File>pluginList= new ArrayList<File>();
	private File clsDir = null;
	
	private final String PluginInfoFile = "META-INF/MANIFEST.MF";
	//private final String PluginInfoFile = "plugin.txt";
	
	//private JarClassLoader jloader = null;
	
	public PluginLoader(String plugpath) throws Exception{
		this.plugPath = plugpath;
		//cl = getClass().getClassLoader();
		
		init();



		
	}
	
	private void println(String txt){
		System.out.println(txt);
	}
	private String readLine(InputStream i) throws IOException{
		ByteArrayOutputStream inbuf = new ByteArrayOutputStream();
		
		int v;
		inbuf.reset();
		
		while(true){
			v = i.read();
			if(v==-1)	return null;
			if(v==13)	continue;
			if(v==10)	break;
			inbuf.write(v);
			
		}
		return new String(inbuf.toByteArray());
	}
	private ArrayList<String> getPluginInfo(JarFile jarfile)throws IOException{
		InputStream in = jarfile.getInputStream(jarfile.getEntry(PluginInfoFile));
		
		ArrayList<String> info = new ArrayList<String>();
		
		while(in.available()>0){
			info.add(readLine(in));
		}
		in.close();
		
		return info;
	}

	
	private void init() throws Exception{

		clsDir = new File(getClass().getClassLoader().getResource(plugPath).getFile());
		
		if(clsDir==null || !clsDir.isDirectory())
			throw new FileNotFoundException();
		
		for(File f : clsDir.listFiles(new FilenameFilter(){
			public boolean accept(File dir, String name) {
				String lc = name.toLowerCase();
				return lc.endsWith(".jar") ;
			}			
		})){
			
			String mainClass = null;
			
			try{
				JarFile jf = new JarFile(f);
				InputStream ji = jf.getInputStream(jf.getEntry(PluginInfoFile));
				while(ji.available()>0){
					String line = readLine(ji);
					if(line.startsWith("Main-Class"))
						mainClass = line.substring(line.indexOf(":") +1 );
					
				}
				
				if(mainClass!=null)
					pluginLIst.put(f.getName(), new PluginEntry(jf,mainClass));
			}
			catch (Exception e) {
				System.err.println( f.getName() + " : plugin.txt read fail");
			}
			
			
			
			
			
			
			
		}
		
		
		
		/*
		
		
		File file = new File(clsDir ,  "PlugTestA.jar");
		File file2 = new File(clsDir, "PlugTestM.jar");
		println(file.getAbsolutePath() + "  " + file.exists());
		JarFile jfile = new JarFile(file);
		
		InputStream in = jfile.getInputStream(
				jfile.getEntry("plugin.txt"));
		
		
		
		Enumeration<JarEntry>je = jfile.entries();
		
		while(je.hasMoreElements()){
			
			JarEntry e = je.nextElement();
			if(e.getName().endsWith(".class")){
				e.
				
			}
				
			
			
		}
		
		
		cl = URLClassLoader.newInstance(new URL[] { file.toURL(), file2.toURL()} );
		
		
		
		
		Class loaded = cl.loadClass("kfmes.plugins.PlugTestA");

		
		Plugin p = (Plugin) loaded.newInstance();
		println(p.getPluginName());
		p.setText("hi hi hi ");
		println(p.getText());
		
		
		Class mulitcls = cl.loadClass("kfmes.plugins.PlugTestM");
		Plugin pp = (Plugin) mulitcls.newInstance();
		println(pp.getPluginName());
		pp.setText("hi hi hi ");
		println(pp.getText());
		*/
		
		
		//jloader = new JarClassLoader(cl.)
		
	}
	
	/*
	private void init(){
		// get plugin list
		ClassLoader c = ClassLoader.
		for(File f : clsDir.listFiles(new FilenameFilter(){
			public boolean accept(File dir, String name) {
				String lc = name.toLowerCase();
				return lc.endsWith(".jar") || lc.endsWith(".class");
			}			
		})){
			
			Class.forName(f.getName(), true, loader)
			
			
		}
			
			
		
	}
	*/
	
	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		new PluginLoader("plugin");

	}

}
