/**
 * 
 */
package kfmes.jateon.swing;

import java.util.StringTokenizer;

import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.tree.DefaultMutableTreeNode;

import kfmes.jateon.swing.dialog.AddFriendDialog;
import kfmes.jateon.swing.dialog.ChatWindow;
import kfmes.jateon.swing.dialog.LoginDialog;
import kfmes.jateon.swing.dialog.NateSMSGUI;
import kfmes.jateon.swing.dialog.OptionDialog;
import kfmes.jateon.swing.dialog.SendMessageGUI;
import kfmes.jateon.swing.dialog.infoLicense;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.SwitchBoardSession;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.entity.UserStatus;
import kfmes.natelib.util.HtmlReader;
import kfmes.natelib.util.MsgUtil;

/**
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: ActionGroup.java,v 1.45 2007/11/19 10:13:34 kfmes Exp $
 */

final public class ActionGroup {
	private MainFrame main = null;
	private NateonMessenger nate = null;
	private BuddyTree buddies = null;
	

	public ActionGroup( MainFrame main, BuddyTree buddies )
	{
		this.main = main;
		this.buddies = buddies;
		this.nate = main.getMessenger();


	}

	
	private NateFriend getSelectedUser(){
		DefaultMutableTreeNode o = 
			(DefaultMutableTreeNode) buddies.getLastSelectedPathComponent();
		try{
			NateFriend fr = (NateFriend)o.getUserObject();
		return fr;
		}catch (NullPointerException e) {
			return null;
		}
	 
	}
	
	
	/**
	 * 알파 & 베타 테스트 기간동안 서버에 기록을 남기기 위한 코드
	 * http://155.230.165.20/~kfmes/jateonLog/";
	 * access.php?cver=xxx
	 * @param loginName
	 */
	protected void actionProcessLogin(String loginName){
		{
			String url = kfmes.jateon.swing.Main.authServer;
			//url += "access.php?id=" + loginName + "&cver=" + kfmes.jateon.swing.Main.ver; 
			url += "access.php?cver=" + kfmes.jateon.swing.Main.ver;
			
			HtmlReader reader = new HtmlReader(url,"UTF8");
			String result;
			result = reader.getHTML().trim();
		
			String resultar[] = null;
			
			resultar = result.split("\n");
			result = result.replaceAll("\n", "\r\n");
			

			if(resultar[0].equals("Warning")){
				JOptionPane.showMessageDialog(main,
						result.substring(result.indexOf("\n")+1), "경고",
						JOptionPane.WARNING_MESSAGE);				
			}
			else if(result.length()==0){
				JOptionPane.showMessageDialog(main,
						"최신버전 정보를 가져오지 못했습니다.", "경고",
						JOptionPane.WARNING_MESSAGE);	
			}
			else if(!resultar[0].equals("OK"))
			{
				JOptionPane.showMessageDialog(main,
						"이용이 제한 되었습니다\r\n이유 : " + result, "정보",
						JOptionPane.ERROR_MESSAGE);
				System.exit(0);
			}
			else if(resultar.length > 1){
				JOptionPane.showMessageDialog(main,
						result.substring(result.indexOf("\n")+1), "정보",
						JOptionPane.INFORMATION_MESSAGE);
			}
			
		}
		
		/**
		 * access log code 끝
		 */
				
	}
	
	public boolean actionLogin()
	{
		LoginDialog dialog = new LoginDialog(main, "로그인", true);		
		dialog.setVisible(true);		
			
		if(dialog.isOK()) {
			String loginName = dialog.getLoginName();
			String passwd = dialog.getPasswd();
			dialog.dispose();
			nate.is_encodedpasswd = true;
			actionProcessLogin(loginName);
			nate.login(loginName,passwd);	
			return true;
		}
		return false;
	}

	public void actionLogout()
	{
		try{
			ConfUtil conf = main.getConfutil();
			conf.readData();

			conf.set("FrameLocation", main.getFrameInfo());
			conf.set("offview", (buddies.getOffview()? "yes":"no"));
			conf.set("viewmode", buddies.getRenderer().getBuddyView() + "" );
			conf.set("LookAndFeel", main.currentLookAndFeel);
			conf.set("DefaultAction", main.getDblClickDefaultAction() + "");
					
			conf.writeData();
			
			buddies.clearTree();
			
			if(!nate.getNS().isConnected())
				return;
			nate.setMyStatus(UserStatus.Offline);
			nate.logout();

			main.menuBar.setOnline(false);
		}
		catch (NullPointerException e) {

		}		
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	public void actionQuit(){
		
		actionLogout();
		System.exit(0);
	}
	public void actionClearLoginInfo(){
		
		
		if( JOptionPane.showOptionDialog(main, 
				"저장되어있던 로그인 정보와" +
				"\n 설정 데이터가 지워집니다.\n계속하시겠습니까? ", "경고",
				JOptionPane.OK_CANCEL_OPTION , JOptionPane.WARNING_MESSAGE,
				UIManager.getIcon("OptionPane.warningIcon")  , null , null)
				== JOptionPane.OK_OPTION)		{
			ConfUtil conf = main.getConfutil();
			conf.removeAll();
			conf.writeData();
			
		}
		
	}
	
	
	/*
istener( action.get("actionSendIMsg") );
			mReqChat.addActionListener( action.get("actionReqChat") );
	 */

	
	public void  actionSendIMsg(){
		if(nate.isLoggedIn()){
				
			NateFriend fr = getSelectedUser();
			if(fr==null)
				return;
			
			SendMessageGUI send = new SendMessageGUI(nate );			
			send.setRecvUser(getSelectedUser());
		}
	}
	
	public void actionReqChat(){
		if(nate.isLoggedIn()){
			
			NateFriend fr = getSelectedUser();
			if(fr==null)
				return;
			
			SwitchBoardSession ss =nate.findSwitchboardSessionAt(fr.getNateID());
			ChatWindow cw = buddies.getChatWindow(ss, fr);
			if(cw==null || !cw.getSS().isConnected()){
				
				/*
				if(ss==null){
					ss = nate.getNS().procOpenChat(nate.getOwner().getID() , fr.getNateID());
				}*/
				
			
				cw = new ChatWindow( nate,buddies,ss, fr);
			//	cw.setIconImage(UIToolkit.getFrameIcon(UIToolkit.iconChat));
				buddies.getChatWinList().add(cw);
				
				
			}
			else {
				
				cw.flashing();
			}
			
			
		}	
	}
	public void actionSendSMS(){
		if(nate.isLoggedIn()){
			NateSMSGUI sms = new NateSMSGUI(nate,main);		
			
		}
		
	}
	public void actionProcessNotify(){
		//buddies.lastLoginBuddy
		NateFriend fr = buddies.lastLoginBuddy;
		if(main.getConfutil().getBoolean("DefaultAction")){
			SwitchBoardSession ss =nate.findSwitchboardSessionAt(fr.getNateID());
			ChatWindow cw = buddies.getChatWindow(ss, fr);
			if(cw==null || !cw.getSS().isConnected()){

				cw = new ChatWindow( nate,buddies,ss, fr);
			//	cw.setIconImage(UIToolkit.getFrameIcon(UIToolkit.iconChat));
				buddies.getChatWinList().add(cw);
			}
			else {
				cw.flashing();
			}
		}
		else{ //msg
			SendMessageGUI send = new SendMessageGUI(nate );			
			send.setRecvUser(fr);
			
		}
		
		
	}
	
	
	public void actionAbout(){
		String txt = "JaTeOn " + Main.version;
		JOptionPane.showMessageDialog(main , txt , "정보",JOptionPane.INFORMATION_MESSAGE);
		
	}
/*
	public final static String Online = "O";
	public final static String Away = "A";
	public final static String Busy = "B"; 
	public final static String Phone = "P";
	public final static String Meeting = "M";
	public final static String Invisible = "X";
	public final static String Offline = "F";
	Online", "Away", "Busy", "Phone", "Meeting", "Invisible" };
 */	
	
	public void actionChangeNick(){
		String newName = nate.getOwner().getNickName().replaceAll("%20", " ").replaceAll("%25", "%");
		
		
		//MsgUtil.println(nate.getOwner().getNickName());
		

		try{
			newName = JOptionPane.showInputDialog(main, "변경할 닉네임을 입력하세요",  newName);
		
			//newName = jp.showInputDialog(main, "변경할 닉네임을 입력하세요", "닉네임변경", JOptionPane.QUESTION_MESSAGE);
			
			if(!nate.getOwner().getNickName().replaceAll("%20", " ").replaceAll("%25", "%").equals(newName))
				nate.setMyNickName(newName);
		}
		catch (Exception e) {
			// TODO: handle exception
		}
	}
	
	/**
	 * 라이센스 다이얼로그
	 *
	 */
	public void actionAboutLicense(){
		infoLicense dialog = new infoLicense(main,"License",true);
		
		//dialog.show();	
			
		/*
		if(dialog.is_OK()){

				String loginName = dialog.getLoginName();
				String passwd = dialog.getPasswd();
				dialog.dispose();
				nate.is_encodedpasswd = true;
								
				nate.login(loginName,passwd);	
				return true;
		}
		return false;*/
	}
	
	/**
	 * 사용자 상태 전환
	 */
	public void actionSetStatusOnline(){
		nate.setMyStatus(UserStatus.Online);
	}
	public void actionSetStatusAway(){
		nate.setMyStatus(UserStatus.Away);
	}
	public void actionSetStatusBusy(){
		nate.setMyStatus(UserStatus.Busy);
	}
	public void actionSetStatusPhone(){
		nate.setMyStatus(UserStatus.Phone);
	}
	public void actionSetStatusMeeting(){
		nate.setMyStatus(UserStatus.Meeting);
	}
	public void actionSetStatusInvisible(){
		nate.setMyStatus(UserStatus.Invisible);
	}
	public void actionSetStatusOffline(){
		nate.setMyStatus(UserStatus.Offline);
	}
	
	/**
	 * 오프라인 사용자 보기, 안보기 toggle
	 */
	public void actionToggleOffView()
	{
		buddies.toggleOfflineView();
	}

	/**
	 * 친구목록을 업데이트 해준다
	 */
	public void actionRefreshList(){
		buddies.syncAllUsers();
	}
	
	/**
	 * 가비지 컬렉터 실행
	 */
	public void actionSystemGC(){
		System.gc();
	}
	
	/**
	 *  보기 모드 전환
	 */
	public void actionSetViewMode0(){
		this.actionSetViewMode(0);
	}
	public void actionSetViewMode1(){
		this.actionSetViewMode(1);		
	}
	public void actionSetViewMode2(){
		this.actionSetViewMode(2);
	}
	public void actionSetViewMode3(){
		this.actionSetViewMode(3);
	}
	public void actionSetViewMode4(){
		this.actionSetViewMode(4);
	}
	private void actionSetViewMode(int mode){
		BuddyRenderer render = main.getBuddyTree().getRenderer();
		render.setBuddyView(mode);
		this.actionRefreshList();
	}


	
	public void actionAddFriend(){
		
	if(nate.isLoggedIn())
		{
			//System.out.println("-_-");
			AddFriendDialog buddyAdd = new AddFriendDialog(main,"친구 등록", false);
			buddyAdd.setVisible(true);
		}
	}

	public void actionSetDefaultMsg(){
		//boolean flag = true;
		main.setDblClickDefaultAction(MainFrame.DefaultActionMsg);
	}
	public void actionSetDefaultChat(){
		//boolean flag = false;
		main.setDblClickDefaultAction(MainFrame.DefaultActionChat);
		
	}
	public void actionDetailSetting(){
		OptionDialog optDial = new OptionDialog(main);
		optDial.setVisible(true);
	}
	public void actionDebugInfo(){
		String msg = "TICKET=" + nate.getTicket() + "\nUserID=" + nate.getOwner().getNateID();
		MsgUtil.println(msg);
	}
	public void actionVersionCheck(){
		String url = Main.authServer + "version_" 
		+ ((Main.releaseType.startsWith("Alpha")) ? "alpha" : "beta") 
		+".txt";
		
		HtmlReader reader = new HtmlReader(url,"UTF8");
		
		StringTokenizer token = new StringTokenizer(reader.getHTML(), "\n");
		String line = null;
		
		String item = null;
		String value =null;
		int idx = -1;
		
		String nversoin = null;
		String ndate = null;
		String ncomment = null;
		
		while(token.hasMoreElements()){
			item =null;
			value =null;
			line = token.nextToken();
			if(line.trim().startsWith("#"))
				continue;
			idx = line.indexOf('=');
			if(idx<0) 
				continue;
			item = line.substring(0,idx).trim();
			value = line.substring(idx+1).trim();

			if(item.equals("version"))
				nversoin = value;
			else if(item.equals("date"))
				ndate = value;
			else if(item.equals("comment"))
				ncomment = value;
		}
		String vinfo = "사용중인 버전 : " + Main.ver +
				"\n최신 버전 : " + nversoin + "\n릴리즈 날짜 : " + ndate + 	"\n내용 : " + ncomment;
		JOptionPane.showMessageDialog(main, vinfo, "버전 정보", JOptionPane.INFORMATION_MESSAGE);
	}
        


}