/**
 * 
 */
package kfmes.jateon.swing;

import java.awt.Color;
import java.awt.Image;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Properties;

import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JTree;
import javax.swing.SwingUtilities;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

import kfmes.jateon.swing.dialog.ChatWindow;
import kfmes.jateon.swing.dialog.RecvMessageGUI;
import kfmes.jateon.swing.dialog.SendMessageGUI;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.SwitchBoardSession;
import kfmes.natelib.entity.GroupList;
import kfmes.natelib.entity.NateFile;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.entity.NateGroup;
import kfmes.natelib.entity.UserStatus;
import kfmes.natelib.event.NateListener;
import kfmes.natelib.ftp.FileRecver;
import kfmes.natelib.ftp.FileSender;
import kfmes.natelib.msg.InstanceMessage;
import kfmes.natelib.msg.MimeMessage;


/**
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: BuddyTree.java,v 1.50 2007/11/19 10:13:34 kfmes Exp $
 */
public class BuddyTree extends JTree {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private NateFriend me = null;
	private NateonMessenger nate = null;
	
	protected NateFriend lastLoginBuddy = null;
	
	private MainFrame main = null;
	private Image chatIcon = null;
	private DefaultTreeModel model = null;
	private DefaultMutableTreeNode root = null;
	private MouseAdapter treeMouseAdapter = new BuddyMouseAdapter();
	private BuddyTree thistree = this;
	private ActionGroup action = null;
	
	private BuddyRenderer renderer = new BuddyRenderer();
	private boolean offView = false;
	private Hashtable<String,DefaultMutableTreeNode> groupMap = new Hashtable<String,DefaultMutableTreeNode>();
	//private Hashtable dialogMap = new Hashtable();
	private ArrayList<ChatWindow> chatWinList = new ArrayList<ChatWindow>();
	
	

	public BuddyTree() {
		super();
		this.setBackground(Color.WHITE);
	}
	/*
this.main = m;		
		this.msnm = m.getMessenger();
		msnm.addMsnListener( new Listener() );

		setCellRenderer( renderer );
		addMouseListener( treeMouseAdapter );
		getSelectionModel().setSelectionMode( TreeSelectionModel.SINGLE_TREE_SELECTION );

		chatIcon = new ImageIcon(
			getClass().getResource("/resources/icon/chat.jpg") ).getImage();
	 */
	
	public BuddyTree(MainFrame mainfrm) {
		super();
		this.setBackground(Color.WHITE);
		this.main = mainfrm;
		this.nate = mainfrm.getMessenger();
		nate.addNateListener( (NateListener) new Listener() );
		
		// TODO: -_-++++
		
		/*
		ImageIcon leafIcon =  new ImageIcon("kfmes/jateon/resources/icon/on.gif");
		if (leafIcon != null) {
		    DefaultTreeCellRenderer renderer = 
			new DefaultTreeCellRenderer();
		    renderer.setLeafIcon(leafIcon);
		    setCellRenderer(renderer);
		}
*/
		
		
		
		setCellRenderer(renderer);
		addMouseListener( treeMouseAdapter );
		getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);

		/*
		chatIcon = new ImageIcon(
				getClass().getResource("resources/icon/chat.jpg") ).getImage();
			*/	

		setBuddyView(0);
		
		
	}
	
	public NateFriend getSelectedFriend()
	{
		TreePath path = getSelectionPath();
		if( path==null || path.getPathCount()!=3 )
			return null;

		Object o = path.getLastPathComponent();
		if( o instanceof DefaultMutableTreeNode )
			o = ((DefaultMutableTreeNode)o).getUserObject();

		return (NateFriend)o;
	}
	
	public void toggleOfflineView()
	{
		this.offView = !this.offView;

		//MsgUtil.println("$$$" + nate.isLoggedIn());
		if( nate.isLoggedIn() )
			syncAllUsers();
	}
	public boolean getOffview(){
		return this.offView;	
	}
	public void setOffview(boolean offview){
		this.offView = offview;
	}
	
	public void setBuddyView( int mode )
	{
		renderer.setBuddyView( mode );
		//renderer.setLeafIcon(new ImageIcon(getClass().getClassLoader().getResource("kfmes/jateon/resources/icon/on.gif")));

		if( nate.isLoggedIn() )
			model.reload();
	}
	
	/**
	 * 현재 Tree에서 주어진 friend가 위치한 Node를 찾아 반환한다.
	 * 만약 존재하지 않는다면 null을 반환할 것이다.
	 */
	protected DefaultMutableTreeNode findTreeNode( NateFriend friend )
	{
		for(Enumeration e = root.children();e.hasMoreElements();)
		{
			DefaultMutableTreeNode node = (DefaultMutableTreeNode)e.nextElement();
			for(Enumeration e1 = node.children(); e1.hasMoreElements(); )
			{
				DefaultMutableTreeNode fnode = (DefaultMutableTreeNode)e1.nextElement();
				if( fnode.getUserObject().equals(friend) )
					return fnode;
			}
		}
		return null;
	}

	/**
	 * 친구 리스트를 초기화한다.
	 */
	public void clearTree(){
		if(root==null)
			return ;
		root.removeAllChildren();

		for(Iterator i=groupMap.values().iterator(); i.hasNext(); )
		{
			DefaultMutableTreeNode node = (DefaultMutableTreeNode)i.next();
			node.removeAllChildren();
		}
		groupMap.clear();
		model.reload();		
	}
	
	
	public void syncAllUsers()
	{
		root.removeAllChildren();
				
		
		for(Iterator i=groupMap.values().iterator(); i.hasNext(); )
		{
			DefaultMutableTreeNode node = (DefaultMutableTreeNode)i.next();
			node.removeAllChildren();
		}
		groupMap.clear();

		

		GroupList gl = nate.getBuddyGroup();
		//gl.sort();
		
		
		
		for(int i = 0;i<gl.length();i++){
			NateGroup group = gl.get(i);
			if(group.getVisual() == "N") // 그룹 이름이 아니라 보이기 속성으로 비교 하면 됨 by bronks  :: 정말 그룹 이름이 XXX 면???
				continue;
			
			DefaultMutableTreeNode node = new DefaultMutableTreeNode(group/*.getName()*/);
			
			root.add( node );
			//groupMap.put( i, node );
			// XXX: Warning
			groupMap.put(i+"", node);
			
//			groupMap.put((Object) i, node );
			
		
	

		ArrayList bl = gl.get(i).getList();//.getForwardList();
		//bl.sort(true);
			for(Iterator j=bl.iterator(); j.hasNext(); )
			{
				NateFriend friend = (NateFriend)j.next();
				
				//MsgUtil.println(":::::" + friend.getStatus());
				
				if( !offView && friend.getStatus().equals(UserStatus.Offline))
					continue;
				//DefaultMutableTreeNode node = findGroupNode( friend.getGroupIndex() );
				//DefaultMutableTreeNode fnode = new DefaultMutableTreeNode(friend);
				DefaultMutableTreeNode user = new DefaultMutableTreeNode(friend/*friend.getFormattedBuddy()*/);
				//user = 
				node.add( user);
				}
		}
	
		model.reload();
		
		for(int i=0;i<thistree.getRowCount();i++)
			expandRow(i);
	}
	
	public ArrayList<ChatWindow> getChatWinList() {
		return chatWinList;
	}
	public void setActionGroup(ActionGroup actionGroup){
		this.action = actionGroup;
	}
	
	public BuddyRenderer getRenderer() {
		return renderer;
	}
	public MainFrame getMainFrame(){
		return this.main;
	}
	
	protected ChatWindow getChatWindow(SwitchBoardSession ss, NateFriend friend){
		ChatWindow chat = null;
		boolean find = false;
		for(int i=chatWinList.size()-1;i>=0;i--){
			
			chat = chatWinList.get(i); 

			if(chat.getSS()==ss)
				return chat;
	
			if(!find && chat.getFriend().getID().equals(friend.getID())){
				chat.setChatWindow(nate, thistree, ss, friend);
				return chat;
			}
		}
		return null;
	}
	
	public void updateAllDialogs()
	{
		for(int i=0;i<chatWinList.size();i++)// Enumeration e=chatWinList.e.elements(); e.hasMoreElements(); )
		{
			ChatWindow cw = chatWinList.get(i);
			SwingUtilities.updateComponentTreeUI( cw );
		}
	}	
	
	private class BuddyMouseAdapter extends MouseAdapter
	{
		private JPopupMenu pop;
		
		 public void mouseReleased(MouseEvent e) {
	        //    maybeShowPopup(e);
	     }
		
		public void mousePressed( MouseEvent e )
		{

			TreePath rootPath = null;
			if( ((rootPath=getPathForLocation(e.getX(), e.getY()))!=null) )
			{
				thistree.setSelectionPath(rootPath);
				
				DefaultMutableTreeNode node = 
					(DefaultMutableTreeNode)rootPath.getLastPathComponent();
				if( node==root )
				{
					pop = main.menuBar.getStatusPopupMenu();
					pop.show( BuddyTree.this, e.getX(), e.getY() );
					
					
					return;
				}
			}
			
			else if(e.getButton()==MouseEvent.BUTTON3){
				pop = main.menuBar.getDefaultPopupMenu();
				pop.show( BuddyTree.this, e.getX(), e.getY() );
			}
			
		}
		public void mouseClicked( MouseEvent e )
		{
			
			//MsgUtil.println(e.getSource());
			/*
			if(e.getSource()==thistree && e.getButton()==MouseEvent.BUTTON3){
				defaultPopUp.
				MsgUtil.println("**");
			}*/
			
			
			TreePath rootPath = null;
			DefaultMutableTreeNode o = 
				(DefaultMutableTreeNode) getLastSelectedPathComponent();
			
			

			if( o==null )
				return;
			
			Object uo = o.getUserObject();

			
			if(( rootPath=getPathForLocation(e.getX(), e.getY()))!=null){
				
				
				
				if(e.getButton()==MouseEvent.BUTTON3){
					
					
					pop = new JPopupMenu();
					if( uo instanceof NateFriend && o!=root )
					{
						NateFriend friend = (NateFriend)uo;
						pop.add(new JMenuItem(friend.getNameID()));
						pop.add(new JPopupMenu.Separator());

					}
					
					//pop.add(new JMenuItem(rootPath));
					
					pop = main.menuBar.getStatusPopupMenu(pop);
					pop.show( BuddyTree.this, e.getX(), e.getY() );
				}
			}
			
			

			if( e.getClickCount() > 1 ) 
			{
				
				if( uo instanceof NateFriend && o!=root )
				{
					NateFriend friend = (NateFriend)uo;
					//MsgUtil.println(":D " + friend.getFormattedBuddy());
					
					if(main.getDblClickDefaultAction() ==kfmes.jateon.swing.MainFrame.DefaultActionMsg){
						SendMessageGUI send = new SendMessageGUI(nate);
						send.setRecvUser(friend);
					}
					else
					{
						action.actionReqChat();
					}
						
					
				}
			}
		}
		
	};

	
	
	private class Listener implements NateListener /*extends NateAdapter*/ 
	{	
		
		
		public void renameNotify( NateFriend i )
		{
			// 자기 자신의 이름 변경된 것을 적용한다.
			if( i.getID().equals(me.getID()) )
			{
				//MsgUtil.println("DDD: " + i.toString());
				me.setNickName(i.getNickName());
				SwingUtilities.invokeLater( new Runnable() {
					public void run()
					{
						model.reload( root );
					}
				});
			}
		}
		
		public void buddyListInit(GroupList list) {
			//MsgUtil.println("트리작성");
			//thistree.removeAll();
			
			/*DefaultMutableTreeNode top =
	            new DefaultMutableTreeNode("네이트온 친구목록");*/
			//root = new DefaultMutableTreeNode("네이트온 친구목록");
			//MsgUtil.println(nate.getOwner());
			root = new DefaultMutableTreeNode(nate.getOwner());
			
			
//			DefaultMutableTreeNode owner = new DefaultMutableTreeNode(nate.getOwner());
			//root.add(owner);
			//root.setParent(owner);
			
			
		
			model = new DefaultTreeModel(root);
			//model.reload( root );
			thistree.setModel(model);
			thistree.setRootVisible(false);
			thistree.syncAllUsers();
			

			
			
		}

		/*
		public void loginComplete( final NateFriend owner )
		{
			SwingUtilities.invokeLater( new Runnable() {
				public void run()
				{
					start( owner );
					main.menuBar.enableLogin();
				}
			});
		}
*/
		private void refreshGroupNode()
		{
			for(Enumeration e = root.children();e.hasMoreElements();)
			{
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)e.nextElement();
				model.reload( node );
			}
		}


		/**
		 *
		 */
		public void instanceMessageReceived(InstanceMessage imsg) {
			RecvMessageGUI recvmsg = new RecvMessageGUI(nate,imsg);
			
			MusicBox.play(MusicBox.SOUND_MESSAGE);
		};
		public void switchboardSessionEnded(SwitchBoardSession ss) {
			if(chatWinList.contains(ss))
				chatWinList.remove(ss);
			
		}

		public void switchboardSessionStarted(SwitchBoardSession ss) {
//			NateFriend recv = ss.getNateFriend();
			
			//ChatWindow chat = new ChatWindow( nate,thistree,ss, recv);
					
			//chat.setVisible(false);
			//chatWinList.add(chat);
			
			
			
		}
		
		
		public void loginError(String header) {
			//MsgUtil.println("catch !!");
			JOptionPane jp = new JOptionPane();//"로그인실패",JOptionPane.ERROR_MESSAGE);
			//jp.showMessageDialog(parentComponent, message)
			jp.showMessageDialog(thistree, "로그인에 실패하였습니다.\n아이디와 패스워드를\n제대로 입력했는지 확인하세요", "로그인 실패",JOptionPane.ERROR_MESSAGE);
		}
		
		
		public void chatMessageReceived(SwitchBoardSession ss, NateFriend friend, MimeMessage mime) {
			
			/*ChatWindow chat = new ChatWindow(nate, thistree,ss);
			chat.setVisible(true);
			chatWinMap.put(ss, chat);
			*/
			ChatWindow chat = getChatWindow(ss, friend);
			boolean find = (chat==null) ? false : true;
						
			/*
			for(int i=chatWinList.size()-1;i>=0;i--){
				
				chat = (ChatWindow)chatWinList.get(i); 

				if(chat.getSS()==ss)
					find = true;
		
				if(!find && chat.getFriend().getID().equals(friend.getID())){
					chat.setChatWindow(nate, thistree, ss, friend);
					find = true;
				}
				
				if(find)
				{
					chat.incoming(friend, mime);
					
					if(chat.isVisible()==false) {
						chat.setFocusableWindowState(false);
						chat.setVisible(true);
						chat.setFocusableWindowState(true);
					}
					
					if(chat.isFocused()==false)
						MusicBox.play(MusicBox.SOUND_CHAT);
					
					return;
				}*/
				/*
				if(((ChatWindow)chatWinList.get(i)).getFriendCount()==1 &&
						
						.getSS().getNateFriend(loginName))
				
			}*/
			if(find)
			{
				chat.incoming(friend, mime);
				
				if(chat.isVisible()==false) {
					chat.setFocusableWindowState(false);
					chat.setVisible(true);
					chat.setFocusableWindowState(true);
				}
				
				if(chat.isFocused()==false)
					MusicBox.play(MusicBox.SOUND_CHAT);
				
				return;
			}
			// 여기까지 왔으면 해당 chatwin 을 찾지 못했을경우다
			
			MusicBox.play(MusicBox.SOUND_CHAT);
			NateFriend recv = ss.getNateFriend();		
			//ChatWindow 
			chat = new ChatWindow( nate,thistree,ss, recv);
			//chat.setVisible(true);
			chatWinList.add(chat);
			chat.incoming(friend, mime);
		}
		
		public void userOnline( final NateFriend friend )
		{
			/*
			final String loginName = friend.getNateID();
			final String formatStatus = friend.getFormattedStatus();
			final String formatName = friend.getRealName();
*/
			
/*
			final NotifyArea noti = new NotifyArea(friend.getFormattedBuddy() + "님이 로그인 하셨습니다");
			
			SwingUtilities.invokeLater( new Runnable() {
			public void run() {
				DefaultMutableTreeNode node = findTreeNode(friend);
				noti.run();
						
			
			} 
			});
			*/
			/* removed 0.17
			if(main.useTray && main.getConfutil().getBoolean("useNotify")){
				lastLoginBuddy = friend;
				main.tray.setDisplayMessage("로그인 알림", friend.getFormattedBuddy());				
			}*/
			
			MusicBox.play(MusicBox.SOUND_LOGIN);
			
			//noti.run();
			

			
		}
		

		
		public void buddyListModified()
		{
			//MsgUtil.println("DDD: ");
			SwingUtilities.invokeLater( new Runnable() {
				public void run()
				{
					syncAllUsers();
				}
			});
			//model.reload();
		}

		

		public void allListUpdated()
		{
			SwingUtilities.invokeLater( new Runnable() {
				public void run()
				{
					syncAllUsers();
				}
			});
			//model.reload();
		}
		
		public void killed() {
			//TODO: WORKING
			
			JOptionPane jp = new JOptionPane();
			nate.setMyStatus(UserStatus.Offline);
			jp.showMessageDialog(thistree, "다른곳에서 접속하여 종료되었습니다", "다른곳에서 접속", JOptionPane.WARNING_MESSAGE);
			clearTree();
		//	nate.fireRemoveKilled();
			
			
			
			
		}

		public void addFailed(int errorCode) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void filePosted(SwitchBoardSession ss, String cookie, String filename, int filesize) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void fileSendAccepted(SwitchBoardSession ss, String cookie) {
			// TODO 자동 생성된 메소드 스텁
			
		}



		public void fileSendRejected(SwitchBoardSession ss, String cookie, String reason) {
			// TODO 자동 생성된 메소드 스텁
			
		}



		public void listAdd(NateFriend friend) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void listOnline(NateFriend friend) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void loginComplete() {
		//buddyListModified();			
		}

		public void logoutNotify() {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void notifyUnreadMail(Properties prop, int unread) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void progressTyping(SwitchBoardSession ss, NateFriend friend, int flag) {
			for(int i=chatWinList.size()-1;i>=0;i--)
				if(chatWinList.get(i).getSS()==ss)
				{
					chatWinList.get(i).progressTyping(friend, flag);
					return;
				}
			// 여기까지 왔으면 해당 chatwin 을 찾지 못했을경우다
			
			
		}

		public void switchboardSessionAbandon(SwitchBoardSession ss, String targetName) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void userOffline(NateFriend friend) {
			MusicBox.play(MusicBox.SOUND_LOGOUT);			
			
		}

		public void whoAddedMe(NateFriend friend) {
			
			 Object[] options = {"수락", "거절","취소"};
	         int n = JOptionPane.showOptionDialog(null,
	                         friend.getNateID() + "님이 당신을 친구로 등록했습니다.\n" + friend.getTag(),
	                         "친구 등록 요청",
	                         JOptionPane.YES_NO_CANCEL_OPTION,
	                         JOptionPane.QUESTION_MESSAGE,
	                         null,
	                         options,
	                         options[0]);
	         if (n == JOptionPane.YES_OPTION) {
	        	 friend.setFABR(true, "FA");
	        	 nate.reqAdsb(true, friend);	        	 

	         } else if (n == JOptionPane.NO_OPTION) {
	        	 friend.setFABR(true, "B");
	        	 nate.reqAdsb(false, friend);
	 ;
	         } else {
	        	 
	         }
			
		}

		public void whoJoinSession(SwitchBoardSession ss, NateFriend join) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void whoPartSession(SwitchBoardSession ss, NateFriend part) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void whoRemovedMe(NateFriend friend) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void RemovedKilled() {
			model.reload();
			
		}

		public void OwnerStatusUpdated() {
			main.updateOwnerStatus();
			
		}

		public void buddyModified(NateFriend friend) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void filePosted(SwitchBoardSession session, FileRecver recv, NateFriend ref, ArrayList<NateFile> list) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void fileRecved(FileRecver recver, NateFile natefile) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void fileSend(SwitchBoardSession session, FileSender sender, NateFriend ref, ArrayList<NateFile> list) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void fileSendEnded(FileSender sender, NateFile natefile) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void fileSendError(FileSender sender, Throwable e) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void fileSendStarted(FileSender sender) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void fileTransferAborted(String cookie) {
			// TODO 자동 생성된 메소드 스텁
			
		}
	}


}