/**
 * 
 */
package kfmes.jateon.swing;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import kfmes.natelib.util.MsgUtil;


/**
 * 환경설정 파일들을 다루기 용이하도록 만든 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: ConfUtil.java,v 1.16 2007/11/19 10:13:34 kfmes Exp $
 */
final public class ConfUtil {
	private Map<String, String> conf = new HashMap<String, String>();

	private File file = null;
	
	public ConfUtil() {
		

	}
	
	public ConfUtil(String confFile) {

		
		file = new File(Main.userHome + "/.jateon");
		if(!file.exists())
			file.mkdirs();
	
		
		try{
			file = new File(confFile);
			if(!file.exists())
				file.createNewFile();
			
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * 데이터를 읽어들인다 
	 * 조심할 점은 현재 저장되어있는 정보는 날라간다.
	 * @return
	 */
	public boolean readData(){
	
		try{
			String line;
			String item, value;
		
			
			BufferedReader fr = new BufferedReader(new FileReader(file));
						
			int idx;
			conf.clear();
						
			while(fr.ready()){
				line = fr.readLine();
				
				if(line.trim().startsWith("#"))
					value = "";
				
				idx = line.indexOf('=');
										
				item = line.substring(0,idx).trim();
				value = line.substring(idx+1).trim();
				conf.put(item, value);
				//list.add(new Item(item, value));
			}
			fr.close();
		}catch (Exception e) {
			e.printStackTrace();
			
			return false;
		}
		return true;
	}

	public boolean writeData(){
		
		if(file.canWrite())	{
			try {
				String passwd = getString("passwd");
				FileWriter fw = new FileWriter(file);
				ArrayList<String> list = new ArrayList<String>() ;
				if(!getBoolean("savepasswd"))
					conf.remove("passwd");
				list.addAll(conf.keySet());
				
				Collections.sort(list);
					
				
				
				for(int i=0;i<conf.size();i++){
					//MsgUtil.print(list.get(i) + " = " + conf.get(list.get(i)) + "\n");
					
					fw.write(list.get(i) + " = " + conf.get(list.get(i)) + "\n");
					
				}
				
				fw.close();
				if(!getBoolean("savepasswd"))
					set("passwd", passwd);
				
				
				
			} catch (IOException e) {
				
				e.printStackTrace();
				System.err.println("Can't Write Configuration File!");
				return false;
			}
		}
		else
			return false;
	
		return true;				
	}
	
	public void debugPrint(){
		ArrayList<String> list = new ArrayList<String>() ;
		list.addAll(conf.keySet());
		
		Collections.sort(list);
			
		
		for(int i=0;i<conf.size();i++){
			MsgUtil.print(list.get(i) + " = " + conf.get(list.get(i)) + "\n");
		}
		
	}
	public void set(String name, String value){
		conf.put(name, value);
	}
	public void set(String name, boolean bool) {
		conf.put(name, (bool ? "true" : "false"));	
	}
	/*
	
	public ArrayList getList(){
		return this.list;
	}*/
	public String get(String name){
		return conf.get(name);
		
	}
	public boolean getBoolean(String name){
		String foo = conf.get(name);
		if(foo==null)
			return false;
		
		if(foo.equalsIgnoreCase("yes") || foo.equals("1") || foo.equalsIgnoreCase("true"))
			return true;
		return false;
	}
	
	/**
	 * 해당 name의 값을 읽어온다
	 * 없는경우 null 이 아닌 "" 문자를 리턴한다
	 */
	public String getString(String name){
		String foo = conf.get(name);
		return (foo == null) ? "" : foo;		
	}
	
	public String remove(String name){
		return conf.remove(name);
	}

	public void removeAll() {
		conf.clear();
		
	}


	
/*
	public static void main(String args[]){
		
		ConfUtil c = new ConfUtil(".jateon.config.inc");
		c.readData();
		
		System.out.println(c.get("loginname"));
id@nate.com
		
		c.writeData();
		
	}
	*/
}
