/**
 * 
 */
package kfmes.jateon.swing;


import java.io.File;
import java.net.URLDecoder;

import javax.swing.JOptionPane;

import kfmes.natelib.NateonMessenger;


/**
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: Main.java,v 1.63 2007/11/19 10:13:34 kfmes Exp $
 */
final public class Main {
	NateonMessenger nate = null;
	MainFrame main = null;

	
	//public static final String releaseType = "Alpha Release";
	public static final String releaseType = "Beta Release";
	public static final String ver = "0.19a";
	public static final String version = releaseType + ' ' + ver;
	public static final String stderr = "errlog.txt";
	public static final String userHome = System.getProperty("user.home");
	public static final String osname = System.getProperty("os.name").toLowerCase();
	
	public static final String authServer = "http://kfmes.com/jateonxLog/";
	
	public static boolean isHigherVer(float queryVer){
		return Float.parseFloat( System.getProperty("java.specification.version")) >= queryVer;
	}
	
	public static String  getJateonPath()
	{
		java.net.URL url = kfmes.jateon.swing.Main.class.getResource("");
		String pw = null;
		if(url==null){
			return "";		
		}
		pw = url.toString();
		
		try {
			pw = URLDecoder.decode(pw 	, "UTF8");
		} catch ( java.io.UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		
		//.getPath();// .getFile();// .toString();
		//System.out.println(pw);
		
		if(pw.indexOf("jar")>=0)
			//return pw.substring(5, pw.lastIndexOf("jateon.jar")-2); 
			return pw.substring(9, pw.lastIndexOf('/', pw.lastIndexOf('!') )+1  );
		else
			return pw.substring(5, pw.lastIndexOf("kfmes"));

		
	}
	
	
	/**
	 * @param args
	 */
	public Main() {
		//test!!!

	}
		
	/**
	 * Jateon Messenger 시작점 
	 * @param mode 실행모드
	 */
	public void run(int mode) throws Exception { //defualt mode = 0
		nate = new NateonMessenger();
		
		if(mode==99){ //debug
			NateonMessenger.setDebugMode(true);
		}

		
		main = new MainFrame(nate);
		main.setVisible(true);
	}
	
	public static void main(String[] args) {
		
		
		try{
			String argsline = "";
			int runmode = 0 ;
			
			for(int i=0;i<args.length;i++)
				argsline += args[i] + " ";
			
			argsline = argsline.trim();
			
			Main jateonMessenger = new Main();
			
			
			if(args.length>0){
				if(argsline.indexOf("--debu9")>-1)
					runmode = 99;
				else if(argsline.indexOf("--sysvar")>-1)
				{
					System.getProperties().list( System.out );
					System.exit(0);
				}
				else if(argsline.indexOf("--clean")>-1){
					File conffile = new File(System.getProperty("user.home") + "/.jateon/" + MainFrame.conffile);
					if(conffile.exists()&&conffile.delete()){
						System.out.println("JaTeOn configuration file is removed!");
						
						
					}
					System.exit(0);
				}
							
			}
			
			jateonMessenger.run(runmode);
		}catch (Exception e) {
			String ee = "\n" +
					"Error - Can't run this program.\n" +
					"Check Your System\n" + 
					"JRE(Java Runtime Environment) version 1.4 or higher.\n" +
					"GUI interface (Linux X-Window, M$-Windows, etc...)\n" + 
					"For bug reporting instructions, please see:\n" +
					"<URL:http://jateon.kfmes.com>.";
			
			JOptionPane.showMessageDialog(null, e.toString() + ee);
			
			e.printStackTrace();
			
			System.err.println(ee);
			
		}		

	}

}