package kfmes.jateon.swing;

import java.awt.BorderLayout;
import java.awt.Window;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.JTree;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.WindowConstants;

import kfmes.jateon.swing.MusicBox;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.event.NateAdapter;

/**
 * GUI의 MainFrame
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: MainFrame.java,v 1.45 2007/11/19 10:13:34 kfmes Exp $
 */
public class MainFrame extends JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = -906350566580719147L;
	protected MenuBar menuBar;
	private JMenu MenuFile;
	private JTree fList;
	private JScrollPane scrollTree;
	protected JToolBar toolbar;
	protected JPanel topPan;
	private BuddyTree buddy=null;
	private NateonMessenger nate = null;
	private ActionGroup action = null;
	private JLabel ownerStatus = null;
	protected OwnerRenderer ownerR = null;
	private ConfUtil confutil = null;
	public static final String conffile = "jateon.config.inc";
	protected String currentLookAndFeel = null;
	private int dblClickDefaultAction = 0;
	protected JateonTray tray = null;
	protected boolean useTray = false;
	
	protected boolean isTraySuppoted = true;
	
	//protected boolean isTraySupport = kfmes.jateon.swing.Main.isHigherVer((float) 1.6);
	
	protected final static int DefaultActionMsg = 0;
	protected final static int DefaultActionChat = 1;
		
	public static Hashtable<String,Window> dialogMap = new Hashtable<String,Window>();
	
	protected static int dialogCnt = 0;
			
	public static void main(String[] args) throws Exception {
		new MainFrame(new NateonMessenger()).setVisible(true);
	}
	
	public MainFrame(NateonMessenger nate) throws Exception	{
		super("JaTeOn - " + Main.version /*Alpha Release"*/);

		this.nate = nate;
		
		
		confutil = new ConfUtil(System.getProperty("user.home") + "/.jateon/" + conffile);
	
		this.loadConf();
		
		
		try{
			
			if(currentLookAndFeel==null)
				currentLookAndFeel = UIManager.getCrossPlatformLookAndFeelClassName();
			else{
				try {
					UIManager.setLookAndFeel(currentLookAndFeel);
				} catch (Exception e) {
					e.printStackTrace();
					currentLookAndFeel = UIManager.getCrossPlatformLookAndFeelClassName();
				}
				//mainfrm.updateUIAll();
			}
		}catch (Exception e) {
			JOptionPane.showMessageDialog(this,e.toString());			
		}
		


		
		//System.out.println(currentLookAndFeel);


		setIconImage( UIToolkit.getFrameIcon() );
		
		if( !UIToolkit.setLocationByPlatform(this, true) ) {
			System.err.println("Warning : Method \"setLocationByPlatform\" can't use!");
		}
		
		ownerR = new OwnerRenderer();
		ownerR.setOwnerRenderer(this);

		initGUI();
		UIToolkit.setAlwaysOnTop(this, confutil.getBoolean("useAlwaysOnTop"));

		MusicBox.init();
		initTray();
		
		//run();

		// 아래 코드는 윈도우가 만들어진 후 수행되도록 하자
		String var = confutil.get("autologin");
		if(var!=null && var.equalsIgnoreCase("yes")){
			autoLogin();
		}

	}
	
	/**
	 * 설정을 다시 읽는다
	 *
	 */
	public void loadConf(){
		
		confutil.readData();
		String tmp = confutil.get("DefaultAction");
		if(tmp!=null && tmp.equals("1"))
			this.dblClickDefaultAction = DefaultActionChat;
		tmp = confutil.getString("useSound");

		MusicBox.setEnabled( !tmp.equals("noSound"));
		
		currentLookAndFeel = confutil.get("LookAndFeel");
		if(tray!=null)
			initTray();
		
		

	}
	
	
	private void initTray(){
		
		/*
		String t = confutil.get("useTray");
		if(t==null) 
			useTray = false;
		else
			useTray = confutil.getBoolean("useTray");
		MusicBox.useSound = !confutil.getBoolean("noSound");
		
		{		// 트레이가 사용가능하다면 트레이 활성화

			
			if(useTray ){
				if(tray==null)
					tray = new JateonTray(this);
				else
					tray.initTray();
					
					
				if(tray.isTraySuppoted==false){
					tray = null;
					useTray = false;
					isTraySuppoted  = false;
				}
			}
			else if(tray!=null && useTray==false){
				tray.removeTray();
			}
		}*/
	}
	

	public NateonMessenger getMessenger(){
		return this.nate;
	}
	public BuddyTree getBuddyTree(){
		return this.buddy;
	}
	public ConfUtil getConfutil() {
		return confutil;
	}
	
	public String getFrameInfo(){
		return this.getLocation().x + " " + this.getLocation().y + " " +  this.getSize().getWidth() + " " + this.getSize().getHeight();
		
	}
	public boolean getUseTray(){
		return this.useTray;
	}
	protected ActionGroup getActionGroup() {
		return action;		
	}
	
	public int getDblClickDefaultAction() {
		return this.dblClickDefaultAction;
	}
	public void setDblClickDefaultAction(int sel){
		this.dblClickDefaultAction = sel;
		menuBar.setDblClickDefaultAction();
	}

	private void initGUI() throws Exception {
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		getContentPane().setLayout(new BorderLayout());
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				rootWindowClosing(evt);
			}
		});
		
		ownerStatus = ownerR.getLabel();
		
		topPan = new JPanel();
		topPan.setLayout(new BorderLayout());
		topPan.add(ownerStatus, BorderLayout.WEST);
		
		//topPan.add(new JLabel("로그인 되지 않음"));

		getContentPane().add(topPan, BorderLayout.NORTH);
		
		JPanel jp = new JPanel();
		BorderLayout jpLayout = new BorderLayout();
		jp.setLayout(jpLayout);

		getContentPane().add(jp);
		{
			scrollTree = new JScrollPane();
			jp.add(scrollTree, BorderLayout.CENTER);
			{
				buddy = new BuddyTree(this);
				
				String val ;
				val = confutil.get("offview");
				if(val!=null){
					buddy.setOffview((val.equalsIgnoreCase("yes")) ? true: false);
				}
				
				int mode = BuddyRenderer.VIEW_NICK;
				
				val = confutil.get("viewmode");
				if(val!=null){
					mode = Integer.parseInt(val);
				}
				
				buddy.setBuddyView(mode);
				
				//scrollTree.add(buddy);
				//fList = new JTree();
				scrollTree.setViewportView(buddy);
			}
		}
		action = new ActionGroup(this,buddy);
		buddy.setActionGroup(action);
		
		menuBar = new MenuBar(this,action);
		setJMenuBar(menuBar);

		nate.addNateListener(new NateAdapter() {
			public void loginComplete()
			{
				menuBar.setOnline(true);
			}
			public void killed()
			{
				menuBar.setOnline(false);
			}
		});

		toolbar = menuBar.getDefaultToolBar();

		menuBar.setOnline(false);
		
		/*
		toolbar = new JToolBar();
		toolbar.add(new JButton("쪽지"));
		toolbar.add(new JButton("대화"));
		toolbar.add(new JButton("문자"));
		*/
		getContentPane().add( toolbar, BorderLayout.SOUTH);
		toolbar.setEnabled(false);
		
		String location = confutil.get("FrameLocation");
		if(location!=null){
			String strnum[] = location.split(" ");
			int pos[] = new int[4];
			pos[0] = Integer.parseInt(strnum[0]);
			pos[1] = Integer.parseInt(strnum[1]);
			pos[2] = (int)Float.parseFloat(strnum[2]);
			pos[3] = (int)Float.parseFloat(strnum[3]);
			
			this.setLocation(pos[0],pos[1]);
			this.setSize(pos[2],pos[3]);

		} else {
			this.setSize(350, 480);
		}
		
		

	}
	

	private void autoLogin(){
		
		try{
				
			String loginName=null, passwd=null;
			
			String val;		
			val = confutil.get("loginName");
			if(val!=null)
				loginName = val;
			
			val = confutil.get("passwd");
			if(val!=null)
				passwd = val;
				
			nate.is_encodedpasswd = true;
			
			action.actionProcessLogin(loginName);//  .LoginProc(loginName);
			nate.login(loginName,passwd);	
			
			nate.fireBuddyListInit(nate.getBuddyGroup());
		
		}catch (Exception e) {
			e.printStackTrace();
			return ;
		}
	}
	
	private void rootWindowClosing(WindowEvent evt) {
		
		if(tray!=null)
			this.setVisible(false);
		else		
		{
			
			try{
				action.actionLogout();
			}catch (NullPointerException e) {
					// NullPointer
			}
			catch (Exception e) {
				e.printStackTrace();
			}finally{
				System.exit(0);
			}
		}//end if
		
	}
	public void updateOwnerStatus(){
		ownerStatus = ownerR.getLabel();
		ownerStatus.repaint();
	}
	/*
    public void updateLookAndFeel() {
    	try {
    		//UIManager.LookAndFeelInfo info = menuBar.lafInfo[i];
    		
    	    UIManager.setLookAndFeel(menuBar.getCurrentLookAndFeel());
    	    SwingUtilities.updateComponentTreeUI(this);
    	    
    	    
    	} catch (Exception ex) {
    	    System.err.println("Failed loading L&F: " +  menuBar.getCurrentLookAndFeel());
    	    System.err.println(ex);
    	}
    }*/

	public static void newDialog(Window dialog){
		dialogMap.put(dialogCnt + "", dialog);
		
		//System.out.println("new " + dialogCnt + "/" + dialog);
		dialogCnt++;
	}
	public static void removeDialog(Window dialog){
		dialogMap.remove(dialog);
		dialogCnt--;
		//System.out.println("remove " + dialogCnt + "/" + dialog);
		
	}
	
	public void updateUIAll()
	{
		SwingUtilities.updateComponentTreeUI( this );
		buddy.updateAllDialogs();
		
		for(Enumeration e=dialogMap.elements(); e.hasMoreElements(); )
		{
			Window cd = (Window)e.nextElement();
			SwingUtilities.updateComponentTreeUI( cd );
		}
		
	}
	

}
