package kfmes.jateon.swing;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.reflect.Method;

import javax.swing.AbstractAction;
import javax.swing.ActionMap;
import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JToolBar;

import kfmes.natelib.NateonMessenger;
/**
 * 
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: MenuBar.java,v 1.36 2007/11/19 10:13:34 kfmes Exp $
 */
public class MenuBar extends JMenuBar  implements ActionListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 5797371384855355806L;
	private MainFrame mainfrm = null;
	private JMenuItem mLogin;
	private JMenuItem mLogout;
	private JMenuItem mSysGC;
	private JMenuItem mQuit;
	private JMenuItem mMyStatus = null;
	private JMenuItem mMyNick = null;
	private JMenuItem mStatus[] = null;
	private JCheckBoxMenuItem mOffview;
	
	private JRadioButtonMenuItem mSetDefaultMsg = null;
	private JRadioButtonMenuItem mSetDefaultChat = null;
	private JButton btnMsg, btnChat, btnSMS, btnAddBuddy;
	
//	protected JMenu mSetLookAndFeel = null;
	
	private JMenuItem mLicense;
	private JMenuItem mAbout;
	private JMenuItem mClearLoginInfo;
	private JMenuItem mDetailSetting;
	
	//private String currentLookAndFeel = null;

	
	public MenuBar(MainFrame mainfrm,ActionGroup actions) {
		this.mainfrm = mainfrm;
		init(actions);
	}

	/**
	 * 로그인/로그아웃 상태가 바뀌었을 때 변경되야 할 UI 처리를 해준다.
	 */
	public void setOnline( boolean isLogin )
	{
		mLogin.setEnabled(!isLogin);
		mLogout.setEnabled(isLogin);
		mMyNick.setEnabled(isLogin);

		mMyStatus.setEnabled(isLogin);
		for(JMenuItem item : mStatus)
			item.setEnabled(isLogin);

		btnMsg.setEnabled(isLogin);
		btnChat.setEnabled(isLogin);
		btnSMS.setEnabled(isLogin);
		btnAddBuddy.setEnabled(isLogin);
	}
	
	public JMenu createMenuAction(){
		ActionMap action = getActionMap();
		JMenu menu = new JMenu("동작(A)");
		menu.setMnemonic( 'A' );
		mLogin = new JMenuItem("로그인");
		mLogout = new JMenuItem("로그아웃");
		mClearLoginInfo = new JMenuItem("설정 지우기");
		mSysGC = new JMenuItem("쓰레기수집");
		
		
		mQuit = new JMenuItem("나가기");
		mLogin.addActionListener( action.get("actionLogin") );
		mLogout.addActionListener( action.get("actionLogout") );
		mClearLoginInfo.addActionListener(action.get("actionClearLoginInfo"));		
		mSysGC.addActionListener( action.get("actionSystemGC") );
		
		
		mQuit.addActionListener( action.get("actionQuit") );
		
		
		//menu.addSeparator();
		//menu.add(new JSeparator());
		menu.add(mLogin);
		menu.add(mLogout);
		
		//
		menu.addSeparator();
		if(NateonMessenger.isDebugMode){
			
			JMenuItem mDbgInfo = new JMenuItem("디버깅정보");
			mDbgInfo.addActionListener(action.get("actionDebugInfo"));
			menu.add(mDbgInfo);
			menu.add(mSysGC);
		}
		menu.add(mClearLoginInfo);
		menu.addSeparator();
		//menu.add(new JSeparator());

		
		//menu.add(new JSeparator());
		
		
		menu.add(mQuit);
		
		
		return menu;
	}
	
	private JMenu createMenuHelp() {
		ActionMap action = getActionMap();
		JMenu menu = new JMenu("도움말(H)");
		menu.setMnemonic( 'H' );
		mLicense = new JMenuItem("라이센스");
		mAbout = new JMenuItem("정보");
		
		//mLicense.addActionListener( action.get("actionLogin") );
		mAbout.addActionListener( action.get("actionAbout") );
		mLicense.addActionListener( action.get("actionAboutLicense") );
		
		JMenuItem mVersionChk = new JMenuItem("최신버전확인");
		mVersionChk.addActionListener(action.get("actionVersionCheck"));

		menu.add(mLicense);
		menu.add(mVersionChk);
		menu.add(mAbout);
				
		return menu;
	}


	public void setDblClickDefaultAction(){

		boolean flag = (mainfrm.getDblClickDefaultAction()==MainFrame.DefaultActionMsg) ? true : false;
//		boolean flag = (sel==MainFrame.DefaultActionMsg)? true: false;
		
		mSetDefaultMsg.setSelected( flag ? true: false);
		mSetDefaultChat.setSelected( flag ? false: true);

	}
	
	private JMenu createMenuSetting() {
		
		//JMenuItem mSetLookAndFeel = null;
		
		ActionMap action = getActionMap();
		JMenu menu = new JMenu("설정(S)");
		menu.setMnemonic( 'S' );
		
		//mSetLookAndFeel = new JMenuItem("룩앤필 설정");
		mMyStatus = new JMenuItem("내 상태");
		mMyNick = new JMenuItem("대화명 설정");
		
		/*
		JMenu mSetLookAndFeel = new JMenu("룩앤필 설정");
		
		
		final UIManager.LookAndFeelInfo lafInfo[] = UIManager.getInstalledLookAndFeels();
		final JMenuItem mLookAndFeelItem[] = new JMenuItem[lafInfo.length] ;
		
		
		for(int i=0;i<lafInfo.length;i++){
			final UIManager.LookAndFeelInfo info = lafInfo[i];
	
			mLookAndFeelItem[i] = new JMenuItem(lafInfo[i].getName());
			mSetLookAndFeel.add(mLookAndFeelItem[i]);
			
			mLookAndFeelItem[i].addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					try{
						//System.out.println(info.getClassName());
						mainfrm.currentLookAndFeel = info.getClassName();
						UIManager.setLookAndFeel(info.getClassName());
						UIToolkit.currentLookAndFeel = info.getClassName();
						
						mainfrm.updateUIAll();
					}catch (Exception ex) {
						ex.printStackTrace();
					}
				}				
			});
		}
		
		
		JMenu mSetDefaultAction = new JMenu("더블 클릭시");
		mSetDefaultMsg = new JRadioButtonMenuItem("쪽지 보내기");
		mSetDefaultChat = new JRadioButtonMenuItem("대화창 열기");
		*/
		mDetailSetting = new JMenuItem("상세 설정");
		
		//mSetDefaultMsg.addActionListener(action.get("actionSetDefaultMsg"));
		//mSetDefaultChat.addActionListener(action.get("actionSetDefaultChat"));
		mDetailSetting.addActionListener(action.get("actionDetailSetting"));
		/*
		mSetDefaultAction.add(mSetDefaultMsg);
		mSetDefaultAction.add(mSetDefaultChat);
		
		setDblClickDefaultAction();				
		*/
		
		
		//mMyStatus.addActionListener( action.get("actionMyStatus") );
		mMyNick.addActionListener( action.get("actionChangeNick") );
		

		//XXX:환경설정 판때기에서 설정지원
		//menu.add(mSetLookAndFeel);
		//menu.add(mSetDefaultAction);
		//menu.addSeparator();
		menu.add(mMyNick);
		menu.add(createMenuStatusSet());
		menu.addSeparator();
		menu.add(mDetailSetting);
		
		
		return menu;
	}
	
	private JMenu createMenuStatusSet() {
		
		mStatus = new JMenuItem[6];
		String statusString[] = { "Online", "Away", "Busy", "Phone", "Meeting", "Invisible","Offline" };
					
		ActionMap action = getActionMap();
		JMenu menu = new JMenu("내 상태");
		
		mStatus[0] = new JMenuItem("온라인");
		mStatus[1] = new JMenuItem("자리비움");
		mStatus[2] = new JMenuItem("다른용무중");
		mStatus[3] = new JMenuItem("통화중");
		mStatus[4] = new JMenuItem("회의중");
		mStatus[5] = new JMenuItem("오프라인으로 표시");
		
		
		NateonMessenger nate = mainfrm.getMessenger();
		for(int i=0;i<6;i++){
			
			mStatus[i].addActionListener(action.get("actionSetStatus" + statusString[i]));
			menu.add(mStatus[i]);			 
		}
		
		return menu;				
	}


	/**
	 * 
	 * @param actions
	 */
	public void init(ActionGroup actions){
		
		collectActions(actions);
		
		setPreferredSize(new java.awt.Dimension(392, 26));
		{	
			//JMenu MenuFile = new JMenu();
			add(createMenuAction());
			add(createMenuSetting());
			add(createMenuHelp());
					
		}
	}
	
	protected void collectActions( final ActionGroup actions )
	{
		ActionMap action = getActionMap();
		
		Method[] ms = actions.getClass().getMethods();
		for(int i=0; i<ms.length; i++)
		{
			final Method m = ms[i];
			String name = m.getName();
			if( name.startsWith("action") )
			{
				action.put( name, new AbstractAction() {
					/**
					 * 
					 */
					private static final long serialVersionUID = -1723154616121741765L;

					public void actionPerformed( ActionEvent e )
					{
						try 
						{
							if( m.getParameterTypes().length==0 )
								m.invoke(actions, new Object[] {});
							else
								m.invoke( actions, new Object[] {e} );
						}
						catch( Exception ex ) {
							ex.printStackTrace();
						}
					}
				});
			}
		}
	}
	
	
	
	public JPopupMenu getStatusPopupMenu(JPopupMenu defaultPopUp) {
		// TODO 친구목록에서 팝업시
		
		//setComponentPopupMenu(this, defaultPopUp);
		//defaultPopUp.setPreferredSize(new java.awt.Dimension(88, 102));
		{
			ActionMap action = getActionMap();
			JMenuItem mSendIMsg =new JMenuItem("쪽지보내기");
			JMenuItem mReqChat =new JMenuItem("대화걸기");
			JMenuItem mSendSMS = new JMenuItem("문자보내기");
			//JMenuItem mAddFriend = new JMenuItem("친구등록");
			
			mSendIMsg.addActionListener( action.get("actionSendIMsg") );
			mReqChat.addActionListener( action.get("actionReqChat") );
			mSendSMS.addActionListener(action.get("actionSendSMS"));
			
			//mAddFriend.addActionListener(action.get("actionAddFriend"));
			
			defaultPopUp.add(mSendIMsg);
			defaultPopUp.add(mReqChat);
			defaultPopUp.add(mSendSMS);
			
		}
		return defaultPopUp;
	}
	
	public JPopupMenu getStatusPopupMenu() {
		// TODO 친구목록에서 팝업시
		JPopupMenu defaultPopUp = new JPopupMenu();

		
		return getStatusPopupMenu(defaultPopUp);
	}

	public JPopupMenu getDefaultPopupMenu(){
		JPopupMenu defaultPopUp = new JPopupMenu();
		//setComponentPopupMenu(this, defaultPopUp);
		//defaultPopUp.setPreferredSize(new java.awt.Dimension(88, 102));
		{
			ActionMap action = getActionMap();
			/*
	public static final int VIEW_NAME = 0;
	
	public static final int VIEW_NICK= 1;
	public static final int VIEW_ID = 2;
	
	public static final int VIEW_NAME_ID = 3;
	public static final int VIEW_NAME_NICK = 4;
			 */
			
			JRadioButtonMenuItem mViewMode[] = new JRadioButtonMenuItem[5];
			
			mViewMode[0] = new JRadioButtonMenuItem("이름으로 보기");
			mViewMode[1] = new JRadioButtonMenuItem("대화명으로 보기");
			mViewMode[2] = new JRadioButtonMenuItem("아이디로 보기");
			mViewMode[3] = new JRadioButtonMenuItem("이름+아이디로 보기");
			mViewMode[4] = new JRadioButtonMenuItem("이름+대화명으로 보기");
			
			mViewMode[mainfrm.getBuddyTree().getRenderer().getBuddyView()].setSelected(true);
			
			
			
			//mView_Nick.setSelected(true);

			mOffview = new JCheckBoxMenuItem("오프라인 사용자 표시");
			mOffview.addActionListener( action.get("actionToggleOffView") );
			mOffview.setSelected(mainfrm.getBuddyTree().getOffview());
			
			for(int i=0;i<5;i++){
				defaultPopUp.add(mViewMode[i]);
				mViewMode[i].addActionListener(action.get("actionSetViewMode" + i));
			}			
			
			//defaultPopUp.add(new JSeparator());
			defaultPopUp.addSeparator();
			
			
			defaultPopUp.add(mOffview);
			JMenuItem mRefreshList =new JMenuItem("목록 새로고침"); 
			defaultPopUp.add(mRefreshList);
			mRefreshList.addActionListener(action.get("actionRefreshList"));
			
		}
		return defaultPopUp;
	}
	
	/**
	 * 메인프레임에 붙는 툴바를 얻어오는 method
	 * @return
	 */
	public JToolBar getDefaultToolBar(){
		
		ActionMap action = getActionMap();
		JToolBar toolbar ;
		toolbar = new JToolBar();
		

		btnMsg = new JButton("쪽지");
		btnChat = new JButton("대화");
		btnSMS = new JButton("문자");
		btnAddBuddy = new JButton("친구추가");
		
		
		
		btnMsg.addActionListener(action.get("actionSendIMsg"));
		btnChat.addActionListener(action.get("actionReqChat"));
		btnSMS.addActionListener(action.get("actionSendSMS"));
		btnAddBuddy.addActionListener(action.get("actionAddFriend"));
		
		toolbar.add(btnMsg);
		toolbar.add(btnChat);
		toolbar.add(btnSMS);
		toolbar.add(btnAddBuddy);
		

		return toolbar;
	}
	
	
	public void enableLogin() {
		// TODO 자동 생성된 메소드 스텁
		
	}

	public void actionPerformed(ActionEvent e) {
		
		JMenuItem o = (JMenuItem) e.getSource();
		
		
			//MsgUtil.println(e);
		
		
	}
	




	

}
