package kfmes.jateon.swing;

import java.lang.reflect.Method;
import java.awt.Image;
import java.awt.Window;

import javax.swing.ImageIcon;
/**
 * User Interface toolkit class.
 * 
 * @author Jang-Ho Hwang, rath@xrath.com
 * @version 1.0, $Id: UIToolkit.java,v 1.16 2007/07/23 12:12:34 kfmes Exp $ since 2007/02/11
 */
public class UIToolkit {

	//icon lists
	public static final String iconChat = "chat.gif";
	public static final String iconSMS = "sms.gif";
	public static final String iconMain = "jateon.png";
	public static final String iconMsg = "msg.gif";
	public static final String iconSetting = "setting.gif";
	public static final String iconTray = "tray.gif";
	
	public static final String resPath= kfmes.jateon.swing.Main.getJateonPath() //+ File.separator 
	+ "resources/";
	
	//resPath = Main.getJateonPath() //+ File.separator 
	// Possible Look & Feels
    public static final String mac      =
            "com.sun.java.swing.plaf.mac.MacLookAndFeel";
    public static final String metal    =
            "javax.swing.plaf.metal.MetalLookAndFeel";
    public static final String motif    =
            "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
    public static final String windows  =
            "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
    public static final String gtk  =
            "com.sun.java.swing.plaf.gtk.GTKLookAndFeel";
	
        
    // The current Look & Feel
    public static String currentLookAndFeel = metal;
    
    public static String getCurrentLookAndFeel(){
    	return currentLookAndFeel;    	
    }

    public static Image getFrameIcon(){
    	return new ImageIcon( resPath + "icon/" + iconMain) .getImage();
    	//return new ImageIcon(	UIToolkit.class.getResource("resources/icon/" + iconMain) ).getImage();    	
    }
    public static Image getFrameIcon(String icon){
    	return new ImageIcon( resPath + "icon/" + icon) .getImage();
    	//return new ImageIcon(	UIToolkit.class.getResource("resources/icon/" + icon )).getImage();    	
    }
    public static ImageIcon getTrayIcon(){
    	return new ImageIcon(	resPath + "icon/" + iconTray );
    	//return new ImageIcon(	UIToolkit.class.getResource("resources/icon/" + iconTray ));    	
    }
	public static ImageIcon getImage(String string) {
		return new ImageIcon(resPath + string);
	}
	
    /*
    public static Image getDialogIcon(Class cls){
    	return new ImageIcon(	cls.getResource("../resources/icon/jateon.gif") ).getImage();    	
    }*/
	
	/**
	 * Process the Window.setLocationByPlatform method with jre 1.4 compatibility.
	 */
	public static boolean setLocationByPlatform( Window window, boolean locationByPlatform ) {
		Method m = null;
		try {
			m = window.getClass().getMethod("setLocationByPlatform", new Class[] { Boolean.TYPE });
			m.invoke(window, new Object[] { Boolean.TRUE } );
		}
		catch( NoSuchMethodError e ) {
			return false;
		}
		catch( NoSuchMethodException e ) {
			return false;
		}
		catch( Exception e ) {
		}
		return true;
	}
	
	/**
	 * Process the Window.setLocationByPlatform method with jre 1.4 compatibility.
	 */
	public static boolean setAlwaysOnTop( Window window, boolean alwaysOnTop ) {
		Method m = null;
		try {
			m = window.getClass().getMethod("setAlwaysOnTop", new Class[] { Boolean.TYPE });
			if(alwaysOnTop)
				m.invoke(window, new Object[] { Boolean.TRUE } );
			else 
				m.invoke(window, new Object[] { Boolean.FALSE } );
		}
		catch( NoSuchMethodError e ) {
			return false;
		}
		catch( NoSuchMethodException e ) {
			return false;
		}
		catch( Exception e ) {
		}
		return true;
	}


}