package kfmes.jateon.swing.dialog;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

import kfmes.jateon.swing.BuddyTree;
import kfmes.jateon.swing.UIToolkit;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.SwitchBoardSession;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.msg.MimeMessage;
import kfmes.natelib.util.DateUtil;
import kfmes.natelib.util.MsgUtil;


/**
 * 
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: ChatWindow.java,v 1.38 2007/11/19 10:13:33 kfmes Exp $
 */
public class ChatWindow extends JFrame{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private NateonMessenger nate = null;
	private BuddyTree parentTree = null ; 
	private SwitchBoardSession ss = null;
	private NateFriend recvUser = null; 
	
	
	private JPanel topPanel;
	private JTextArea chatLog;
	private JScrollPane scrollPane;
	private JTextField smsg;
	private JLabel recvUsrLvl ;

	private JLabel typing;
	private JFrame thisfrm = null;
	
	private boolean isTyping = false;

	public static void main(String[] args) {
		JFrame frame = new JFrame();
		ChatWindow inst = new ChatWindow(frame);
		inst.setVisible(true);
	}
	
	public ChatWindow(JFrame frame) {
//		super(frame);
		initGUI();
	}
	
	public ChatWindow(NateonMessenger nate, BuddyTree parenttree, SwitchBoardSession ss, NateFriend fr) {
		super("대화하기");
		
		setChatWindow(nate, parenttree, ss, fr);
		initGUI();
		//this.setFocusableWindowState(false);
		
		setVisible(true);
		//this.setFocusableWindowState(true);
		
		//
		smsg.requestFocus();
	}
	
	public void setChatWindow(NateonMessenger nate, BuddyTree parenttree, SwitchBoardSession ss, NateFriend fr) {
		this.nate = nate;
		this.parentTree = parenttree;
		this.ss= ss;
		this.recvUser = fr;
		
		//makeSwtichBoardSession();
		

		
	}

	private void initGUI() {
		try {
			UIToolkit.setLocationByPlatform(this, true);
			this.setIconImage(UIToolkit.getFrameIcon(UIToolkit.iconChat));
			this.thisfrm = this;
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);		
			this.addWindowListener(new WindowAdapter() {
			
				public void windowClosing(WindowEvent e) {
					try{
						//ss.sendMessage("QUIT");
						//System.out.println("FDD");
						if( ss!=null )
						{
							ss.close();
							ss = null;
						}
					}
					catch (Exception ex) {
						ex.printStackTrace();
					}
					//super.windowClosing(e);
					//BuddyTree parentTree = (BuddyTree) parent;
					
					
					
				}
				public void windowClosed(WindowEvent evt) {

					
					parentTree.getChatWinList().remove(thisfrm);
					//super.windowClosed(evt);
				}
			});
			
			
			getContentPane().setLayout(new BorderLayout());
			
			JPanel topPanel = new JPanel();
			String display_recvUser ;
			if(recvUser!=null)
				display_recvUser = recvUser.getNameID();
			else 
				display_recvUser = "";
			
			recvUsrLvl = new JLabel("대화상대 : " + display_recvUser);
			typing = new JLabel("   ");
			
			topPanel.add(recvUsrLvl);
			topPanel.add(typing);
			
			
			topPanel.setLayout(new FlowLayout());
			
			
			
				
			getContentPane().add(topPanel, BorderLayout.NORTH);
			
			scrollPane = new JScrollPane();
			chatLog = new JTextArea();
			chatLog.setLineWrap(true);
			chatLog.setEditable(false);

			
			scrollPane.setViewportView(chatLog);
			getContentPane().add(scrollPane);
			
			smsg = new JTextField();
			scrollPane.setAutoscrolls(true);
			
			chatLog.append("대화 시작 ".concat(DateUtil.toTextString()));
			// 대화창 열리면서 상대와 채팅연결
			
			
			//chatLog.setAutoscrolls(true);
			smsg.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					
					MsgUtil.println("SS status : " + ss + " / " + ((ss!=null) ? ss.isConnected() : ""));
					if(ss==null || !ss.isConnected())
						ss = nate.getNS().procOpenChat(nate.getOwner().getID() , recvUser.getNateID());
					
					if(smsg.getText().length()==0)
						return;
					
					try{
						if(ss==null){
							ss = nate.getNS().procOpenChat(nate.getOwner().getID() , recvUser.getNateID());
							Thread.sleep(200);
						}
						

						boolean success = ss.sendMessage(smsg.getText());
						
						if(!success){
							for(int i =0 ;i< 2; i++){
								Thread.sleep(200);
								success = ss.sendMessage(smsg.getText());
								if(success) 
									break;								
							}
						}
						
					}catch (Exception e) {
						// TODO: handle exception
					}
					
					
					chatLog.append("\n" + nate.getOwner().getNameNick() + " says : \n  " + smsg.getText());
					
					isTyping = false ;
					chatLog.setSelectionStart(chatLog.getText().length());
					chatLog.setSelectionEnd(chatLog.getText().length());
					smsg.setText("");
				}
			});
			smsg.addKeyListener(new KeyListener(){

				public void keyPressed(KeyEvent e) {
					
					
				}

				public void keyReleased(KeyEvent e) {
					if((isTyping && smsg.getCaretPosition()==0) /*|| e.getKeyChar()==KeyEvent.VK_ENTER*/){
						isTyping = false;
						ss.progressTyping(0);
					}
					else if(isTyping==false && smsg.getCaretPosition()>0){
						isTyping = true;
			
						if(ss==null || !ss.isConnected())
							ss = nate.getNS().procOpenChat(nate.getOwner().getID() , recvUser.getNateID());
						
						if(ss.isConnected())
							ss.progressTyping(1);
					}
					
				}

				public void keyTyped(KeyEvent e) {
					
				
				}
				
			});
			
			getContentPane().add(smsg,BorderLayout.SOUTH);
	
			
			
			this.setSize(410, 314);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		
	}

	public SwitchBoardSession getSS() {
		return ss;
	}
	public int getFriendCount(){
		return ss.getFriendCount();
	}
	public NateFriend getFriend(){
//		MsgUtil.println(recvUser.getFormattedBuddy());
		return this.recvUser;
	}

	public void incoming(NateFriend friend, MimeMessage mime) {
		String from = friend.getNameNick(); 
		String msg = null;
		//TODO DEBUG
		//MsgUtil.println(mime.getMessage());
		typing.setText("   ");
		
		if(mime.getType().equals("QUIT")){//상대방이 창을 닫았다!!
			chatLog.append("\n" + from + " 대화방 나감");
			this.ss.close();
			this.ss  = null;
		}
		else{
			
			String display_recvUser ;
			if(friend!=null)
				display_recvUser = friend.getNameID();
			else 
				display_recvUser = "";
			
			if(recvUser!=friend)
				recvUser = friend;
			
			recvUsrLvl.setText("대화상대 : " + display_recvUser);
		
			msg = mime.getMessage().replaceAll("%20", " ").replaceAll("%25", "%").replaceAll("%0A", "\n");
			chatLog.append("\n" + from + " says : \n  " + msg);
		}
		chatLog.setSelectionStart(chatLog.getText().length());
		chatLog.setSelectionEnd(chatLog.getText().length());
		
		flashing();  
		//this.setFocusableWindowState(true);
		
	}
	
	public void flashing(){  
		//MsgUtil.println("Flashing");
		if(this.isFocused()==false && parentTree.getMainFrame().getConfutil().getBoolean("useFlashing")){
			
			this.setExtendedState(JFrame.NORMAL);
			this.toFront();
		}
	}
	
	public void setSS(SwitchBoardSession ss) {
		this.ss = ss;
	}

	public void progressTyping(NateFriend friend, int flag) {
		if(flag==0)
			typing.setText("   ");
		else{
			recvUsrLvl.setText("대화상대 : " + friend.getNameID());
			typing.setText("...");
		}
		
	}
}
