/**
 * 
 */
package kfmes.jateon.swing.dialog;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;

/**
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: ChatWindow2.java,v 1.7 2007/11/19 10:13:32 kfmes Exp $
 */
public class ChatWindow2 extends JFrame {

	private static final long serialVersionUID = 1L;
	private Listener listener = new Listener();  //  @jve:decl-index=0:
	private JPanel jContentPane = null;
	private JPanel top_panel = null;
	private JScrollPane jsp_ChatLog = null;
	private JEditorPane txt_chatlog = null;
	private JScrollPane jsp_MsgInput = null;
	private JTextArea txt_input = null;
	private JPopupMenu jpop_menu = null;
	private JMenuItem jMenuItem = null;
	private JPanel bottom_panel = null;
	private JButton btn_send = null;
	private JLabel lbl_progessType = null;
	private JLabel lbl_recvUsr = null;
	private JLabel lbl_MenuPop = null;
	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getTop_panel(), BorderLayout.NORTH);
			jContentPane.add(getJsp_ChatLog(), BorderLayout.CENTER);
			jContentPane.add(getBottom_panel(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes top_panel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getTop_panel() {
		if (top_panel == null) {
			lbl_MenuPop = new JLabel();
			lbl_MenuPop.setText("메뉴");
			lbl_MenuPop.addMouseListener(listener);
			lbl_recvUsr = new JLabel();
			lbl_recvUsr.setText("JLabel");
			lbl_progessType = new JLabel();
			lbl_progessType.setText("JLabel");
			top_panel = new JPanel();
			top_panel.setLayout(new BoxLayout(getTop_panel(), BoxLayout.X_AXIS));
			top_panel.add(lbl_MenuPop, null);
			top_panel.add(lbl_progessType, null);
			top_panel.add(lbl_recvUsr, null);
		}
		return top_panel;
	}

	/**
	 * This method initializes jsp_ChatLog	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJsp_ChatLog() {
		if (jsp_ChatLog == null) {
			jsp_ChatLog = new JScrollPane();
			jsp_ChatLog.setViewportView(getTxt_chatlog());
			jsp_ChatLog.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jsp_ChatLog.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jsp_ChatLog.addComponentListener(new java.awt.event.ComponentAdapter() {
				public void componentResized(java.awt.event.ComponentEvent e) {
					System.out.println("componentResized()"); // TODO Auto-generated Event stub componentResized()
					txt_chatlog.setSize(txt_chatlog.getMaximumSize());
				}
			});
			
			
		}
		return jsp_ChatLog;
	}

	/**
	 * This method initializes txt_chatlog	
	 * 	
	 * @return javax.swing.JEditorPane	
	 */
	private JEditorPane getTxt_chatlog() {
		if (txt_chatlog == null) {
			txt_chatlog = new JEditorPane();
			
		}
		return txt_chatlog;
	}

	/**
	 * This method initializes jsp_MsgInput	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJsp_MsgInput() {
		if (jsp_MsgInput == null) {
			jsp_MsgInput = new JScrollPane();
			jsp_MsgInput.setViewportView(getTxt_input());
		}
		return jsp_MsgInput;
	}

	/**
	 * This method initializes txt_input	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getTxt_input() {
		if (txt_input == null) {
			txt_input = new JTextArea();
			txt_input.setRows(2);
			txt_input.setLineWrap(true);
		}
		return txt_input;
	}

	/**
	 * This method initializes jpop_menu	
	 * 	
	 * @return javax.swing.JPopupMenu	
	 */
	private JPopupMenu getJpop_menu() {
		if (jpop_menu == null) {
			jpop_menu = new JPopupMenu();
			jpop_menu.add(getJMenuItem());
		}
		return jpop_menu;
	}

	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getJMenuItem() {
		if (jMenuItem == null) {
			jMenuItem = new JMenuItem("fff");
		}
		return jMenuItem;
	}

	/**
	 * This method initializes bottom_panel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBottom_panel() {
		if (bottom_panel == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridheight = 3;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.weighty = 1.0;
			gridBagConstraints.weightx = 1.0;
			bottom_panel = new JPanel();
			bottom_panel.setLayout(new GridBagLayout());
			bottom_panel.add(getJsp_MsgInput(), gridBagConstraints);
			bottom_panel.add(getBtn_send(), gridBagConstraints1);
		}
		return bottom_panel;
	}

	/**
	 * This method initializes btn_send	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtn_send() {
		if (btn_send == null) {
			btn_send = new JButton();
			btn_send.setText("Send");
		}
		return btn_send;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO 자동 생성된 메소드 스텁
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				ChatWindow2 thisClass = new ChatWindow2();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public ChatWindow2() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 234);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
		jpop_menu = getJpop_menu();
	}
	
	private class Listener implements ActionListener, MouseListener{
		public void actionPerformed(ActionEvent e) {
			String cmd = e.getActionCommand();
			//if(cmd.equals("menu"))
				
			
		}

		public void mouseClicked(MouseEvent e) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void mouseEntered(MouseEvent e) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void mouseExited(MouseEvent e) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void mousePressed(MouseEvent e) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void mouseReleased(MouseEvent e) {
			System.out.println("X : " + e.getX/*OnScreen*/() + "  Y:" + e.getY/*OnScreen*/());
			jpop_menu.setLocation(
					e.getX/*OnScreen*/() ,
					e.getY/*OnScreen*/());
			jpop_menu.setInvoker(jpop_menu);
			jpop_menu.setVisible(true);
			
		}
		
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
