/**
 * 
 */
package kfmes.jateon.swing.dialog;


import java.awt.Dimension;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.*;
import javax.swing.*;

import kfmes.jateon.swing.ConfUtil;
import kfmes.jateon.swing.MainFrame;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.util.PasswordEncryptor;



/**
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: LoginDialog.java,v 1.27 2007/11/19 10:13:33 kfmes Exp $
 */
public class LoginDialog extends AbstractDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel jp = null;
	private String loginName = "";
	private String passwd = "";
	private boolean savepasswd = false;
	private LoginDialog thisdlg = this;
	private ConfUtil conf = null;
	private boolean autologin = false;
	
	private boolean isReady = false;
	private boolean isloadedpass = false;

	private JTextField jid ;
	private JPasswordField jpw; 
	private JButton commit;
	private JButton cancel;
	private JCheckBox jc= null;
	private JCheckBox jcauto = null; 
	private JCheckBox jcOfflogin =null;
	

	/*
	 * (Frame owner,
               String title,
               boolean modal)
               
	 */
	public LoginDialog(MainFrame owner, String title, boolean modal) {
		
		super(owner,title,modal);
		conf = owner.getConfutil();
		readConf();

		
		init();
	
		
	}

	
	private void init() {
		
		jp = new JPanel();
		
		jp.setLayout(null);
		JLabel lbl_id = new JLabel(" 아이디 ");
		
		lbl_id.setBounds(14, 8, 50, 14);
		
		jp.add(lbl_id);
		jid = new JTextField(20);
		jid.setBounds(75, 5, 180, 20);
		jid.setText(loginName);
		
		
		this.isReady = false;
		
		jpw = new JPasswordField(20);
		jpw.setBounds(75, 28, 180, 21);
		if(isloadedpass)
			jpw.setText("foobarmelong");
		jc = new JCheckBox("패스워드 저장");
		jcauto = new JCheckBox("자동 로그인");
		jc.setSelected(savepasswd);
		jcauto.setSelected(autologin);

		jc.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if( jc.isSelected()==false && jcauto.isSelected())
					jcauto.setSelected(false);
			}
		});

		jcauto.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				//if( jcauto.isSelected()==false && jc.isSelected())
					//jc.setSelected(false);
				if(jcauto.isSelected() && jc.isSelected()==false)
					jc.setSelected(true);
			}
		});		
		
		jp.add(jid);
		jid.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				jpw.requestFocus();
			}
		});
		JLabel lbl_pass = new JLabel("패스워드");
		lbl_pass.setBounds(10, 31, 52, 14);
		jp.add(lbl_pass);
		jp.add(jpw);

		
		JPanel chk = new JPanel(null);
		
		chk.add(jc);
		chk.add(jcauto);
		jc.setBounds(0, 0, 110, 21);
		jcauto.setBounds(0, 21, 110, 21);
		
		
		jcOfflogin = new JCheckBox("몰래 로그인");
		jcOfflogin.setBounds(0, 42, 110, 21);
		chk.add(jcOfflogin);
		
		

		chk.setBounds(14, 56, 112, 77);
		

		jp.add(chk);
		
		
		commit = new JButton("확인");
		cancel = new JButton("취소");
		
		ActionListener actionCommit = new ActionListener() {
			public void actionPerformed( ActionEvent e )
			{
				commit();
			}
		};

		jpw.addActionListener(actionCommit);
		jpw.addFocusListener(new FocusListener(){
			public void focusGained(FocusEvent e) {
				jpw.setSelectionStart(0);
				jpw.setSelectionEnd(jpw.getPassword().length);				
			}
			public void focusLost(FocusEvent e) {}
			
		});
		
		commit.addActionListener(actionCommit);
		cancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				isReady = false;
				dispose();				
			}
			
		});
		//commit.setSize(arg0, arg1)

		commit.setBounds(130, 60, 60, 50);
		cancel.setBounds(190, 60, 60, 50);
		
		jp.add(commit);
		jp.add(cancel);

		//setBounds(int x, int y, int width, int height) 
		
		{
			Toolkit t = Toolkit.getDefaultToolkit();
			Dimension d =	t.getScreenSize();
			
			this.setLocation((int)(d.getWidth()-280)/2, (int)(d.getHeight()-130)/2);
			
		}
		
		getContentPane().add(jp);
		jp.setBounds(0, 0, 301, 147);
		this.setSize(280,150);
		this.setResizable(false);
		
		Point p = getOwner().getLocation();
		Dimension d = getOwner().getSize();

		this.setLocation( 
			p.x + (d.width - getWidth()) / 2,
			p.y + (d.height - getHeight()) / 2);
		this.setSize(new java.awt.Dimension(280, 154));

		JPanel panel = (JPanel)getContentPane();
		ActionMap actionMap = panel.getActionMap();
		InputMap inputMap = panel.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW);

		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "cancelLogin");
		actionMap.put("cancelLogin", new AbstractAction() {
			public void actionPerformed( ActionEvent e )
			{
				isReady = false;
				dispose();
			}
		});

		addComponentListener( new ComponentAdapter() {
			public void componentShown( ComponentEvent e )
			{
				jid.requestFocus();
			}
		});
	}

	public String getLoginName() {
		return loginName;
	}
	public String getPasswd() {
		return passwd;
	}
	
	/**
	 * 설정값을 저장한다.
	 *
	 */
	private void commit(){
		loginName = jid.getText();
		String tmp = new String(jpw.getPassword());
		
		if(loginName.length()==0){
			JOptionPane.showMessageDialog(this, "로그인 메일 주소를 넣지 않았습니다", "정보", JOptionPane.WARNING_MESSAGE);
			jid.requestFocus();
			return ;
		}
		int atpos = loginName.indexOf("@");
		if(atpos<1){
			JOptionPane.showMessageDialog(this, "아이디는 메일 주소 형식입니다", "정보", JOptionPane.WARNING_MESSAGE);
			jid.requestFocus();
			return ;
		}
		
		if(tmp.length()==0)
		{
			JOptionPane.showMessageDialog(this, "패스워드를 넣지 않았습니다", "정보", JOptionPane.WARNING_MESSAGE);
			jpw.requestFocus();
			return ;
		}
		
		
		if(!tmp.equals("foobarmelong") ) { //&& isloadedpass){
			//passwd = PasswordEncryptor.encrypt(new String(jpw.getPassword()));
			passwd = new String( jpw.getPassword()) ;
			if(loginName.endsWith("@nate.com"));
			
			passwd = PasswordEncryptor.getMD5String(	passwd
					+ ((loginName.endsWith("@nate.com")) ? 
							PasswordEncryptor.getID( loginName) : loginName) );
		
		}
		
		this.savepasswd = this.jc.isSelected();
		this.autologin = this.jcauto.isSelected();
		NateonMessenger.setOffLogin(this.jcOfflogin.isSelected());
		
				
		writeConf();
		
		isReady = true;
		thisdlg.setVisible(false);

	}

		
	private void writeConf() {
		conf.set("savepasswd", (savepasswd) ? "yes" : "no" );
		conf.set("autologin", (autologin) ? "yes" : "no" );
		conf.set("loginName", this.loginName);
		//if(savepasswd)
			conf.set("passwd",passwd);
		//else
//			conf.set("passwd", "");
		
		conf.writeData();
			
	}
	
	private void readConf(){
		String val;
		
		val = conf.get("savepasswd");
		
		if(val!=null)
			savepasswd = (val.equals("yes")) ? true : false;
		
		val = conf.get("autologin");
		
		if(val!=null)
			autologin = (val.equals("yes")) ? true : false;

		
		val = conf.get("loginName");
		
		if(val!=null)
			this.loginName = val;
		if(savepasswd){
			val = conf.get("passwd");
			if(val!=null){
				this.passwd = val;
				this.isloadedpass = true;
			}
		}
		else{
			this.passwd = "";
		}
		
	}
	

	public boolean isOK() {
		
		return isReady;
	}


}
