package kfmes.jateon.swing.dialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

import kfmes.jateon.swing.ConfUtil;
import kfmes.jateon.swing.MainFrame;
import kfmes.jateon.swing.UIToolkit;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.msg.NateSMS;
import kfmes.natelib.util.MsgUtil;

/**
 * 
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: NateSMSGUI.java,v 1.20 2007/11/19 10:13:32 kfmes Exp $
 */
public class NateSMSGUI extends JFrame implements ActionListener{
	private JPanel sms_area;
	private JTextArea txt_smsmsg;
	private JLabel lbl_freeCnt;
	private JPanel jPanel1;
	private JTextField txt_senderNum;
	private JLabel lbl_senderNum;
	private JPanel sms_preview;
	private JButton btn_sendsms;
	private JLabel lbl_recvnum;
	private JButton btn_address;
	//private JTextField txt_recvnum;
	private JPanel sms_recv;
	private JLabel lbl_msgpreview;
	private JLabel lbl_inputSMSMsg;
	private JTextArea txt_preview;
	private JButton btn_preview;
	private JLabel lbl_disp_smsbytes;
	private int freeCnt=-1;
	private int freePlusCnt = -1;
	private NateSMS smsEngine = null;
	private MainFrame frmmain = null;
	private NateonMessenger nate =null;
	private NateSMSGUI thisfrm = null;
	private ConfUtil conf = null;
	
	private String recvNum = "";
	private String sendNum = "";
	private String sendSMS = "";
	private String ticket = null;
	private String uid = null;
	private JComboBox cmb_recvnum;
	private JScrollPane sp_preview;
	private JScrollPane sp_smsmsg;
	private ArrayList<String> recvList = new ArrayList<String>();
	//private String recvList[] = null;
	

	public static void main(String[] args) {
		NateSMSGUI inst = new NateSMSGUI(null, null);
		inst.setVisible(true);
	}
	
	public NateSMSGUI(NateonMessenger nate, MainFrame frmmain) {
		super("문자 보내기");
		this.nate = nate;
		this.frmmain = frmmain;
		this.thisfrm = this;
		NateFriend recvFriend = null;
		this.ticket = nate.getTicket();
		this.setIconImage(UIToolkit.getFrameIcon(UIToolkit.iconSMS));
		
		this.uid = nate.getOwner().getNateID();
		sendNum = nate.getOwner().getPhoneNumber();
		this.conf = frmmain.getConfutil();
		
		if(sendNum==null||sendNum.equals("%00")) sendNum = "";
		
		try{
			recvFriend = frmmain.getBuddyTree().getSelectedFriend();
			if(recvFriend!=null)
				recvNum = recvFriend.getPhoneNumber();
			if(recvNum==null||recvNum.equals("%00")) recvNum = "";
						
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
		{
			String list = conf.get("smsRecent");
			if(list!=null){
				String recvList[] = list.split("/");
				for(int i=0;i<recvList.length;i++){
					if(!(recvList[i].equals("") || recvList[i].equals(recvNum)))
						this.recvList.add(recvList[i]);
				}
			}
			recvList.add(0, recvNum);
			
		}
		
		
		initGUI();
		this.setVisible(true);
		//this.setIconImage(UIToolkit.getDialogIcon(this.getClass()));
		kfmes.jateon.swing.MainFrame.newDialog(this);
		start();
		
		
	}
	private void start(){
		
		smsEngine = new NateSMS(this.ticket, this.uid);
		updateUI();
		
		
	}
	private void updateUI(){
		this.freeCnt = smsEngine.getFreeCnt();
		this.freePlusCnt = smsEngine.getFreePlusCnt();
		//this.txt_recvnum.setText(this.recvNum);
		//this.cmb_recvnum.set
		MsgUtil.println("FreeCnt : " + freeCnt + "\nFreePlusCnt : " + freePlusCnt);
		
		this.freeCnt = (freePlusCnt<=0) ? freeCnt : freeCnt + freePlusCnt;
		
		this.txt_senderNum.setText(this.sendNum);
		lbl_freeCnt.setText("남은 문자 : " + freeCnt + "건");
	}
	
	
	private void initGUI() {
		try {
			this.setResizable(false);
			UIToolkit.setLocationByPlatform(this, true);
			
			this.addWindowListener(new WindowAdapter(){
				public void windowClosing(WindowEvent we) {
					
					StringBuffer sb = new StringBuffer();
										
					for(int i=0;i<recvList.size();i++){
						if(!recvList.get(i).equals(""))
							sb.append(recvList.get(i) + "/");
					}
										
					if(sb.length()>2){
						conf.set("smsRecent", sb.substring(0, sb.length()-1));
						conf.writeData();
					}
					
					kfmes.jateon.swing.MainFrame.removeDialog(thisfrm);
				}
			});
			
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			getContentPane().setLayout(null);
			
				sms_area = new JPanel();
				getContentPane().add(sms_area);
				sms_area.setLayout(null);
				sms_area.setBounds(7, 7, 147, 175);
				sms_area.setLayout(null);
				sms_area.setBorder(BorderFactory.createTitledBorder(""));

				lbl_disp_smsbytes = new JLabel();
				sms_area.add(lbl_disp_smsbytes);
				lbl_disp_smsbytes.setText("0 bytes");
				lbl_disp_smsbytes.setBounds(42, 154, 77, 21);
			
				lbl_inputSMSMsg = new JLabel();
				sms_area.add(lbl_inputSMSMsg);
				lbl_inputSMSMsg.setText("보낼 내용");
				lbl_inputSMSMsg.setBounds(14, 0, 112, 21);
			
				sp_smsmsg = new JScrollPane();
				sms_area.add(sp_smsmsg);
				sp_smsmsg.setBounds(7, 21, 133, 133);
				
				
				txt_smsmsg = new JTextArea();
				sp_smsmsg.setViewportView(txt_smsmsg);
				txt_smsmsg.setBounds(7, 21, 133, 133);
				txt_smsmsg.setLineWrap(true);
				//txt_smsmsg.setBorder(BorderFactory.createTitledBorder(""));
				txt_smsmsg.addKeyListener(new KeyListener() {
					public void keyTyped(KeyEvent evt) {

						//System.out.println("txt_smsmsg.keyTyped, event="	+ evt);

						//TODO add your code for txt_smsmsg.keyTyped
					}

					public void keyPressed(KeyEvent evt) {

					}

					public void keyReleased(KeyEvent evt) {
						// TODO 자동 생성된 메소드 스텁
						if (evt.getKeyCode() == KeyEvent.VK_TAB) {
							txt_smsmsg.setText(txt_smsmsg.getText()
								.replaceAll("\t", ""));
							//txt_recvnum.requestFocus();
							cmb_recvnum.requestFocus();
						}
						
						try {
							lbl_disp_smsbytes.setText(txt_smsmsg.getText()
								.getBytes("MS949").length
								+ " bytes");
						} catch (UnsupportedEncodingException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}

					}
				});
				
				

				btn_preview = new JButton();
				getContentPane().add(btn_preview);
				btn_preview.setText("미리보기");
				btn_preview.setBounds(168, 196, 133, 28);
				btn_preview.addActionListener(this);
			
				sms_preview = new JPanel();
				getContentPane().add(sms_preview);
				sms_preview.setBounds(161, 7, 147, 175);
				sms_preview.setLayout(null);
				sms_preview.setBorder(BorderFactory.createTitledBorder(""));
				
				
				txt_preview = new JTextArea();
				//JScrollPane jsp = new JScrollPane();
				//jsp.setViewportView(txt_preview);
				//sms_preview.add(jsp);
				//sms_preview.add(txt_preview);
				
				sp_preview = new JScrollPane();
				sms_preview.add(sp_preview);
				sp_preview.setBounds(7, 21, 133, 133);
				sp_preview.setViewportView(txt_preview);
				
				txt_preview.setText("미리보기\n 버튼을\n  누르세요");
				txt_preview.setEditable(false);
				//txt_preview.setBorder(BorderFactory.createTitledBorder(""));
				txt_preview.setBounds(7, 21, 133, 133);
			
				lbl_msgpreview = new JLabel();
				sms_preview.add(lbl_msgpreview);
				lbl_msgpreview.setText("미리보기");
				lbl_msgpreview.setBounds(14, 0, 126, 21);
				
				
			

				btn_sendsms = new JButton();
				getContentPane().add(btn_sendsms);
				btn_sendsms.setText("문자 보내기");
				btn_sendsms.setBounds(168, 231, 133, 28);
				btn_sendsms.addActionListener(this);
			
				sms_recv = new JPanel();
				getContentPane().add(sms_recv);
				sms_recv.setLayout(null);
				sms_recv.setBounds(7, 189, 147, 126);
				sms_recv.setBorder(BorderFactory.createTitledBorder(""));
				
					//txt_recvnum = new JTextField();
					//sms_recv.add(txt_recvnum);
					//txt_recvnum.setBounds(7, 49, 133, 21);
				
					lbl_recvnum = new JLabel();
					sms_recv.add(lbl_recvnum);
					lbl_recvnum.setText("받는이 번호");
					lbl_recvnum.setBounds(7, 7, 84, 14);
				
					btn_address = new JButton();
					sms_recv.add(btn_address);
					btn_address.setText("주소록");
					btn_address.setBounds(7, 98, 133, 21);
					btn_address.addActionListener(this);
					
					btn_address.setVisible(false);//TODO: 주소록구현 
				
					lbl_senderNum = new JLabel();
					sms_recv.add(lbl_senderNum);
					lbl_senderNum.setText("보내는 번호");
					lbl_senderNum.setBounds(7, 56, 77, 14);
				
					txt_senderNum = new JTextField();
					sms_recv.add(txt_senderNum);
					txt_senderNum.setBounds(7, 70, 133, 21);

					//ComboBoxModel cmb_recvnumModel = new J(
	//							new String[] { "Item One", "Item Two" });
					cmb_recvnum = new JComboBox();//
					updateRecentCombo();
					//recvList.toArray());
					//cmb_recvnum = new JComboBox(new String[]{recvNum, "foo","bar"});
					
					sms_recv.add(cmb_recvnum);
					cmb_recvnum.setBounds(7, 28, 133, 21);
					//cmb_recvnum.setFocusable(false);
					cmb_recvnum.setEditable(true);


				jPanel1 = new JPanel();
				getContentPane().add(jPanel1);
				jPanel1.setLayout(null);
				jPanel1.setBounds(161, 266, 147, 49);
				
				lbl_freeCnt = new JLabel();
				jPanel1.add(lbl_freeCnt);
				lbl_freeCnt.setText("남은 문자 : " + freeCnt + "건");
				lbl_freeCnt.setBounds(21, 14, 119, 21);
				
				btn_sendsms.setEnabled(false);
			
			//pack();
			this.setSize(323, 349);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void DisplayPreview(){
		
		txt_preview.setText("");
		
		String src = txt_smsmsg.getText();
		StringBuffer sb = new StringBuffer();
		int col=0;
		int bytes ;
		int totalbytes = 0;
		
		try {
			for(int i=0;i<src.length();i++){
				
				bytes = src.substring(i, i+1).getBytes("MS949").length;
				
				
				if( col+ bytes  >16 ){
					txt_preview.append("\n");
					col =0;
				}
				if(src.charAt(i)=='\n'){
					col = 0;
					bytes=0;
		
				}
				
				txt_preview.append(src.charAt(i) + "");
				sb.append(src.charAt(i));
				col+=bytes;
				totalbytes+=bytes;
				
				//if(sb.getChars(arg0, arg1, arg2, arg3)  txt_preview.getText().getBytes("MS949").length>80)
				if(totalbytes>=80)
					break;
			}
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		this.sendSMS = sb.toString();
		if(chkSMSValid()){ 
			
			
			this.btn_sendsms.setEnabled(true);
		}
		
	}
	
	private void updateRecentCombo(){
		recvList.remove(recvNum);
		
		//recvList.remove(idx);
		recvList.add(0, recvNum);

		for(int i=recvList.size()-1;i>9;i--)
			recvList.remove(i);

		
		cmb_recvnum.removeAllItems();
		
		for(int i=0;i<recvList.size();i++)
			cmb_recvnum.addItem(recvList.get(i));
		cmb_recvnum.setSelectedIndex(0);
	}
	
	private boolean chkSMSValid(){

		this.recvNum = ((String)cmb_recvnum.getSelectedItem()).replaceAll("-", "");;// txt_recvnum.getText().replaceAll("-", "");
		this.sendNum = txt_senderNum.getText().replaceAll("-", "");
		
		if(this.txt_smsmsg.getText().length()<=0){
			JOptionPane.showMessageDialog(this, "보낼 내용을 입력하세요"
					, "에러", JOptionPane.ERROR_MESSAGE);
			txt_smsmsg.requestFocus();
			return false;
		}
		
		
		if(!isValidNum(recvNum)){
			JOptionPane.showMessageDialog(this, "받는이 번호 형식 오류"
					, "에러", JOptionPane.ERROR_MESSAGE);
			//txt_recvnum.requestFocus();
			cmb_recvnum.requestFocus();
			return false;
			}
		
		
		if(!isValidSendNum(sendNum)){
			JOptionPane.showMessageDialog(this, "보내는 번호 형식 오류"
					, "에러", JOptionPane.ERROR_MESSAGE);
			txt_senderNum.requestFocus();
			return false;
		}
		if(freeCnt<=0){
			JOptionPane.showMessageDialog(this, "남은 문자 없음"
					, "에러", JOptionPane.ERROR_MESSAGE);
			return false;
		}
		return true;
			
	}
	

	
	private boolean isValidSendNum(String num){ 
		if(num.length()<1 )
			return false;
		/*
		if(!num.startsWith("01"))
			return false;*/
		for(int i=0;i<num.length();i++)
			if(!Character.isDigit(num.charAt(i)))
				return false;		
		
		return true;		
	}
	
	private boolean isValidNum(String num){ 
		if(num.length()>11 || num.length()<10)
			return false;
		if(!num.startsWith("01"))
			return false;
		for(int i=0;i<num.length();i++)
			if(!Character.isDigit(num.charAt(i)))
				return false;		
		
		return true;		
	}
	
	private void sendSMS(){
		boolean retval = false;
		retval = smsEngine.sendSMS(this.sendSMS, recvNum, sendNum);
		String msg= "문자 전송 실패";
		// 최근 문자 목록 업데이트 
		
		if(retval){//전송 성공
			this.freeCnt --;
			this.btn_sendsms.setEnabled(false);
			
			msg = "문자 전송 접수완료";
		}
		JOptionPane.showMessageDialog(this, msg,
				"결과", (retval) ?  JOptionPane.INFORMATION_MESSAGE:JOptionPane.ERROR_MESSAGE);
		updateRecentCombo();
		updateUI();
		txt_smsmsg.setText("");
		
	}

	public void actionPerformed(ActionEvent evt) {
		String src= evt.getActionCommand();
		if(src.equals("미리보기")) {// 미리보기처리
			DisplayPreview();
		}
		else if(src.equals("문자 보내기")){
			if(chkSMSValid()){}
				sendSMS();
				
		}
		else if(src.equals("주소록")){
			JOptionPane.showMessageDialog(this, "아직 구현 되지 않았습니다" +
					"\nfreeCnt : " + freeCnt + "\nfplusCnt : " + freePlusCnt);
		}
	

	}

}
