/**
 * 
 */
package kfmes.jateon.swing.dialog;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagLayout;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.UIManager.LookAndFeelInfo;

import kfmes.jateon.swing.ConfUtil;
import kfmes.jateon.swing.MainFrame;
import kfmes.jateon.swing.UIToolkit;

/**
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: OptionDialog.java,v 1.14 2007/11/19 10:13:32 kfmes Exp $
 */
public class OptionDialog extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7006315411609879134L;
	private MainFrame frmmain = null;
	private EvtHandler evthand = new EvtHandler();  //  @jve:decl-index=0:
	private OptionDialog thisdlg = null;
	
	private JPanel jContentPane = null;
	private JTabbedPane jTabbedPane = null;
	private JPanel buttonArea = null;
	private JPanel optFunction = null;
	private JButton btnOK = null;
	private JButton btnCancel = null;
	private JPanel optVisual = null;
	private JPanel optSound = null;
	private JCheckBox chk_useTray = null;
	private JCheckBox chk_useFlashing = null;
	private JCheckBox chk_useNotify = null;
	private JLabel lbl_fun_dblclik_title = null;
	private JRadioButton opt_dblclk_msg = null;
	private JRadioButton opt_dblclk_chat = null;
	private ConfUtil conf = null;  //  @jve:decl-index=0:
	/*
	private JRadioButton opt_snd_default = null;
	private JRadioButton opt_snd_nosnd = null;
	private JRadioButton opt_
	*/
	
	private ButtonGroup btngrp_opt_dblclk = null;
	private ButtonGroup btngrp_opt_lookandfeel = null;  //  @jve:decl-index=0:
	private ButtonGroup btngrp_opt_sound = null;
	
	private JRadioButton mLookAndFeelItem[] = null;
	private JLabel lbl_visual_title = null;
	private JPanel opt_visual_lookNfeelpan = null;
	private JCheckBox chk_use_viewontop = null;
	private JLabel lbl_fun_autoaway = null;
	private JTextField txt_fun_autoAway = null;
	private JLabel lbl_fun_autoawaymin = null;
	private JPanel opt_Message = null;
	private JPanel opt_File = null;

	private JRadioButton opt_snd_default = null;
	private JRadioButton opt_snd_nosnd = null;
	private JRadioButton opt_snd_custom = null;
	
	/**
	 * This method initializes 
	 * 
	 */
	public OptionDialog(MainFrame frmmain) {
		super();
		this.frmmain = frmmain;
		this.thisdlg = this;
		initialize();
		loadConf();
		this.setModal(true);
		
	}

	/*
	 * 기능 
v 트레이 사용
v 플래싱 사용
v 접속알림 사용
o 더블 클릭시


사운드 
v 소리 없음
v 기본 사운드
v User Setting

룩앤필


파일전송
v 자동으로 수락
   저장위치

	 */
	
	/**
	 * 설정값을 읽어온다.
	 */
	private void loadConf() {
		conf = frmmain.getConfutil();
		conf.readData();
		String foo;
		
		//chk_useTray.setSelected(conf.getBoolean("useTray"));
		chk_useTray.setSelected(frmmain.getUseTray());
		if(System.getProperty("os.name").startsWith("Mac")){
			chk_useTray.setSelected(false);
			chk_useTray.setEnabled(false);
		}
			
			
			//Mac OS
		
		chk_useFlashing.setSelected(conf.getBoolean("useFlashing"));
		chk_useNotify.setSelected(conf.getBoolean("useNotify"));
		chk_use_viewontop.setSelected(conf.getBoolean("useAlwaysOnTop"));
		if(chk_use_viewontop.isSelected())
			UIToolkit.setAlwaysOnTop(frmmain, false);
		
		foo = conf.get("useAutoAway"); 		if(foo==null) foo = "0";
		txt_fun_autoAway.setText(foo);
		
		foo = conf.get("DefaultAction");			if(foo==null) foo = "0";
		if(foo.equals("0"))
			opt_dblclk_msg.setSelected(true);
		else
			opt_dblclk_chat.setSelected(true);
	
		foo = conf.get("useSound");					if(foo==null) foo = "default";
		if(foo.equals("default"))
			opt_snd_default.setSelected(true);
		else if(foo.equals("noSound"))
			opt_snd_nosnd.setSelected(true);
		
		chk_useTray.setEnabled(false);
		
	}
	/**
	 * 설정값을 저장한다
	 */
	private void saveConf() {
		conf = frmmain.getConfutil();
		conf.readData();
		
		
		String foo;
		int bar;
		
		//chk_useTray.setSelected(conf.getBoolean("useTray"));
		
		conf.set("useTray", (chk_useTray.isSelected()) ? "true" : "false" );
		conf.set("useFlashing", (chk_useFlashing.isSelected()) ? "true" : "false" );
		conf.set("useNotify" , (chk_useNotify.isSelected()) ? "true" : "false" );
		conf.set("useAlwaysOnTop" , (chk_use_viewontop.isSelected()) ? "true" : "false" );
		
		
		foo = txt_fun_autoAway.getText();
		
		try{
			bar = Integer.parseInt(foo);
		}catch (NumberFormatException e) {
			bar = 0;
		}
		bar = (bar<0) ? 0: bar;
		conf.set("useAutoAway", bar+"");
		
		conf.set("DefaultAction" , (opt_dblclk_msg.isSelected()) ? "0" : "1" );

		foo = "default";
		//foo = opt_snd_default.isSelected() ? "default" : null;
		foo = opt_snd_nosnd.isSelected() ? "noSound" : foo;
		foo = opt_snd_custom.isSelected() ? "custom" : foo;
		
		
		conf.set("useSound" ,foo );
		

			
	
		
		final UIManager.LookAndFeelInfo lafInfo[] = UIManager.getInstalledLookAndFeels();
		
		foo = null;
		LookAndFeelInfo laf = null;
		
		for(int i=0;i<lafInfo.length;i++){
			if(mLookAndFeelItem[i].isSelected() == true){
				foo = 	 lafInfo[i].getClassName();
				break;
			}
		}

		
	//	if(!foo.equals(UIToolkit.currentLookAndFeel)){
			
			conf.set("LookAndFeel", foo);
			try {
				UIManager.setLookAndFeel(foo);
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			} catch (InstantiationException e) {
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			} catch (UnsupportedLookAndFeelException e) {
				e.printStackTrace();
			}
			frmmain.updateUIAll();		
		//}
			
		
		
		
		conf.writeData();
		frmmain.loadConf();
		UIToolkit.setAlwaysOnTop(frmmain, chk_use_viewontop.isSelected());
		
		thisdlg.dispose();
	
		
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
        this.setSize(new Dimension(400, 309));
        this.setTitle("JaTeOn 환경설정");
        

		//this.setIconImage(UIToolkit.getFrameIcon(UIToolkit.iconSetting));
		
        this.setContentPane(getJContentPane());
        this.setResizable(false);
        
        //XXX: Not implemented fetures
        //XXX: Not implemented fetures
        //opt_File.setEnabled(false);
        //opt_Message.setEnabled(false);
        opt_snd_custom.setEnabled(false);
        txt_fun_autoAway.setEnabled(false);
        
        
        
        
        Point p = frmmain.getLocation();
		Dimension d = frmmain.getSize();

		this.setLocation( 
			p.x + (d.width - getWidth()) / 2,
			p.y + (d.height - getHeight()) / 2);
		
        
			
	}

	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJTabbedPane(), null);
			jContentPane.add(getButtonArea(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setBounds(new Rectangle(0, 0, 391, 241));
			jTabbedPane.setTabPlacement(JTabbedPane.LEFT);
			////jTabbedPane.setTabLayoutPolicy(JTabbedPane.LEFT_ALIGNMENT);
			jTabbedPane.addTab("기  능", null, getOptionFunction(), null);
		
			jTabbedPane.addTab("모  양", null, getOptionVisual(), null);
			//jTabbedPane.setTabPlacement();
			jTabbedPane.addTab("소  리", null, getOptionSound(), null);
			//XXX: not implemented fetures
			//jTabbedPane.addTab("메시지", null, getOptMessage(), null);
			//jTabbedPane.addTab("파  일", null, getOpt_File(), null);
		}
		return jTabbedPane;
	}

	/**
	 * This method initializes buttonArea	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getButtonArea() {
		if (buttonArea == null) {
			buttonArea = new JPanel();
			buttonArea.setLayout(new FlowLayout());
			buttonArea.setBounds(new Rectangle(240, 240, 151, 46));
			btnOK = new JButton("확인");
			btnCancel = new JButton("취소");
			btnOK.setActionCommand("OK");
			btnCancel.setActionCommand("Cancel");
			
			btnOK.addActionListener(evthand);
			btnCancel.addActionListener(evthand);
			
			buttonArea.add(btnOK);
			buttonArea.add(btnCancel);
		}
		return buttonArea;
	}

	/**
	 * This method initializes option1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getOptionFunction() {
		if (optFunction == null) {
			lbl_fun_autoawaymin = new JLabel();
			lbl_fun_autoawaymin.setBounds(new Rectangle(75, 120, 159, 18));
			lbl_fun_autoawaymin.setText("분 ( 0이면 사용 안함)" +
					"");
			lbl_fun_autoaway = new JLabel();
			lbl_fun_autoaway.setBounds(new Rectangle(30, 105, 211, 16));
			lbl_fun_autoaway.setText("자동 자리 비움 설정");
			btngrp_opt_dblclk = new ButtonGroup();
			lbl_fun_dblclik_title = new JLabel();
			lbl_fun_dblclik_title.setBounds(new Rectangle(30, 150, 166, 16));
			lbl_fun_dblclik_title.setText("대화 상대 더블 클릭시");
			optFunction = new JPanel();
			
			chk_useTray = new JCheckBox();
			chk_useTray.setBounds(new Rectangle(15, 15, 286, 16));
			chk_useTray.setText("트레이 사용");
			chk_useTray.setActionCommand("useTray");
			chk_useTray.addActionListener(evthand);
			chk_useFlashing = new JCheckBox();
			chk_useFlashing.setBounds(new Rectangle(15, 45, 286, 16));
			chk_useFlashing.setText("플래싱 기능 사용");
			chk_useNotify = new JCheckBox();
			chk_useNotify.setBounds(new Rectangle(15, 30, 219, 16));
			chk_useNotify.setText("접속 알림 사용");
			opt_dblclk_msg = new JRadioButton();
			opt_dblclk_msg.setBounds(new Rectangle(36, 168, 107, 12));
			opt_dblclk_msg.setText("쪽지 보내기");
			btngrp_opt_dblclk.add(opt_dblclk_msg);
			opt_dblclk_chat = new JRadioButton();
			opt_dblclk_chat.setBounds(new Rectangle(36, 183, 121, 16));
			opt_dblclk_chat.setText("대화 걸기");
			btngrp_opt_dblclk.add(opt_dblclk_chat);
			chk_use_viewontop = new JCheckBox();
			chk_use_viewontop.setBounds(new Rectangle(15, 60, 256, 16));
			chk_use_viewontop.setText("항상 위에 표시");
			txt_fun_autoAway = new JTextField();
			txt_fun_autoAway.setBounds(new Rectangle(43, 121, 31, 16));

			txt_fun_autoAway.setHorizontalAlignment(JTextField.TRAILING);
			
			
			
			
			optFunction.setLayout(null);
			optFunction.add(chk_useTray);
			optFunction.add(chk_useFlashing);
			optFunction.add(chk_useNotify);
			optFunction.add(lbl_fun_dblclik_title);
			optFunction.add(opt_dblclk_msg);
			optFunction.add(opt_dblclk_chat);
			optFunction.add(chk_use_viewontop);
			optFunction.add(lbl_fun_autoaway);
			optFunction.add(txt_fun_autoAway);
			optFunction.add(lbl_fun_autoawaymin);
			
			
			
		}
		return optFunction;
	}


	private JPanel getOptionVisual() {
		if (optVisual == null) {
			lbl_visual_title = new JLabel();
			lbl_visual_title.setBounds(new Rectangle(15, 15, 148, 18));
			lbl_visual_title.setText("룩앤필 설정");
			optVisual = new JPanel();
			optVisual.setLayout(null);
			optVisual.add(lbl_visual_title, null);
			opt_visual_lookNfeelpan = new JPanel();
			opt_visual_lookNfeelpan.setLayout(new BoxLayout(opt_visual_lookNfeelpan, BoxLayout.Y_AXIS));
			opt_visual_lookNfeelpan.setBounds(new Rectangle(26, 38, 220, 178));
			
			optVisual.add(opt_visual_lookNfeelpan, null);
			btngrp_opt_lookandfeel = new ButtonGroup();
			
			
			final UIManager.LookAndFeelInfo lafInfo[] = UIManager.getInstalledLookAndFeels();
			mLookAndFeelItem = new JRadioButton[lafInfo.length] ;

					
			for(int i=0;i<lafInfo.length;i++){
				final UIManager.LookAndFeelInfo info = lafInfo[i];
		
				//mLookAndFeelItem[i] = new JMenuItem(lafInfo[i].getName());
				mLookAndFeelItem[i] = new JRadioButton(lafInfo[i].getName());
				
				if(lafInfo[i].getClassName().equals(UIToolkit.getCurrentLookAndFeel()))
					mLookAndFeelItem[i].setSelected(true);
				
				btngrp_opt_lookandfeel.add(mLookAndFeelItem[i]);
				opt_visual_lookNfeelpan.add(mLookAndFeelItem[i]);				
				//mSetLookAndFeel.add(mLookAndFeelItem[i]);
		
			}
			
			
		}
		return optVisual;
	}


	private JPanel getOptionSound() {
		if (optSound == null) {
			optSound = new JPanel();
			optSound.setLayout(null);
			
			
			
			opt_snd_default = new JRadioButton();
			opt_snd_default.setBounds(new Rectangle(15, 15, 201, 16));
			opt_snd_default.setText("소리 알림 사용");
			
			opt_snd_nosnd = new JRadioButton();
			opt_snd_nosnd.setBounds(new Rectangle(15, 45, 220, 16));
			opt_snd_nosnd.setText("소리 알림 사용안함");
			
			opt_snd_custom = new JRadioButton();
			opt_snd_custom.setBounds(new Rectangle(15, 75, 159, 16));
			opt_snd_custom.setText("소리 파일 지정");
			
			
			btngrp_opt_sound = new ButtonGroup();
			btngrp_opt_sound.add(opt_snd_default);
			btngrp_opt_sound.add(opt_snd_nosnd);
			btngrp_opt_sound.add(opt_snd_custom);
			

			
			optSound.add(opt_snd_default);
			optSound.add(opt_snd_nosnd);
			optSound.add(opt_snd_custom);
			
			
			
			opt_snd_custom.setActionCommand("opt_snd_custom");			
			opt_snd_custom.addActionListener( evthand );
			
			
			
		}
		return optSound;
	}
	private JPanel getOptMessage() {
		if (opt_Message == null) {
			opt_Message = new JPanel();
			opt_Message.setLayout(new GridBagLayout());
		}
		return opt_Message;
	}

	/**
	 * This method initializes opt_File	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getOpt_File() {
		if (opt_File == null) {
			opt_File = new JPanel();
			opt_File.setLayout(new GridBagLayout());
		}
		return opt_File;
	}



	/**
	 * @param args
	 */
	public static void main(String[] args) {
	
		OptionDialog app = new OptionDialog(null);
		app.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		app.setVisible(true);
		
		

	}
	
	private class EvtHandler implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			String cmd = e.getActionCommand();
			if(cmd.equals("OK")){
				saveConf();
			}
			else if(cmd.equals("Cancel"))
			{
				thisdlg.dispose();
			}
			else if(cmd.equals("useTray")){
				if(chk_useTray.isSelected()==false && chk_useNotify.isEnabled()==true){
					chk_useNotify.setSelected(false);
					chk_useNotify.setEnabled(false);
				}
				else if(chk_useNotify.isEnabled()==false && chk_useTray.isSelected()==true)
					chk_useNotify.setEnabled(true);
					
			}		
			
			else
				System.err.println(cmd);
			
		}
	}

}  //  @jve:decl-index=0:visual-constraint="51,12"
