package kfmes.jateon.swing.dialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import kfmes.jateon.swing.UIToolkit;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.msg.InstanceMessage;
import kfmes.natelib.util.DateUtil;

/**
 * 
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: RecvMessageGUI.java,v 1.24 2007/11/19 10:13:32 kfmes Exp $
 */
public class RecvMessageGUI  implements ActionListener, KeyListener{
	private JScrollPane jScrollPane1;
	private JLabel lblInfo;
	private JButton btnSend;
	private NateonMessenger nate = null;
	private InstanceMessage msg = null;
	private NateFriend owner = null;
	private JButton jButton1;
	private JTextArea jTextArea1;
	private String recvUser = null;
	private JFrame frmMsgDialog = null;
	private InstanceMessage imsg = null;
	
	public RecvMessageGUI(NateonMessenger nate, InstanceMessage imsg){
		this.nate = nate;
		this.imsg = imsg;
	
		initGUI();
		this.set();
		
		jTextArea1.requestFocus();
	}
	
	private void set(){
		
		String sender = imsg.getFriend().getNameID().replace('(','<').replace(')','>');;//.getRealName();//.getFormattedBuddy();
		//String sender = imsg.getFrom();
		
		String info = "보낸이 : " + /*imsg.getFrom()*/ sender  +  " (" + DateUtil.toFormattedDate(imsg.getDate()) + ")";
		//MsgUtil.println("%%%" + info);
		this.lblInfo.setText(info);
		
		this.jTextArea1.setText(imsg.getMessage());
		
	}
	
/*
	public RecvMessageGUI(NateonMessenger nate) {
		this.nate = nate;
		initGUI();
	
	}
	*/
	
	public void initGUI(){
		frmMsgDialog = new JFrame("쪽지 읽기");
		frmMsgDialog.getContentPane().setLayout(null);
		kfmes.jateon.swing.MainFrame.newDialog(frmMsgDialog);
		
		UIToolkit.setLocationByPlatform(frmMsgDialog, true);
		frmMsgDialog.setIconImage(UIToolkit.getFrameIcon(UIToolkit.iconMsg));
		
		
		{
			btnSend = new JButton();
			frmMsgDialog.getContentPane().add(btnSend);
			btnSend.setText("답장");
			btnSend.setBounds(189, 203, 84, 28);
			btnSend.addActionListener(this);
			/*
			btnSend.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					try{
						SendMessageGUI SendMsg = new SendMessageGUI(nate);
						SendMsg.setRecvUser(imsg.getFrom());
					}catch (Exception e) {
						e.printStackTrace();
					}
					frmMsgDialog.dispose();
				}
				
			});*/
		}
		{
			lblInfo = new JLabel();
			frmMsgDialog.getContentPane().add(lblInfo);
			lblInfo.setText("foo");
			lblInfo.setBounds(7, 7, 364, 21);
		}
		{
			jScrollPane1 = new JScrollPane();
			frmMsgDialog.getContentPane().add(jScrollPane1);
			jScrollPane1.setBounds(7, 35, 357, 161);
			//jScrollPane1.setFocusTraversalPolicyProvider(true);
			{
				jTextArea1 = new JTextArea();
				jScrollPane1.setViewportView(jTextArea1);
				jTextArea1.setText("jTextArea1");
				jTextArea1.addKeyListener(this);
				jTextArea1.setEditable(false);
				jTextArea1.setLineWrap(true);
			}
		}
		{
			jButton1 = new JButton();
			frmMsgDialog.getContentPane().add(jButton1);
			jButton1.setText("닫기");
			jButton1.setBounds(273, 203, 84, 28);
			jButton1.addActionListener(this);
			/*
			jButton1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					frmMsgDialog.dispose(); // 프레임 닫기
				}
			});*/
			
		}
		frmMsgDialog.setSize(379, 270);
		
		frmMsgDialog.setFocusableWindowState(false);
		frmMsgDialog.setVisible(true);
		frmMsgDialog.setFocusableWindowState(true);
		
		frmMsgDialog.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frmMsgDialog.setResizable(false);

	}
	

	private void sendMessage() throws IOException {
		SendMessageGUI SendMsg = new SendMessageGUI(nate);
		//SendMsg.setRecvUser(imsg.getFrom());		
		SendMsg.setRecvUser(imsg.getFriend());
	}
	
		
	
	public void actionPerformed(ActionEvent e)  {
		JButton b = (JButton) e.getSource();
		try{
			if(b==btnSend){
				sendMessage();
				kfmes.jateon.swing.MainFrame.removeDialog(frmMsgDialog);
				frmMsgDialog.dispose();
				
			}
			else if(b==jButton1){
				kfmes.jateon.swing.MainFrame.removeDialog(frmMsgDialog);
				frmMsgDialog.dispose();
			}				
			
		} catch (IOException e1) {
				e1.printStackTrace();
		}
		
	}
	public void keyPressed(KeyEvent e) {
		try{
			
			if((e.isAltDown()&& (e.getKeyCode()==KeyEvent.VK_R))||
					(e.isControlDown() && e.getKeyCode()==KeyEvent.VK_ENTER)){
				// Alt + R 또는 Ctrl + Enter가 눌리면 답장 창 띄움
				kfmes.jateon.swing.MainFrame.removeDialog(frmMsgDialog);
				sendMessage();
				frmMsgDialog.dispose();
			}
				
			else if(e.getKeyCode() == KeyEvent.VK_ESCAPE){
				kfmes.jateon.swing.MainFrame.removeDialog(frmMsgDialog);
				frmMsgDialog.dispose();
			}
		}catch (IOException e1) {
			e1.printStackTrace();			
		}

		
	}
	public void keyReleased(KeyEvent e) {
		// TODO 자동 생성된 메소드 스텁
		
	}
	public void keyTyped(KeyEvent e) {
		// TODO 자동 생성된 메소드 스텁
		
	}
	
	
	


}