package kfmes.jateon.swing.dialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.IOException;
import javax.swing.*;

import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.msg.InstanceMessage;

import kfmes.jateon.swing.UIToolkit;

/**
 * 
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: SendMessageGUI.java,v 1.16 2007/11/19 10:13:32 kfmes Exp $
 */
public class SendMessageGUI implements ActionListener,KeyListener {
	private JScrollPane jScrollPane1;
	private JTextField txtRecv;
	private JButton jButton1;
	private JTextArea txtMessage;
	private JButton btnSend;
	private NateonMessenger nate = null;
	private InstanceMessage msg = null;
	private NateFriend owner = null;
	private NateFriend recvUser = null;
	private JFrame frmMsgDialog = null;	
	

	public SendMessageGUI(NateonMessenger nate) {
		//this.frmMsgDialog.setLocationByPlatform(true);
		this.nate = nate;
		
		
		initGUI();
		//this.frmMsgDialog.
		
		
	
	}
	public void setRecvUser(NateFriend recvUser) {
		this.recvUser = recvUser;
		this.txtRecv.setText(recvUser.getNameID());
	}
	public void setMsg(InstanceMessage msg) {
		this.msg = msg;
		this.txtMessage.setText(msg.getMessage());
		this.txtRecv.setText(msg.getRef());
		
	}
	
	public void initGUI(){
		frmMsgDialog = new JFrame("쪽지 보내기");
		kfmes.jateon.swing.MainFrame.newDialog(frmMsgDialog);
		
		UIToolkit.setLocationByPlatform(frmMsgDialog, true);
		frmMsgDialog.setIconImage(UIToolkit.getFrameIcon(UIToolkit.iconMsg));
		
		frmMsgDialog.getContentPane().setLayout(null);
		{
			jScrollPane1 = new JScrollPane();
			frmMsgDialog.getContentPane().add(jScrollPane1);
			jScrollPane1.setBounds(7, 35, 357, 161);
			{
				txtMessage = new JTextArea();
				jScrollPane1.setViewportView(txtMessage);
				txtMessage.addKeyListener(this);
				txtMessage.setLineWrap(true);
			}
			
		}
		{
			txtRecv = new JTextField();
			frmMsgDialog.getContentPane().add(txtRecv);

			txtRecv.setBounds(7, 7, 350, 21);
			txtRecv.addFocusListener(new FocusAdapter() {
				public void focusGained(FocusEvent evt) {
					txtRecv.setSelectionStart(0);
					txtRecv.setSelectionEnd(txtRecv.getText().length());					
					
				}
			});
		}
		{
			btnSend = new JButton();
			frmMsgDialog.getContentPane().add(btnSend);
			btnSend.setText("보내기");
			btnSend.setBounds(189, 203, 84, 28);
			btnSend.addActionListener(this);
			/*
			btnSend.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					try{
						
					}catch (Exception e) {
						e.printStackTrace();
					}
					frmMsgDialog.dispose();
				}
				
			});
			*/
		}
		{
			jButton1 = new JButton();
			frmMsgDialog.getContentPane().add(jButton1);
			jButton1.setText("닫기");
			jButton1.setBounds(280, 203, 84, 28);
			jButton1.addActionListener(this);
			/*
			jButton1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {

					frmMsgDialog.dispose(); // 프레임 닫기
				}
				
			});
			*/
		}
		frmMsgDialog.setSize(379, 270);
		frmMsgDialog.setVisible(true);
		frmMsgDialog.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.txtMessage.requestFocusInWindow();
		frmMsgDialog.setResizable(false);

	}
	
	private void sendMessage() throws IOException {
		
		owner = nate.getOwner(); 
		msg = new InstanceMessage(owner.getNateID(),recvUser.getNateID(), txtMessage.getText());
		nate.sendIMessage(msg);
		
	}
	
	
	public void actionPerformed(ActionEvent e)  {
		JButton b = (JButton) e.getSource();
		try{
			if(b==btnSend){
				sendMessage();			
				kfmes.jateon.swing.MainFrame.removeDialog(frmMsgDialog);
				frmMsgDialog.dispose();
			}
			else if(b==jButton1){
				kfmes.jateon.swing.MainFrame.removeDialog(frmMsgDialog);
				frmMsgDialog.dispose();				
			}
			
		} catch (IOException e1) {
				e1.printStackTrace();
		}
		
	}
	public void keyPressed(KeyEvent e) {
		try{
			if((e.isAltDown()&&e.getKeyCode()==KeyEvent.VK_S) || 
					(e.isControlDown() && e.getKeyCode()==KeyEvent.VK_ENTER)) {
				// Alt + S 또는 Ctrl + Enter가 눌리면 쪽지 보냄
				sendMessage();
				kfmes.jateon.swing.MainFrame.removeDialog(frmMsgDialog);
				frmMsgDialog.dispose();
			} // END of send
			
			else if(e.getKeyCode() == KeyEvent.VK_ESCAPE){
				kfmes.jateon.swing.MainFrame.removeDialog(frmMsgDialog);
				frmMsgDialog.dispose();
			}
		}catch (IOException e1) {
			e1.printStackTrace();			
		}

		
	}
	public void keyReleased(KeyEvent e) {
		// TODO 자동 생성된 메소드 스텁
		
	}
	public void keyTyped(KeyEvent e) {
		// TODO 자동 생성된 메소드 스텁
		
	}
	
	
	


}
