/**
 * 
 */
package kfmes.jateon.swt;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Properties;

import kfmes.jateon.swt.dialog.ChatWindow;
import kfmes.jateon.swt.dialog.RecvMessage;
import kfmes.natelib.NateFileManager;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.SwitchBoardSession;
import kfmes.natelib.entity.GroupList;
import kfmes.natelib.entity.NateFile;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.entity.NateGroup;
import kfmes.natelib.entity.UserStatus;
import kfmes.natelib.event.NateListener;
import kfmes.natelib.ftp.FileRecver;
import kfmes.natelib.ftp.FileSender;
import kfmes.natelib.msg.InstanceMessage;
import kfmes.natelib.msg.MimeMessage;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;


/**
 * 친구 리스트
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: BuddyTree.java,v 1.53 2007/11/19 10:13:31 kfmes Exp $
 */
final public class BuddyTree {
	private static final long serialVersionUID = 1L;
	private NateFriend me = null;
	private NateonMessenger nate = null;
	private Listener listener = null;
	private TListener tlistener = null;
	private BuddyTree thistree = null;
	private ActionGroup action = null;
	
	protected NateFriend lastLoginBuddy = null;
	protected TreeItem lastSelected = null;
	
	
	
	//private HashMap<String,TreeItem> groupMap = new HashMap<String,TreeItem>();
	private HashMap<String,TreeItem> friendMap = new HashMap<String, TreeItem>();
	private HashMap<SwitchBoardSession, ChatWindow> chatdlgMap = new HashMap<SwitchBoardSession, ChatWindow>();
	private HashSet<Composite> windowsSet = new HashSet<Composite>();
	
	
	protected Tree tree = null;
	private MainFrame main = null;
	private UIToolKit toolkit = null;
		
	
	public static final int VIEW_NAME = 0;
	public static final int VIEW_NICK= 1;
	public static final int VIEW_ID = 2;
	public static final int VIEW_NAME_ID = 3;
	public static final int VIEW_NAME_NICK = 4;
	
	private boolean offView = false;
	private int viewMode = 1;

	
	public BuddyTree(Composite parent, MainFrame main){

		this.main = main;
		this.nate = main.getMessenger();
		this.thistree = this;
		this.action = main.action;
		this.toolkit = main.toolKit;
		
		listener = new Listener();
		tlistener = new TListener();
		
		tree = new Tree(main.shell,SWT.SINGLE | SWT.BORDER);
		
		nate.addNateListener(listener);
		
		initTree();
		
	}
	private void initTree() {
		
		tree.setHeaderVisible(false);
		tree.addMouseListener(tlistener);
		tree.addSelectionListener(tlistener);
		//test
		//tree.setBackground(new Color(Display.getCurrent() , 0,255,0));
		
		
	}

	
	private String getGroupText( NateGroup group)
	{
		ArrayList<NateFriend> list = group.getList();
		int total = list.size();
		
		int online = 0;
		for(int i=0;i<total;i++)
			if(!list.get(i).getStatus().equals(UserStatus.Offline))
				online++;		
		return  (offView)? group.getName() + " (" + online + "/" + total + ")" : group.getName() + "(" + online + ")";
	}
	
	private String getBuddyText(NateFriend friend){
		String txt = null;
		
		String status = "";
		if(!friend.getStatus().equals(UserStatus.Online))
			status = " (" + friend.getFormattedStatus() + ')';
		
		switch( viewMode )
		{
		case VIEW_NAME:
			txt = friend.getRealName().concat(status);
			break;
		case VIEW_NICK:
			txt = friend.getNickName().replaceAll("%20", " ").replaceAll("%25", "%").concat(status) ;
			break;
		case VIEW_ID:
			txt = friend.getID().concat(status);
			break;
		case VIEW_NAME_ID:
			txt = friend.getRealName() + "(" + friend.getID() + ")" + status;
			break;
		case VIEW_NAME_NICK:
			txt = friend.getRealName() + "(" + friend.getNickName().replaceAll("%20", " ").replaceAll("%25", "%") + ")" + status;
			break;
			/*
		case VIEW_LOGIN_NAME:
			setText( friend.getNameID() .getLoginName().concat(status) );
			break;*/
		}
		return txt;		
	}

	/**
	 * 상태가 변경된 buddy 를 처리
	 * @param friend
	 */
	private void updateBuddy(NateFriend friend) {
		TreeItem ti = friendMap.get(friend.getID());
		
		if(ti==null)
			syncAllUsers();
		
		else if(friend.getStatus().equals(UserStatus.Offline)){
			//ti.dispose();
			syncAllUsers();
		}
			
		else
			updateBuddyTreeItem(ti);
	}

	/**
	 * buddy를 다시 그려준다.
	 * @param ti
	 */
	private void updateBuddyTreeItem(TreeItem ti){
		NateFriend f = (NateFriend) ti.getData();

			ti.setImage(toolkit.getBuddyIcon(f.getStatus()) );
			ti.setText(getBuddyText(f));
			
		
	}
	
	

	public void syncAllUsers()
	{
		tree.removeAll();
		//groupMap.clear();
		
		friendMap.clear();

		GroupList gl = nate.getBuddyGroup();
		
		
		if(gl==null)
			return;

		for(int i = 0;i<gl.length();i++){
			NateGroup group = gl.get(i);
			if(group.getVisual() == "N")		// 그룹 이름이 아니라 보이기 속성으로 비교 하면 됨 by bronks  :: 정말 그룹 이름이 XXX 면???
				continue;
			
			TreeItem node = new TreeItem(tree,0);
						

			node.setText(getGroupText(group) );
			node.setImage(toolkit.getBuddyIcon(UIToolKit.BuddyGroup));
			node.setData(group);

			//groupMap.put(i+"", node);

		ArrayList bl = gl.get(i).getList();//.getForwardList();
		//bl.sort(true);
			for(Iterator j=bl.iterator(); j.hasNext(); )
			{
				NateFriend friend = (NateFriend)j.next();
					if( !offView && 
							(friend.getStatus().equals(UserStatus.Offline) 
									|| (friend.getStatus().equals(UserStatus.OFF_Blocked))))
							continue;
					
				TreeItem subnode = new TreeItem(node,0);
				
				/*
				subnode.setImage(toolkit.getBuddyIcon(friend.getStatus()));
				subnode.setText(getBuddyText(friend));*/
				
				subnode.setData(friend);
				updateBuddyTreeItem(subnode);

				friendMap.put(friend.getID(), subnode);
				}
			node.setExpanded(true);
		}

	}
	
	/**
	 *  자테온이 생성한 모든 창을 닫는다
	 *
	 */
	protected void closeAllWindows() {
		
		
		Iterator cwit = chatdlgMap.values().iterator();
	//	Iterator cwitk = chatdlgMap.keySet().iterator();
		for(int i=0;i<chatdlgMap.size();i++){
			((ChatWindow)cwit.next()).shellDispose();
		}/*
		while(cwit.hasNext()){
			System.err.println(cwit.next());
			((ChatWindow)cwit.next()).shellDispose();
		}*/
		chatdlgMap.clear();
		
		Iterator<Composite> i = windowsSet.iterator();
		while(i.hasNext()){
			i.next().dispose();
		}
		
		
		//
		// TODO 자동 생성된 메소드 스텁
		
	}


	
	public NateFriend getSelectedFriend(){
		
		TreeItem[] t = tree.getSelection();
		//for(int i=0;i<t.length;i++)
		
		if(t.length==1)
			if (t[0].getData() instanceof NateFriend){
				//MsgUtil.println(t[0].getData().toString());
				return (NateFriend) t[0].getData();
			}
				
		return null;			
		
	}
	public ChatWindow getChatWindow(SwitchBoardSession ss, NateFriend fr) {
		ChatWindow cw = chatdlgMap.get(ss);

		if(cw==null){
			for(ChatWindow c : chatdlgMap.values()){
				
				//MsgUtil.errPrintln(c.getLastRecvUser().toString());
				NateFriend cf = c.getLastRecvUser();
				
				if(cf!=null && cf.equals(fr) )
					return c;
			}
		
		}
		return chatdlgMap.get(ss);
	}
	
	public void addChatWindow(ChatWindow cw, SwitchBoardSession ss){
		if(!chatdlgMap.containsKey(ss))
			chatdlgMap.put(ss, cw);
	}
	

	public void addWindow(Composite c){
		windowsSet.add(c);
	}
	public void removeChatWindow(SwitchBoardSession  ss){
		chatdlgMap.remove(ss);
	}
	protected ChatWindow getChatWindow(SwitchBoardSession ss){
		return chatdlgMap.get(ss);
	}
	public void removeWindow(Composite c){
		windowsSet.remove(c);
	}
	
	
	
	public boolean getOffView() {
		return offView;
	}
	public void setOffview(boolean offview){
		this.offView = offview;
	}
	public int getBuddyView() {
		return viewMode;
	}
	
	
	
	public void setLayoutData(GridData gridData) {
		tree.setLayoutData(gridData);
	}
	
	public void setBuddyView(int mode){
		viewMode = mode;
	}


	private class TListener implements MouseListener, SelectionListener{

		public void mouseDoubleClick(MouseEvent e) {
			// TODO 자동 생성된 메소드 스텁
			
			if(e.button==1 ){
				Point p =new Point(e.x,e.y);
				TreeItem node = tree.getItem(p);
				
				if(node==null || node.getData() instanceof NateGroup)
					return;
				NateFriend f =(NateFriend) node.getData();
				
				
				if(main.getDblClickDefaultAction() == kfmes.jateon.swt.MainFrame.DefaultActionMsg){
					action.actionSendIMsg(f);
					/*
					SendMessageGUI send = new SendMessageGUI(nate);
					send.setRecvUser(friend);*/
				}
				else
				{
					action.actionReqChat(f);
				}

			}
			
		}

		public void mouseDown(MouseEvent e) {
			
			if(e.button==3){

				Point p =new Point(e.x,e.y);
				TreeItem node = tree.getItem(p);
				
				
				
					
				if (node!=null && node.getData() instanceof NateFriend) {
					
					NateFriend fr = (NateFriend) node.getData();
					//MsgUtil.println(fr.getFormattedBuddy());
					main.getMenuBar().getPopup(fr);
					//Menu menu = main.getMenuBar().getPopup(fr);
					//menu.setVisible(true);
					//tree.setMenu(menu);
					
					//tree.setMenu(main.getMenuBar().getPopup( fr ));
					
				}
				else if(node!=null && node.getData() instanceof NateGroup) {
					main.getMenuBar().getGroupPopup((NateGroup)node.getData());
					
				}
				else 
//					if(node==null)
						main.getMenuBar().getDefaultPopup(null);
						//tree.setMenu(main.getMenuBar().getDefaultPopup());
				
			}
			
			

		}

		public void mouseUp(MouseEvent e) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void widgetDefaultSelected(SelectionEvent e) {
			if (e.item!=null && e.item.getData() instanceof NateGroup) {
				//NateGroup gr = (NateGroup) e.item.getData();
				TreeItem treeItem = (TreeItem) e.item;
				treeItem.setExpanded(!treeItem.getExpanded());
			}
			
		}

		public void widgetSelected(SelectionEvent e) {
			setSelected((TreeItem) e.item);

		}
		private void setSelected(TreeItem t){
			//MsgUtil.errPrintln(t.getText());
			lastSelected = t;
		}


	


		
	}
	
	private class Listener /*extends NateAdapter*/ implements NateListener{

		
		public void buddyListInit(GroupList grouplist) {
			Display.getCurrent().asyncExec(new Runnable(){
				public void run(){
					thistree.syncAllUsers();	
				}
			});
			
			tree.setBackgroundMode(SWT.INHERIT_NONE);
		}
		public void OwnerStatusUpdated() {
			main.updateOwnerStatus();			
		}
		public void instanceMessageReceived(final InstanceMessage imsg) {
			Display.getDefault().asyncExec(new Runnable(){
				public void run() {
					MusicBox.play(MusicBox.SOUND_MESSAGE);	
					RecvMessage recv = new RecvMessage(main, nate,imsg);
									
				}				
			});
		};
		
		public void switchboardSessionEnded(SwitchBoardSession ss) {
		
			//MsgUtil.println("sb ended " + ss);
			
			/*
			if(chatdlgMap.containsKey(ss))
				chatdlgMap.remove(ss);
				*/
			
		}

		public void switchboardSessionStarted(SwitchBoardSession ss) {
	
		}
		
		
		public void loginError(String header) {
			main.menuBar.setOnline(false);
			main.showMessageBox("로그인 실패", "로그인에 실패하였습니다.\n아이디와 패스워드를\n제대로 입력했는지 확인하세요", SWT.ICON_ERROR);
			
		}
		
		
		public void chatMessageReceived(final SwitchBoardSession ss, final NateFriend friend, final MimeMessage mime) {
			
		//	ChatWindow chat = getChatWindow(ss, friend);
			/*
			boolean find = (chat==null) ? false : true;
			
						

			if(find)
			{*/
			if(mime.getType().equals("QUIT"))
				return;
			
				Display.getDefault().asyncExec(new Runnable(){
					public void run() {
						try{
						getChatWindow(ss, friend).incoming(friend, mime);
						}catch (Exception e) {// 여기까지 왔으면 해당 chatwin 을 찾지 못했을경우다
							
							
					
							NateFriend recv = ss.getNateFriend();
							ChatWindow c = new ChatWindow( nate,thistree,ss, recv, friend, mime);
							//c.incoming(friend, mime);					
							
						
						}
						//c.incoming(friend, mime);					
					}				
				});
				
			//}
			

			MusicBox.play(MusicBox.SOUND_CHAT);
					
			//ChatWindow 
			
			
			
		}
		public void killed() {
			try {
				nate.logout();

			} catch (IOException e) {
				e.printStackTrace();
			}
			Display.getDefault().asyncExec(new Runnable(){
				public void run() {
					tree.removeAll();
					main.menuBar.setOnline(false);
					nate.setMyStatus(UserStatus.Offline);
					main.setUserStatusNull();
					main.showMessageBox("다른곳에서 접속됨", "다른곳에서 접속하여 종료되었습니다", SWT.ICON_WARNING);
					
				}
			});
		}
		public void buddyModified(final NateFriend friend) {
			Display.getDefault().asyncExec(new Runnable(){
				public void run() {
					updateBuddy(friend);
				}				
			})	;			
		}
		
		
		public void addFailed(int errorCode) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void allListUpdated() {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void buddyListModified() {
			Display.getDefault().asyncExec(new Runnable(){
				public void run(){
					thistree.syncAllUsers();
				}				
			});
			
			
		}

		public void fileSendAccepted(SwitchBoardSession ss, String cookie) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void fileSendEnded(FileSender sender, NateFile natefile) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void fileSendError(FileSender sender, Throwable e) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void fileSendRejected(SwitchBoardSession ss, String cookie, String reason) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void fileSendStarted(FileSender server) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void listAdd(NateFriend friend) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void listOnline(NateFriend friend) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void loginComplete() {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void logoutNotify() {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void notifyUnreadMail(Properties prop, int unread) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void progressTyping(SwitchBoardSession ss, final NateFriend friend, final int flag) {
			final ChatWindow cw = chatdlgMap.get(ss);
			if(cw!=null)
				Display.getDefault().asyncExec(new Runnable(){
					public void run() {
						cw.progressTyping(friend, flag);
					}					
				});
				
			
		}
		public void renameNotify(NateFriend friend) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void switchboardSessionAbandon(SwitchBoardSession ss, String targetName) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void userOffline(NateFriend friend) {
			//removeTreeItem(friend);
			MusicBox.play(MusicBox.SOUND_LOGOUT);			
		}
		public void userOnline(NateFriend friend) {
			lastLoginBuddy = friend;
			
			if( main.getConf().getBoolean("useNotify") && main.tray!=null){
				
				main.tray.setDisplayMessage("로그인 알림", friend);
				
			}
			
			MusicBox.play(MusicBox.SOUND_LOGIN);
			
		}
		public void whoAddedMe(NateFriend friend) {
			action.actionWhoAddedMe(friend);
			
		}
		public void whoJoinSession(SwitchBoardSession ss, NateFriend join) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void whoPartSession(SwitchBoardSession ss, NateFriend part) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		public void whoRemovedMe(NateFriend friend) {
			// TODO 자동 생성된 메소드 스텁
			
		}

		public void fileSend(SwitchBoardSession session, FileSender sender, NateFriend ref, ArrayList<NateFile> list) {
			main.fileTransferDlg.fileSend(session, sender, ref, list);
			//		(sender, NateFileManager.STATUS_SEND_READY);
			
		}
		
		public void filePosted(SwitchBoardSession ss, final FileRecver recv, final NateFriend ref, final ArrayList<NateFile> list) {
			
			
			main.fileTransferDlg.filePosted(ss, recv, ref, list);
			 
			/*
			Display.getDefault().asyncExec(new Runnable(){
				public void run() {
					ArrayList<NateFile>llist = list;
					File file = list.get(0).getFile();
					String realFileName = file.getAbsolutePath();
					
					//MainFrame.shell.moveAbove(null);
					MainFrame.shell.forceFocus();
					int retval = MainFrame.showMessageBox("파일전송", 
							ref.getBuddyText(viewMode)
							 + "님이 " + file.getName() + " 파일을 보내려고 합니다" +
									"\n받으시겠습니까?",
									SWT.YES | SWT.NO );
					if(retval==SWT.YES)
						nate.filemgr.procFileRecv(recv, ref, llist);
					//else
						//nate.filemgr.procFileRecv(recv, ref, llist);
					
						
				*/		
					
					
					/*
					int retval = MainFrame.showMessageBox("파일전송", 
							ref.getBuddyText(viewMode)
							 + "님이 " + file.getName() + " 파일을 보내려고 합니다" +
									"\n받기 Yes, 다른곳에 받기 No, 취소 Cancel",
									SWT.YES|SWT.NO |SWT.CANCEL);
					
					//new NateFile(filename, length, tag);
					if(retval==SWT.YES){
						nate.filemgr.procFileRecv(recv, ref, llist);
						
					}
					else if(retval==SWT.NO)
					{
						FileDialog dialog = new FileDialog (MainFrame.shell, SWT.SAVE);
						dialog.setFileName(NateFileManager.getSavePath() + NateFileManager.fileSep + realFileName);
						realFileName = dialog.open();
						if(realFileName==null){
							retval = SWT.CANCEL;
							
						}
						else
							nate.filemgr.procFileRecv(recv, ref, llist);
							//nate.filemgr.procFileRecv(ref, realFileName, filesize, cookie, true);
						
						
					}
					if(retval==SWT.CANCEL){
						//sendMessage("WHSP", list[2] + " FILE NACK%091%09" + filename + "|" + length + "|"+ tag);
						nate.filemgr.procFileRecv(recv, ref, llist);
						//ss.sendFileReject(ref, filename,filesize, cookie);
					}*/
					
			/*
				}				
			});*/
			
		}
		public void fileRecved(FileRecver recver, NateFile natefile) {
			main.fileTransferDlg.updateRow(recver, NateFileManager.STATUS_END);
			
		}
		public void fileTransferAborted(String cookie) {
			main.fileTransferDlg.fileTransferAborted(cookie);			
		}

		
	}

	public void toggleOfflineView() {
		offView= !offView;
		if(nate.isLoggedIn())
			syncAllUsers();
	}
	public MainFrame getMainFrm() {
		return this.main;
	}

	




}
