/**
 * 
 */
package kfmes.jateon.swt;


import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.util.MsgUtil;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.ToolTip;
import org.eclipse.swt.widgets.Tray;
import org.eclipse.swt.widgets.TrayItem;

/**
 * Jateon 의 트레이를 관리하는 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: JateonTray.java,v 1.25 2007/11/19 10:13:32 kfmes Exp $
 */

final public class JateonTray{
	
	protected boolean isTraySuppoted  = false;
	protected MainFrame frmmain = null;
	
	private ActionGroup action = null;
	
	Image image = null;
	protected Tray tray = null;
	private TrayItem trayitem =null; 
	private Menu menu = null;
	private TrayMenuListener listener = null;
	private ToolTip tip = null;
	private NateFriend displayFriend = null;
	
	private MenuItem mi[] = null;
	protected boolean usingTray = false;
	
	private int lastnotify = -1;
	
	/**
	 * @param frmmain
	 */
	public JateonTray(MainFrame frmmain) {
		this.frmmain = frmmain;
		action = frmmain.action;
		//initTray();
		
		
	}
	


	public boolean initTray() {
		try{
					
			tray= frmmain.display.getSystemTray();
			if(tray==null)
				throw new Exception("Tray is not supported");
				//MsgUtil.errPrintln("SysTray not supported");
			else{
				if(listener==null)
					listener = new TrayMenuListener();
			
				trayitem = new TrayItem(tray, SWT.NONE);
				
				trayitem.addListener (SWT.DefaultSelection, new Listener(){
					public void handleEvent(Event event) {

						if(frmmain.shell.isVisible())
							frmmain.shell.setFocus();
						frmmain.shell.setVisible(true);						
					}					
				});
				
				trayitem.setToolTipText("JaTeOn " + Main.version);
		
				
				//trayitem.setText("hihi");
				initTrayMenu();
				
				trayitem.addListener (SWT.MenuDetect, new Listener () {
					public void handleEvent (Event event) {
						//System.err.println("E" + event);
						menu.setVisible (true);
					}
				});
				trayitem.addSelectionListener(listener);
				
				
				image = frmmain.toolKit.getImg(UIToolKit.ImageTray);//new Image (frmmain.display, 16, 16);
				
				trayitem.setImage (image);
			}
			
			
		}
		catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		
		this.isTraySuppoted = true;
		this.usingTray  = true;
		return true;
		
	}
	
	private void initTrayMenu(){
		menu = new Menu(frmmain.shell,SWT.PUSH);

		mi = new MenuItem[6];
		
		
		for(int i=0;i<6;i++){

			if(i!=1)
				mi[i] = new MenuItem(menu, SWT.PUSH);
			else
				mi[i] = new MenuItem(menu, SWT.CASCADE);
			if(i==0||i==2) 
				new MenuItem(menu, SWT.SEPARATOR);
			mi[i].addSelectionListener( listener);
					
		}
		
		
		Menu m_subStatus = new Menu(mi[1]);
		
		MenuItem m_Status[] = new MenuItem[6];
		//	String statusString[] = { "Online", "Away", "Busy", "Phone", "Meeting", "Invisible","Offline" };
			String statusText[] = { "온라인", "자리비움", "다른용무중", "통화중", "회의중", "오프라인으로 표시" };

			for(int i=0;i<6;i++){
				m_Status[i] = new MenuItem(m_subStatus, SWT.PUSH);//  "온라인");
				m_Status[i].setText(statusText[i]);
				m_Status[i].addSelectionListener(listener);
			}
			
			mi[1].setMenu(m_subStatus);
		
		
		mi[0].setText("환경설정");
		mi[1].setText("상태 변경(&M)");
		mi[2].setText("열기");
		mi[3].setText("숨기기(&C)");
		mi[4].setText("로그아웃");
		
		mi[5].setText("끝내기(&X)");
		
		
		
		menu.setDefaultItem(mi[2]);

		
		
	}
	
	/**
	 * 로그인/로그아웃 상태가 바뀌었을 때 변경되야 할 UI 처리를 해준다.
	 */
	public void setOnline( boolean isLogin )
	{
		mi[1].setEnabled(isLogin);
		mi[4].setEnabled(isLogin);
	}
	
	
	public void setDisplayMessage(final String string, final NateFriend friend) {
		this.displayFriend = friend;
		//MsgUtil.errPrintln(string + "/" + formattedBuddy);
		Display.getDefault().asyncExec(new Runnable(){
			public void run(){
				tip =null;
			if(usingTray){
				tip =trayitem.getToolTip();// 
				if(tip==null){
					tip = new ToolTip(frmmain.getShell(), SWT.ICON_INFORMATION | SWT.BALLOON);
					if(frmmain.useTray)
						trayitem.setToolTip(tip);
					
				}
			}
			else
				tip= new ToolTip(MainFrame.shell,SWT.ICON_INFORMATION | SWT.BALLOON);
			
			
			
			tip.setText(string);
			tip.addSelectionListener(new SelectionAdapter(){
				public void widgetSelected(SelectionEvent e) {
					
					if(lastnotify!=e.time){
				
						if(frmmain.getDblClickDefaultAction()==MainFrame.DefaultActionMsg)
							action.actionSendIMsg(displayFriend);
						else
							action.actionReqChat(displayFriend);
						lastnotify = e.time;
						
					}
					
				}						
			});

			String m = displayFriend.getBuddyText(frmmain.getBuddyTree().getBuddyView());
			tip.setMessage(m);
			MsgUtil.println(m);
			tip.setVisible(true);
			tip.setAutoHide(true);
			}
		});		
		
	}
	
	
	public void disopse() {
		if(trayitem!=null)
			trayitem.dispose();
		if(tray!=null)
			tray.dispose();	
		usingTray = false;
	}

	public void removeTray() {
		// TODO 자동 생성된 메소드 스텁
		
	}
	private class TrayMenuListener implements  SelectionListener{
		

		public void widgetSelected(SelectionEvent e) {
			
			if (e.getSource() instanceof MenuItem) {
				MenuItem m = (MenuItem) e.getSource();
				
				String c = m.getText();
				if(c.equals("환경설정"))
					action.actionDetailSetting();
				else if(c.equals("열기")){
					
					if(frmmain.shell.isVisible())
						frmmain.shell.setFocus();
						
					frmmain.shell.setVisible(true);
				}
				
				else if(c.equals("숨기기(&C)"))
					frmmain.shell.setVisible(false);
				else if(c.equals("로그아웃"))
					action.actionLogout();
				else if(c.equals("끝내기(&X)"))
					action.actionQuit();
				
				else if(c.equals("온라인"))
					action.actionSetStatusOnline();
				else if(c.equals("자리비움"))
					action.actionSetStatusAway();
				else if(c.equals("다른용무중"))
					action.actionSetStatusBusy();
				else if(c.equals("통화중"))
					action.actionSetStatusPhone();
				else if(c.equals("회의중"))
					action.actionSetStatusMeeting();
				else if(c.equals("오프라인으로 표시"))
					action.actionSetStatusInvisible();


			}
			//MenuItem m = (MenuItem) e.getSource();
			
		
			
		}

		public void widgetDefaultSelected(SelectionEvent e) {
			// TODO 자동 생성된 메소드 스텁
			
			if(frmmain.shell.getMinimized())
				frmmain.shell.setMinimized(false);
		}
	}

	

	
}
