/**
 * 
 */
package kfmes.jateon.swt;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.net.URLDecoder;

import kfmes.jateon.swt.dialog.Downloader;
import kfmes.natelib.NateonMessenger;



/**
 * 자테온 메신저(SWT Ver) 시작점 
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: Main.java,v 1.51 2007/11/19 10:13:31 kfmes Exp $
 */
final public class Main {

	
	NateonMessenger nate = null;
	MainFrame main = null;

	//public static final String releaseType = "Alpha Release";
	public static final String releaseType = "Beta Release";
	public static final String ver = "0.25a";
	public static final String version = ver + ' ' + releaseType ;
	public static final String stderr = "errlog.txt";
	public static final String userHome = System.getProperty("user.home");
	public static final String osname = System.getProperty("os.name").toLowerCase();
	//private static String jateonHome ;//= substring(4, pw.lastIndexOf('/', pw.lastIndexOf('!')));
	
	
	
	public static final String authServer = "http://kfmes.com/jateonLog/";
	
	public static boolean isHigherVer(float queryVer){
		return Float.parseFloat( System.getProperty("java.specification.version")) >= queryVer;
	}
	
	public static String  getJateonPath()
	{
		java.net.URL url = kfmes.jateon.swt.Main.class.getResource("");
		String pw = null;
		if(url==null){
			return "";		
		}
		pw = url.toString();
		
		try {
			pw = URLDecoder.decode(pw 	, "UTF8");
		} catch ( java.io.UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		
		//.getPath();// .getFile();// .toString();
		//System.out.println(pw);
		
		if(pw.indexOf("jar")>=0)
			//return pw.substring(5, pw.lastIndexOf("jateon.jar")-2); 
			return pw.substring(9, pw.lastIndexOf('/', pw.lastIndexOf('!') )+1  );
		else
			return pw.substring(5, pw.lastIndexOf("kfmes"));

		
	}
	
	/**
	 * @param args
	 */
	public Main() {
		//test!!!

	}
	
	/**
	 * Jateon Messenger 시작점 
	 * @param mode 실행모드
	 */
	public void run(int mode) throws Exception { //defualt mode = 0
		nate = new NateonMessenger();
		
		if(mode==99){ //debug
			NateonMessenger.setDebugMode(true);
		
		}
		try{
			new SWTcheck();			
		}catch (Throwable t) {
			Downloader down = new Downloader();
			down.setDefaultCloseOperation(2);
			t.printStackTrace();
		}

		try{
			main = new MainFrame(nate);
		}/*catch (Exception e) {
			// TODO: handle exception
		}*/
		catch(UnsatisfiedLinkError ue){
			System.err.println("swt.jar not found!");
			ue.printStackTrace();
			System.exit(1);
		}
		catch (Throwable e) {
			File errfile = new File(Main.userHome + "/" + stderr);
			if(!errfile.exists())
				errfile.createNewFile();
			
			FileOutputStream fos= new FileOutputStream(errfile);
			
			PrintWriter err = new PrintWriter(fos);
			e.printStackTrace(err);
			err.flush();
			err.close();			
			e.printStackTrace();
			
			main.disposeAllWindow();
			

			System.exit(1);
		}

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {


		//MainFrame Jateon = new MainFrame();
		//System.out.println(Main.getJateonPath());
		
		
		
		
		try{
			String argsline = "";
			int runmode = 0 ;
			
			

			
			for(int i=0;i<args.length;i++)
				argsline += args[i] + " ";
			
			argsline = argsline.trim();
			
			Main jateonMessenger = new Main();
			
			
			if(args.length>0){
				if(argsline.indexOf("--debu9")>-1)
					runmode = 99;
				else if(argsline.indexOf("--sysvar")>-1)
				{
					System.getProperties().list( System.out );
					System.exit(0);
				}
				else if(argsline.indexOf("--clean")>-1){
					File conffile = new File(System.getProperty("user.home") + "/.jateon/" + MainFrame.conffile);
					if(conffile.exists()&&conffile.delete()){
						System.out.println("JaTeOn configuration file is removed!");
						
						
					}
					System.exit(0);
				} 
				
							
			}
			
			jateonMessenger.run(runmode);
		
		}catch (Throwable e) {
			/*
			String ee = "\n" +
					"Error - Can't run this program.\n" +
					"Check Your System\n" + 
					"JRE(Java Runtime Environment) version 1.4 or higher.\n" +
					"GUI interface (Linux X-Window, M$-Windows, etc...)\n" + 
					"For bug reporting instructions, please see:\n" +
					"<URL:http://jateon.kfmes.com>.";
			*/
			String ee = "\n" + 
					"Runtime Error has occurred.\n" +
					"For bug reporting instructions, please see:\n" +
					"<URL:http://jateon.kfmes.com>.";
			
			e.printStackTrace();
			System.err.println(ee);
			
			MainFrame.showMessageBox("Can't run this program!", e.toString()+ee, 1);
			
			

			
		}		
		

		
	}

}



