/**
 * 
 */
package kfmes.jateon.swt;

import java.io.FileOutputStream;

import kfmes.jateon.swt.dialog.FileTransferDialog;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.entity.UserStatus;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.ToolBar;

/**
 * 자테온 메인 프레임
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: MainFrame.java,v 1.43 2007/11/19 10:13:31 kfmes Exp $
 */
final public class MainFrame {

	public static Shell shell = null;
	protected Display display =null;  //  @jve:decl-index=0:
	protected MenuBar menuBar = null;
	private ToolBar toolBar = null;
	private BuddyTree buddy = null;
	
	protected NateonMessenger nate = null;
	public static final String conffile = "jateon.config.inc";  //  @jve:decl-index=0:
	public FileTransferDialog fileTransferDlg = new FileTransferDialog();
	
	protected ActionGroup action = null;
	private ConfUtil confutil;
	protected JateonTray tray = null;
	public boolean useTray = true; 
	protected UIToolKit toolKit = null;
	//private Label OwnerLabel = null;
	
	private Composite ownerStatus = null;
	private Label ownIcon = null;
	private Label ownStat = null;
	private static String errLogfile = Main.userHome + "/" + Main.stderr;
	private static FileOutputStream stderr = null;
	
	private int dblClickDefaultAction = 0;
	private Point chatwin_size = new Point(300, 200);
	private static MainFrame mainframe = null;
	
	
	protected final static int DefaultActionMsg = 0;
	protected final static int DefaultActionChat = 1;
	
	/**
	 * 
	 */
	public MainFrame() {
		run();
		
	}
	@SuppressWarnings("static-access")
	public MainFrame(NateonMessenger nate){
		this.nate = nate;
		Display.setAppName("JaTeOn");
		mainframe = this;
		display = Display.getDefault();
		//NateonMessenger.setDebugMode(true);
		
		//display.setAppName("JaTeOn - " + Main.version /*Alpha Release"*/);
		
		confutil = new ConfUtil(System.getProperty("user.home") + "/.jateon/" + conffile);
		confutil.readData();
		toolKit = new UIToolKit(this);
		createSShell();
		shell.setText("JaTeOn - " + Main.version /*Alpha Release"*/);		
		//this.loadConf();
		
		

		MusicBox.init();
		nate.filemgr.setForceUseFR(confutil.getBoolean("useFR"));
		String tmp = confutil.get("FileSavePath");
		if(tmp!=null)
			nate.filemgr.setDefaultSavePath(tmp);
		
		setGUI();
		
		
		shell.setImage(toolKit.getImg(UIToolKit.ImageMainFrame));
		
		fileTransferDlg.set(nate, this);
		fileTransferDlg.createSShell();
	/*	
		if( !UIToolkit.setLocationByPlatform(this, true) ) {
			System.err.println("Warning : Method \"setLocationByPlatform\" can't use!");
		}
		
		ownerR = new OwnerRenderer();
		ownerR.setOwnerRenderer(this);

		//initGUI();
		UIToolkit.setAlwaysOnTop(this, confutil.getBoolean("useAlwaysOnTop"));

		MusicBox.init();
		
		*/
		//run();

		menuBar.setOnline(false);
		shell.setVisible(true);
		// 아래 코드는 윈도우가 만들어진 후 수행되도록 하자
		if(confutil.getBoolean("autologin")){
			
			autoLogin();
		}
		
		if(!nate.isLoggedIn()){
			//shell.setVisible(true);
			action.actionLogin();
		}
			
		
		
		run();
		
	}
	
	static public MainFrame getMainFrame(){
		return mainframe;
	}
	
	private void setGUI() {
		if(confutil.getBoolean("DefaultAction"))
			this.dblClickDefaultAction = DefaultActionChat;
		else 
			this.dblClickDefaultAction = DefaultActionMsg;
			
		buddy.setOffview(confutil.getBoolean("offview"));
		String tmp = confutil.get("viewmode");
		if(tmp!=null)
			buddy.setBuddyView(Integer.parseInt(tmp));
		
		tmp = confutil.getString("useSound");
		
		
		MusicBox.setEnabled( !tmp.equals("noSound"));
		tmp = confutil.get("ChatWindowSize");
		if(tmp!=null){
			try{
				String s[] = tmp.split(" ");
				chatwin_size.x = Integer.parseInt(s[0]);
				chatwin_size.y = Integer.parseInt(s[1]);
				
				
			}catch (Exception e) {
			}
		}
		
		initTray();
		//display.		confutil.getBoolean("useAlwaysOnTop")
		
		
		
	}
	
	public Point getChatWinSize() {
		return this.chatwin_size;
	}
	
	
	public void setChatWinSize(Point size){
		this.chatwin_size.x = size.x;
		this.chatwin_size.y = size.y;		
	}

	private void autoLogin(){
		
		try{
			
			String loginName=null, passwd=null;
			
			String val;		
			val = confutil.get("loginName");
			if(val!=null)
				loginName = val;
			
			val = confutil.get("passwd");
			if(val!=null)
				passwd = val;
				
			nate.is_encodedpasswd = true;
			
			menuBar.setOnline(true);
			action.actionProcessLogin(loginName);//  .LoginProc(loginName);
			nate.login(loginName,passwd);	
			
			
			nate.fireBuddyListInit(nate.getBuddyGroup());
		
		}catch (Exception e) {
			e.printStackTrace();
			return ;
		}
		
	}
	
	private void run(){
		shell.open();
		
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		

		
		
	
		shell.dispose();
		
		
		System.exit(0);

	}

	/**
	 * This method initializes toolBar	
	 *
	 */


	public void toggleVisible(){
		shell.setVisible(!shell.isVisible());		
	}

	/**
	 * This method initializes shell
	 */
	private void createSShell() {
		GridData gridData1 = new GridData();
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.verticalAlignment = GridData.FILL;
		gridData1.grabExcessVerticalSpace = false;
		gridData1.horizontalIndent = 10;
		gridData1.horizontalAlignment = GridData.FILL;
		
		GridData gridData2 = new GridData();
		gridData2.grabExcessHorizontalSpace = false;
		gridData2.verticalAlignment = GridData.FILL;
		gridData2.grabExcessVerticalSpace = true;
		gridData2.horizontalAlignment = GridData.FILL;
		
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 1;
		gridLayout.verticalSpacing = 5;
		gridLayout.marginWidth = 2;
		gridLayout.marginHeight = 2;
		gridLayout.horizontalSpacing = 5;
		int swtvar = 0;
		if(confutil.getBoolean("useAlwaysOnTop"))
			swtvar += SWT.ON_TOP;
			
		shell = new Shell(SWT.SHELL_TRIM + swtvar);
		shell.setLayout(gridLayout);
		
		shell.setSize(new Point(300, 200));
		
		
		action = new ActionGroup(this,null);
		createOwnerStatus();
		ownerStatus.setLayoutData(gridData1);
		/*
		Label MyStatus = new Label(shell, SWT.NONE);
		MyStatus.setText("Hello World");
		MyStatus.setSize(new Point(300, 20));
		MyStatus.setLayoutData(gridData1);
		*/

		
		
		//ownerStatus =ownerRenderer.getLabel();
		//ownerStatus.setLayoutData(gridData1);
		buddy = new BuddyTree(shell,this);
		action.setBuddyTree(buddy);
		
		
		
		menuBar = new MenuBar(this, action);
		
		Menu menu = menuBar.getMenuBar();
		
	
		
		shell.setMenuBar(menu);
		
		shell.addShellListener(new org.eclipse.swt.events.ShellAdapter() {
			public void shellClosed(org.eclipse.swt.events.ShellEvent e) {
				
				if(tray==null ){
					action.actionQuit();
					disposeAllWindow();
					
				}else {
						
					shell.setVisible(false);		
					e.doit=false;
				}
					
				//shell.dispose();
			}
		});
		
		//buddy = new Tree(shell, SWT.NONE);
		buddy.setLayoutData(gridData2);
		/*
		Tree tmpTree = new Tree(shell, SWT.NONE);
		tmpTree.setLayoutData(gridData2);
		*/
		String location = confutil.get("FrameLocation");
		
		try{
		if(location!=null){
			String strnum[] = location.split(" ");
			int pos[] = new int[4];
			pos[0] = Integer.parseInt(strnum[0]);
			pos[1] = Integer.parseInt(strnum[1]);
			pos[2] = Integer.parseInt(strnum[2]);
			pos[3] = Integer.parseInt(strnum[3]);
			
			
			shell.setLocation(pos[0],pos[1]);
			shell.setSize(pos[2],pos[3]);

		} else {
			shell.setSize(350, 480);
		}
		}catch (/*NumberFormat*/Exception e) {
//			e.printStackTrace();
			shell.setSize(350,480);
		}
		
		
		menuBar.createToolBar(shell);
		//createToolBar();
	
		
	}
	public NateonMessenger getMessenger() {
		return this.nate;
	}
	
	
	private void initTray(){
		
		boolean useTray = confutil.getBoolean("useTray");
		
		if(useTray && tray==null)
		{		// 트레이가 사용가능하다면 트레이 활성화
			
			tray = new JateonTray(this);
			tray.initTray();
			
			if(tray.isTraySuppoted==false)
				tray = null;
		}
		else if(!useTray && tray!=null){
			tray.disopse();
			tray = null;
		}
		
		
	}
	
	public void setUserStatusNull() {
		ownIcon.setImage(toolKit.getBuddyIcon(UserStatus.Offline));
		ownStat.setText(toolKit.ownStatus(null));
	}
	
	public void updateOwnerStatus(){
		NateFriend own = nate.getOwner();
		ownIcon.setImage(toolKit.getBuddyIcon(own.getStatus()));//own.getStatus()));
		ownStat.setText(toolKit.ownStatus(own));
	
		
	//	ownerStatus= ownerRenderer.getLabel();
		//ownerStatus.repaint();
	}
	public void reset() {
		//confutil.readData();
		setGUI();		
	}
	
	
	
	public ConfUtil getConf(){
		return this.confutil;
	}
	public Shell getShell(){
		return this.shell;
	}
	public String getFrameInfo(){

		return shell.getLocation().x + " " + shell.getLocation().y + " " + shell.getSize().x + " " + shell.getSize().y;
		
		//.getLocation().x + " " + this.getLocation().y + " " +  this.getSize().getWidth() + " " + this.getSize().getHeight();
	}
	
	public BuddyTree getBuddyTree() {
		return buddy;
	}
	public int getDblClickDefaultAction() {
		return this.dblClickDefaultAction;
	}
	public void setDblClickDefaultAction(int sel){
		this.dblClickDefaultAction = sel;
		menuBar.setDblClickDefaultAction();
	}
	
	public MenuBar getMenuBar(){
		return this.menuBar;
	}
	public void addWindow(Composite c){
		buddy.addWindow(c);
	}
	public void removeWindow(Composite c){
		buddy.removeWindow(c);
	}
	protected void disposeAllWindow(){
		if(tray!=null)
			tray.disopse();
		buddy.closeAllWindows();
		
	}
	public static boolean useStyledText(){
		return kfmes.jateon.swt.Main.osname.startsWith("linux");
		
	}
		
	public static int showMessageBox(String title, String message , int type){
		MessageBox msgb = new MessageBox(shell, type);

		msgb.setMessage(message);
		msgb.setText(title);
		return msgb.open();
		
	}
	

	/**
	 * This method initializes ownerStatus	
	 *
	 */
	private void createOwnerStatus() {
		GridData gridData5 = new GridData();
		gridData5.horizontalAlignment = GridData.BEGINNING;
		gridData5.verticalAlignment = GridData.FILL;
		GridData gridData4 = new GridData();
		gridData4.horizontalAlignment = GridData.FILL;
		gridData4.grabExcessHorizontalSpace = true;
		gridData4.grabExcessVerticalSpace = true;
		gridData4.verticalAlignment = GridData.END;
		GridData gridData3 = new GridData();
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.verticalAlignment = GridData.CENTER;
		gridData3.horizontalAlignment = GridData.FILL;
		GridLayout gridLayout1 = new GridLayout();
		gridLayout1.numColumns = 2;
		gridLayout1.marginHeight = 0;
		gridLayout1.marginWidth = 0;
		ownerStatus = new Composite(getShell(), SWT.NONE);
		ownerStatus.setLayout(gridLayout1);
		ownerStatus.setLayoutData(gridData3);
		ownIcon = new Label(ownerStatus, SWT.NONE);
		ownIcon.setImage(toolKit.getBuddyIcon(UserStatus.Offline));
		ownIcon.setLayoutData(gridData5);
		
		ownStat = new Label(ownerStatus, SWT.NONE);
		ownStat.setText(toolKit.ownStatus(null));
		ownStat.setLayoutData(gridData4);
	}


}
