/**
 * 
 */
package kfmes.jateon.swt;

import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.entity.UserStatus;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

/**
 * jateon UI에 사용되는 여러가지 
 * 자원들을 모아놓은 클래스이다. 
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: UIToolKit.java,v 1.22 2007/11/19 10:13:31 kfmes Exp $
 */
final public class UIToolKit {

	//icon lists
	/*
	public static final String iconChat = "chat.gif";
	public static final String iconSMS = "sms.gif";
	public static final String iconMain = "jateon.gif";
	public static final String iconMsg = "msg.gif";
	public static final String iconSetting = "setting.gif";
	public static final String iconTray = "tray.gif";
	*/

	private MainFrame main = null;
	private Shell shell = null;
	private Display disp = null;
	
	private Image imgChat = null;
	private Image imgMain = null;  //  @jve:decl-index=0:
	private Image imgTray = null;
	public static Image DefaultImage = null;
	
	private Image buddyImg[] = null;  //  @jve:decl-index=0:
	
	public final static int BuddyOnline = 1;
	public final static int BuddyAway = 2;
	public final static int BuddyBusy = 3;
	public final static int BuddyPhone = 4;
	public final static int BuddyMeeting = 5;
	public final static int BuddyOffline = 6;
	public final static int BuddyGroup = 7;
	public final static int BuddyOnBlocked = 8;
	public final static int BuddyOffBlocked = 9;
	
	public final static int ImageMainFrame = 10;
	public final static int ImageTray= 11;
	
	private int idx = 0;
	
	private Shell sShell = null;  //  @jve:decl-index=0:visual-constraint="50,50"
	private Label label = null;
	private Label label1 = null;
	private Button button = null;
	private Button button1 = null;
	
	
	public UIToolKit(MainFrame main) {
		this.main = main;
		this.shell = main.shell;
		this.disp = main.display;
		
		init();
	}

	public UIToolKit() {
		
		Display display = Display.getDefault();
		
		createSShell();
		init();
		sShell.open();
		
		while (!sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		
		display.dispose();
	}

	public Image getImage(String path, int width, int height ){
	
		return new Image(Display.getDefault(), 
				new Image(Display.getDefault(),
						path )
						//ClassLoader.getSystemResourceAsStream(path))
						
						//ClassLoader.getSystemResourceAsStream("resources/"+path))
						//getClass().getClassLoader().getSystemResourceAsStream("resources/"+path))
						//UIToolKit.class.getResourceAsStream("resources/"+path))
		.getImageData().scaledTo(width, height));
		/*
		return new Image(Display.getDefault(), 
				new Image(Display.getDefault(), 
						UIToolKit.class.getResourceAsStream("resources/"+path))
		.getImageData().scaledTo(width, height));
		*/
	}
	
	public Image getImage( String path )
	{
		
		Image img = null;
		
	//resources/icon/
		try{	
			/*
			InputStream in =
				ClassLoader.getSystemResourceAsStream(path);
				//UIToolKit.class.getResourceAsStream("resources/" + path);
				 
				 */
			img = new Image(Display.getCurrent(), path);
			//in.close();
		}catch (Exception e) {
			e.printStackTrace();
		}	
		return img;
	}
	public Image getBuddyIcon(int status){
		return buddyImg[status-1];
	}
	public Image getImg(int imgcode){
		switch (imgcode) {
		case ImageMainFrame:
			return imgMain;
		case ImageTray:
			return imgTray;
			
		default:
			break;
		}
		return imgMain;
	}
	
	public Image getBuddyIcon(String status) {

		if(status ==null || status.equals(UserStatus.Offline))
			return getBuddyIcon(BuddyOffline);
		if(status.equals(UserStatus.ON_Blocked))
			return getBuddyIcon(BuddyOnBlocked);
		if(status.equals(UserStatus.OFF_Blocked))
			return getBuddyIcon(BuddyOffBlocked);
				
		if( status.equals(UserStatus.Away) ||
			status.equals(UserStatus.Meeting) )
			return getBuddyIcon(BuddyAway);
		if( status.equals(UserStatus.Busy) ||
				status.equals(UserStatus.Phone))
			return getBuddyIcon(BuddyPhone);
		if( status.equals(UserStatus.Offline) ||
				status.equals(UserStatus.Invisible) )
			return getBuddyIcon(BuddyOffline);
		
		
		return getBuddyIcon(BuddyOnline);
	}

	
	
	public String ownStatus(NateFriend own){
		if(own==null)
			return "로그인 되지 않음";
		return  own.getNickName().replaceAll("%20", " ").replaceAll("%25", "%") +"(" + own.getFormattedStatus() + ")" ;
		
	}

	private void init(){
		
		String iconlist[] = {
				//on,	away,	busy,	 phone,	meeting, 	off ,	 group
				"on" ,	"away",	"busy",	 "busy", 	"busy",		"off",  "group" , "block_on" , "block_off"
				};
		String resPath= null;
		
			resPath = Main.getJateonPath() //+ File.separator 
			+ "resources/";
		//MsgUtil.err.println(resPath);
		buddyImg = new Image[iconlist.length];
		
		for(int i=0;i<iconlist.length;i++){
			buddyImg[i] = getImage(resPath + "icon/" + iconlist[i] + ".gif", 20,20);
			/*
			Label f =new Label(sShell, SWT.NONE );
			f.setImage(buddyImg[i]);*/
		}
		
		imgMain = getImage(resPath + "icon/jateon.png");
		DefaultImage = imgMain;
		if(Main.osname.startsWith("windows") || Main.osname.startsWith("mac"))
				imgTray = getImage(resPath + "icon/tray.png");
		//else if(Main.osname.startsWith("mac"))
			//imgTray = getImage(resPath + "icon/jateon.png", 20,20);
		else
			imgTray = getImage(resPath + "icon/tray.png", 20,20);
				
		
		//, 16,16);//, 32,32);
		//imgTray = getImage(resPath + "icon/tray.gif", 20,20);
			
	}

	/**
	 * This method initializes sShell	
	 *
	 */
	private void createSShell() {
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 4;
		sShell = new Shell();
		sShell.setLayout(gridLayout);
		sShell.setSize(new Point(374, 209));
		label = new Label(sShell, SWT.NONE);
		//label.setImage());
		label.setText("d");
		
		label1 = new Label(sShell, SWT.NONE);
		label1.setText("Label");
		button = new Button(sShell, SWT.ARROW | SWT.LEFT);
		button.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				idx --;
				if(idx<1)
					idx=1;
				label.setImage(getBuddyIcon(idx));
				label1.setText(":" + idx);/*
				label.pack();
				label.update();*/
				
			}
		});
		button1 = new Button(sShell, SWT.ARROW | SWT.RIGHT);
		button1.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				
				idx ++;
				if(buddyImg.length-1<idx)
					idx--;
				label.setImage(getBuddyIcon(idx));
				label1.setText(":" + idx);
				label.pack();
				label.update();
				
			}
		});
	}

	public static void main(String[] args){
		new UIToolKit();
	}


}
