/**
 * 
 */
package kfmes.jateon.swt.dialog;

import java.io.File;
import java.net.URLClassLoader;

import kfmes.jateon.plugin.Control;
import kfmes.jateon.plugin.Plugin;
import kfmes.jateon.swt.BuddyTree;
import kfmes.jateon.swt.MainFrame;
import kfmes.jateon.swt.MusicBox;
import kfmes.jateon.swt.UIToolKit;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.SwitchBoardSession;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.msg.MimeMessage;
import kfmes.natelib.util.DateUtil;
import kfmes.natelib.util.MsgUtil;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.custom.StyledTextContent;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.ShellAdapter;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * 채팅 윈도우
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: ChatWindow.java,v 1.36 2007/11/19 10:13:29 kfmes Exp $
 */
public final class ChatWindow {

	private Shell sShell = null;
	private Label lbl_Typing = null;
	private Button btn_menu = null;
	private Menu menu = null;
	private Label lbl_recvUser = null;
	private SashForm sashForm = null;
	private Composite cpz_txt_area = null;
	private Composite cpz_input_area = null;
	private StyledText txt_area = null;
	private StyledText txt_sinput =null;
	private Text txt_input = null;
	private Button btn_send = null;
	private NateonMessenger nate;
	private BuddyTree parentTree;
	private SwitchBoardSession ss;  //  @jve:decl-index=0:
	private NateFriend recvUser;  //  @jve:decl-index=0:
	private int recvUserCnt = 0;
		
	private boolean isTyping = false;
	
	private CListener listener = new CListener();  //  @jve:decl-index=0:

	/**
	 * This method initializes sashForm	
	 *
	 */
	private void createSashForm() {
		GridData gridData2 = new GridData();
		gridData2.horizontalSpan = 4;
		gridData2.verticalAlignment = GridData.FILL;
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.grabExcessVerticalSpace = true;
		gridData2.horizontalAlignment = GridData.FILL;
		sashForm = new SashForm(sShell, SWT.NONE);
		sashForm.setOrientation(SWT.VERTICAL);
		
		createCpz_txt_area();
		sashForm.setLayoutData(gridData2);
		createCpz_input_area();
		sashForm.setWeights(new int[] {80,20} );
		
	}

	/**
	 * This method initializes cpz_txt_area	
	 *
	 */
	private void createCpz_txt_area() {
		GridLayout gridLayout2 = new GridLayout();
		gridLayout2.marginWidth = 0;
		gridLayout2.marginHeight = 0;
		GridData gridData3 = new GridData();
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.verticalAlignment = GridData.FILL;
		gridData3.grabExcessVerticalSpace = true;
		cpz_txt_area = new Composite(sashForm, SWT.NONE);
		cpz_txt_area.setLayout(gridLayout2);
		txt_area = new StyledText(cpz_txt_area, SWT.READ_ONLY| SWT.BORDER |  SWT.V_SCROLL);
		txt_area.setLayoutData(gridData3);
		txt_area.setWordWrap(true);
	}

	/**
	 * This method initializes cpz_input_area	
	 *
	 */
	private void createCpz_input_area() {
		GridData gridData5 = new GridData();
		gridData5.horizontalAlignment = GridData.FILL;
		gridData5.verticalAlignment = GridData.FILL;
		GridData gridData4 = new GridData();
		gridData4.grabExcessHorizontalSpace = true;
		gridData4.horizontalAlignment = GridData.FILL;
		gridData4.verticalAlignment = GridData.FILL;
		gridData4.grabExcessVerticalSpace = true;
		GridLayout gridLayout1 = new GridLayout();
		gridLayout1.numColumns = 2;
		gridLayout1.marginHeight = 0;
		gridLayout1.verticalSpacing = 5;
		gridLayout1.marginWidth = 0;
		cpz_input_area = new Composite(sashForm, SWT.NONE);
		cpz_input_area.setLayout(gridLayout1);
		if(!MainFrame.useStyledText()){
			txt_input = new Text(cpz_input_area, SWT.BORDER|SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);//StyledText(cpz_input_area, SWT.BORDER| SWT.V_SCROLL);
			txt_input.setLayoutData(gridData4); 
		}
		else{
			txt_sinput = new StyledText(cpz_input_area, SWT.BORDER|SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);//StyledText(cpz_input_area, SWT.BORDER| SWT.V_SCROLL);
			txt_sinput.setLayoutData(gridData4);
		}
		

			
		
	
		
		btn_send = new Button(cpz_input_area, SWT.NONE);
		btn_send.setText("보내기");
		btn_send.setLayoutData(gridData5);
	}

	private void autoScroll(StyledText st) {
		if(st==null)
			st = txt_area;
		StyledTextContent doc = st.getContent();
		int docLength = doc.getCharCount();
		if (docLength > 0) {
			st.setCaretOffset(docLength);
			st.showSelection();
		}
	}
	
	/**
	 * Dummy Default Constructor
	 *
	 */
	public ChatWindow() {
		
	}
	
	public ChatWindow(NateonMessenger nate, BuddyTree parenttree, SwitchBoardSession ss, NateFriend fr) {
		
		
		setChatWindow(nate, parenttree, ss, fr);
		createSShell();
		
		setChatWin();
		sShell.setVisible(true);
		if(txt_sinput!=null) txt_sinput.setFocus();
		else txt_input.setFocus();
		
		sShell.open();
		while (!sShell.isDisposed()) {
			if (!Display.getDefault().readAndDispatch())
				Display.getDefault().sleep();
		}
		dispose();
		sShell.dispose();
		
		//this.setFocusableWindowState(false);
		
//		setVisible(true);
		//this.setFocusableWindowState(true);
		
		//
	//	smsg.requestFocus();
	}
	
	public ChatWindow(NateonMessenger nate, BuddyTree parenttree, SwitchBoardSession ss, NateFriend recv, NateFriend friend, MimeMessage mime) {
		setChatWindow(nate, parenttree, ss, friend);
		createSShell();
		
		setChatWin();
		sShell.setVisible(true);
		incoming(friend, mime);
		
		
		sShell.open();
		while (!sShell.isDisposed()) {
			if (!Display.getDefault().readAndDispatch())
				Display.getDefault().sleep();
		}
		dispose();
		sShell.dispose();
	}

	public void send() {
		
		
		String smsg = null;
		if(txt_sinput!=null)
			smsg = txt_sinput.getText().replaceAll("\r\n", "\n");
		else
			smsg = txt_input.getText().replaceAll("\r\n", "\n");
		
		
		/*
		if(smsg.endsWith("\r\n"))
			smsg = smsg.substring(0, smsg.length()-2);
		else*/
		if(smsg.endsWith("\n"))
			smsg = smsg.substring(0, smsg.length()-1);
		
		if(smsg.length()==1 && smsg.indexOf('\n')>0)
			smsg = "";
					
		
		if(smsg.length()==0 ){
			if(txt_sinput!=null)
				txt_sinput.setText("");
			else
				txt_input.setText("");
			return ;
		}
		
		if(ss.getFriendCount()==0){
			parentTree.removeChatWindow(ss);
			
			ss = nate.getNS().procOpenChat(nate.getOwner().getID(), recvUser.getID());
			parentTree.addChatWindow(this, ss);
		}
		
		boolean success = ss!=null ? ss.sendMessage(smsg) : false;
		if(success){
			txt_area.append("\n" + nate.getOwner().getNameNick() + " says : \n");
			
			//		+ txt_input.getText());
			
			int curline = txt_area.getLineCount()-1;
			
			if(txt_sinput!=null)
				txt_area.append(txt_sinput.getText());
			else			
				txt_area.append(txt_input.getText());
			
			txt_area.setLineIndent(curline , txt_area.getLineCount()-curline , 15);
			
			if(txt_sinput!=null){
				txt_sinput.setText("");
				txt_sinput.setFocus();
			}
			else{
				txt_input.setText("");
				txt_input.setFocus();
			}
			autoScroll(txt_area);
		}
			
		else			
		{// 전송에 실패했을 경우
			txt_area.append("\n 전송 실패!\n");
			int curline = txt_area.getLineCount()-1;
			
			if(txt_sinput!=null)
				txt_area.append(txt_sinput.getText());
			else			
				txt_area.append(txt_input.getText());
			txt_area.setLineIndent(curline , txt_area.getLineCount()-curline , 15);
			
			if(txt_sinput!=null){
				txt_sinput.setText("");
				txt_sinput.setFocus();
			}
			else{
				txt_input.setText("");
				txt_input.setFocus();
			}
			autoScroll(txt_area);
			
		}

		isTyping = false;
		
		
	}

	public void setChatWindow(NateonMessenger nate, BuddyTree parenttree, SwitchBoardSession ss, NateFriend fr) {
		this.nate = nate;
		this.parentTree = parenttree;
		this.ss= ss;
		this.recvUser = fr;
		this.parentTree= parenttree;
		
		//makeSwtichBoardSession();
	}
	private void setChatWin(){
		if(recvUser==null)
			recvUser = new NateFriend("null");
		if(ss==null || !ss.isConnected())
			ss = nate.getNS().procOpenChat(nate.getOwner().getID(), recvUser.getNateID());
		lbl_recvUser.setText(recvUser.getNameNick());
		parentTree.addChatWindow(this, ss);
		
		if(txt_sinput!=null){
			txt_sinput.setFocus();
		}
		else{
			txt_input.setFocus();
		}

		
		

	}
	
	
	public SwitchBoardSession getSS() {
		return this.ss;
	}
	public NateFriend getLastRecvUser(){
		if(this.recvUserCnt==1)
			return recvUser;
		return null;
	}
	
	public void shellDispose(){
		//if(!sShell.isDisposed())
		if(sShell.isVisible() || !sShell.isDisposed())
			
			sShell.dispose();
	}
	
	
	public void dispose(){
	//	parentTree.getMainFrm().setChatWinSize(curSize);
		parentTree.removeChatWindow(this.ss);
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO 자동 생성된 메소드 스텁
		/* Before this is run, be sure to set up the launch configuration (Arguments->VM Arguments)
		 * for the correct SWT library path in order to run with the SWT dlls. 
		 * The dlls are located in the SWT plugin jar.  
		 * For example, on Windows the Eclipse SWT 3.1 plugin jar is:
		 *       installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
		 */
		Display display = Display.getDefault();
		ChatWindow thisClass = new ChatWindow();
		thisClass.createSShell();
		
		thisClass.sShell.open();

		while (!thisClass.sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}
	
	private void setTitleBar(String friendDisp){

		sShell.setText(
				(friendDisp.length()>12 ? friendDisp.substring(0,12) + "... " : friendDisp)
						+ "님과의 대화");
	}

	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		GridData gridData = new GridData();
		gridData.grabExcessHorizontalSpace = true;
		gridData.verticalAlignment = org.eclipse.swt.layout.GridData.CENTER;
		gridData.horizontalSpan = 2;
		gridData.heightHint = -1;
		gridData.horizontalIndent = 0;
		gridData.horizontalAlignment = GridData.FILL;
		GridData gridData1 = new GridData();
		gridData1.grabExcessHorizontalSpace = false;
		gridData1.verticalAlignment = org.eclipse.swt.layout.GridData.CENTER;
		gridData1.horizontalAlignment = GridData.BEGINNING;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 4;
		gridLayout.verticalSpacing = 5;
		gridLayout.marginWidth = 2;
		gridLayout.marginHeight = 2;
		gridLayout.horizontalSpacing = 5;
		sShell = new Shell(/*MainFrame.shell*/ Display.getDefault(),
				SWT.SHELL_TRIM
				/*
				SWT.NORMAL |SWT.TITLE | SWT.RESIZE | SWT.MODELESS | SWT.MIN | SWT.MAX*/);
		sShell.setImage(UIToolKit.DefaultImage);
		
		//sShell.setText("대화 하기");
		if(recvUser!=null)
			setTitleBar(recvUser.getBuddyText(parentTree.getBuddyView()));
		
		btn_menu = new Button(sShell, SWT.NONE);
		btn_menu.setText("메뉴!");
		menu = new Menu(sShell, SWT.POP_UP);
		
		//MenuItem[] mi = new MenuItem[10];
		//for(int i=0;i<10;i++)
			//mi[i] = new MenuItem(menu,SWT.PUSH);
		MenuItem[] mi = new MenuItem[3];
		
		mi[0] = new MenuItem(menu, SWT.PUSH);
		mi[0].setText("파일 보내기");
		mi[0].addSelectionListener(new SelectionAdapter(){
			public void widgetSelected(SelectionEvent e){
				FileDialog fd = new FileDialog(sShell);
				fd.setText("보낼 파일을 선택하세요");
				String file = fd.open();
				if(file!=null){
					File f = new File(file);
					if(f.exists() && f.canRead() && f.isFile())
						nate.filemgr.procFileSend( ss.getNateFriend(), f,ss );
						
				}
			}
		});
		
		mi[1] = new MenuItem(menu, SWT.PUSH);
		mi[1].setText("초대하기");
		
		mi[1].addSelectionListener(new SelectionAdapter(){
			public void widgetSelected(SelectionEvent e){
				ChatInviteDialog cid = new ChatInviteDialog(sShell, nate );
				//cid.do
			}
		});
		
		/*
		mi[2] = new MenuItem(menu, SWT.PUSH);
		mi[2].setText("화이트보드");
		
		mi[2].addSelectionListener(new SelectionAdapter(){
			public void widgetSelected(SelectionEvent e){
				
				System.err.println("wb");
				Control control = new Control( MainFrame.getMainFrame(), nate);
				
				control.setSS(ss);
				wb.initControl(control);
				
				wb.runPlugin();
				
				
				//ChatInviteDialog cid = new ChatInviteDialog(sShell, nate );1
				//cid.do
			}
		});
		*/
		
		btn_menu.addSelectionListener(new SelectionAdapter(){
			public void widgetSelected(SelectionEvent e) {
				//MainFrame.showMessageBox("미구현", "미구현 기능입니다", SWT.ICON_INFORMATION);
				//FIXME:
				
				Rectangle rect = btn_menu.getBounds ();
				Point pt = new Point (rect.x, rect.y + rect.height -5);
				pt = btn_menu.toDisplay (pt);
				menu.setLocation (pt.x, pt.y);
				menu.setVisible (true);
				
			}
		});
			
			
		///ToolItem toolItem = new ToolItem(toolBar, SWT.DROP_DOWN);
		
		
		
		lbl_Typing = new Label(sShell, SWT.NONE);
		lbl_Typing.setText("   ");
		lbl_Typing.setLayoutData(gridData1);
		lbl_recvUser = new Label(sShell, SWT.NONE);
		lbl_recvUser.setText("recv");
		lbl_recvUser.setLayoutData(gridData);
		sShell.setLayout(gridLayout);
		createSashForm();
		sShell.setSize( this.parentTree.getMainFrm().getChatWinSize() );
		//new Point(300, 200));
		
		//sShell.setDefaultButton(btn_send);
		if(txt_sinput!=null){
			txt_sinput.addKeyListener(listener);
		}
		else{
			txt_input.addKeyListener(listener);
		}
		

		btn_send.addSelectionListener(listener);
		sShell.addDisposeListener(listener);
		
		DropTarget dt = new DropTarget(sashForm, 
				DND.DROP_DEFAULT | DND.DROP_MOVE);
		dt.setTransfer(new Transfer[] { FileTransfer.getInstance() } );

		dt.addDropListener(new DropTargetAdapter(){
			public void drop(DropTargetEvent event) {
				String fileList[] = null;
				FileTransfer ft = FileTransfer.getInstance();
				if (ft.isSupportedType(event.currentDataType)) {
					fileList = (String[])event.data;    
					}
				//ss.send("WHSP", )
				//WHSP 0 A@nate.com FILE REQUEST%091%09FILE!!.txt|377|15:100254215:967
				//WHSP 10 A@nate.com FILE REQUEST%091%09OS_finalterm07_answer.hwp|69120|13:1037613324:613
				// WHSP 2 A@nate.com FILE REQUEST%091%09OS_finalterm07_answer.hwp|69120|6:1037613324:901
				
				
				//NATE:WHSP 10 B@dreamwiz.com FILE REQUEST%091%09OS_finalterm07_answer.hwp|69120|9:100254215:16
				//          WHSP 2 A@nate.com FILE REQUEST%091%09OS_finalterm07_answer.hwp|69120|6:1037613324:901
				//WHSP 2 A@nate.com FILE REQUEST%091%09OS_finalterm07_answer.hwp|69120|4:100254215:235
				//WHSP 4 A@nate.com FILE REQUEST%091%09|69120OS_finalterm07_answer.hwp|2:100254215:901
				//WHSP 2 A@nate.comFILE REQUEST%091%09OS_finalterm07_answer.hwp|0:100254215:353
				//
			
				if(fileList.length>0){
					File file = new File(fileList[0]);
					nate.filemgr.procFileSend( ss.getNateFriend(), file,ss );
				}
					

				
			}

			
		});
		//	
		
		txt_area.append("대화 시작 ".concat(DateUtil.toTextString()));
		txt_area.setStyleRange(new StyleRange(0, txt_area.getText().length(),
				Display.getDefault().getSystemColor(SWT.COLOR_BLUE),
				Display.getDefault().getSystemColor(SWT.COLOR_WHITE)));
		
		
		sShell.addShellListener(new ShellAdapter(){

			public void shellClosed(ShellEvent e) {
				parentTree.getMainFrm().setChatWinSize(sShell.getSize());
				
			}
		});
	
	}

	public void flashing() {
		Display.getCurrent().beep();	
		//Display.getDefault().beep();
		//Display.getDefault().
		//sShell.setActive();
		//sShell.forceActive();
	}
	

	public boolean isVisible() {
		return this.sShell.isVisible();
	}
	
	public void incoming(NateFriend friend, MimeMessage mime) {
		if(friend==null) friend = new NateFriend("null");
		String from = friend.getNameNick(); 
		String msg = null;
		//TODO DEBUG
		//MsgUtil.println(mime.getMessage());
		lbl_Typing.setText("  ");
		
		if(mime.getType().equals("QUIT")&&ss.getFriendCount()<1){//상대방이 창을 닫았다!!
			//txt_area.append("\n" + from + " 대화방 나감");
			this.ss.close();
			//this.ss  = null;
		}
		else{
			if(sShell.getMinimized())
				sShell.setMinimized(false);
			
			if(sShell.getVisible()==false ){
				MusicBox.play(MusicBox.SOUND_CHAT);
				sShell.setVisible(true);
			}
			
			String display_recvUser ;
			if(friend==null || friend.getNateID().equals("null"))
				display_recvUser = "";
			else
				display_recvUser = friend.getBuddyText(parentTree.getBuddyView());
			 
				
			
			if(recvUser!=friend)
				recvUser = friend;
			this.recvUserCnt = this.ss.getFriendCount();
			
			lbl_recvUser.setText(display_recvUser);
			if(!mime.isSuccess()){
				msg = "전송 실패!";
			}
			else{
				msg = mime.getMessage().replaceAll("%20", " ").replaceAll("%25", "%").replaceAll("%0A", "\n").replaceAll("%0D", "");
				
				txt_area.append("\n" + from + " says : \n");
			}
			if(recvUser!=null && !recvUser.getNateID().equals("null"))
				setTitleBar(recvUser.getBuddyText(parentTree.getBuddyView()));
			//txt_area.setLineSpacing(2);
			int curline = txt_area.getLineCount()-1;
			txt_area.append(msg);
			txt_area.setLineIndent(curline , txt_area.getLineCount()-curline , 15);

		//);  " + msg);
			//txt_area.setLineSpacing(0);
		}
		autoScroll(txt_area);
		
		flashing();  
		
	}
	public void progressTyping(NateFriend friend, int flag) {
		if(friend==null)
			return;
		if(flag==0)
			lbl_Typing.setText("  ");
		else{
			lbl_recvUser.setText( friend.getBuddyText(parentTree.getBuddyView()));
			lbl_Typing.setText("..");
		}
		
	}
	
	private class CListener implements  SelectionListener, KeyListener, DisposeListener{

	

		public void widgetDefaultSelected(SelectionEvent e) {
			MsgUtil.println(e.getSource().toString());
			
		}

		public void widgetSelected(SelectionEvent e) {
			send();
			
		}

		public void keyPressed(KeyEvent e) {
			if(e.stateMask == SWT.CTRL && e.keyCode==SWT.CR)
			{
			}			
			else if(e.keyCode==SWT.CR || e.keyCode == SWT.KEYPAD_CR){
				e.doit =false;
				send();
			}

		}

		public void keyReleased(KeyEvent e) {
			int charCount = txt_sinput!=null ? txt_sinput.getCharCount() : txt_input.getCharCount();

			if((isTyping && charCount==0) ){
				isTyping = false;
				if(ss!=null)
					ss.progressTyping(0);
			}
			else if(isTyping==false && charCount>0){
				isTyping = true;
	
				if(ss==null || !ss.isConnected())
					ss = nate.getNS().procOpenChat(nate.getOwner().getID() , recvUser.getNateID());
				
				if(ss!=null && ss.isConnected())
					ss.progressTyping(1);
			}			
		}

		public void widgetDisposed(DisposeEvent e) {
			if(ss!=null){
				ss.close();			
				ss=null;
				}
		}		
	}

}
