/**
 * 
 */
package kfmes.jateon.swt.dialog;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Method;
import java.net.URL;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;

import kfmes.natelib.util.MsgUtil;

/**
 * SWT 라이브러리를 사용할 수 없는경우, 자동으로 다운받는 클래스
 * Swing 으로 만들어졌기 때문에 독립적으로 실행이 가능하다
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: Downloader.java,v 1.16 2007/11/19 10:13:30 kfmes Exp $
 */
public class Downloader extends JFrame{

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private final int OS_UNKNOWN = 0;
	private final int OS_WINDOWS = 1;
	private final int OS_LINUX= 2;
	private final int OS_MAC= 3;
	
	private int remoteFileSize  = -1;
	private int writtenSize  = -1;
	private int per;
	
	private String remotefile = null;
	private String fs = System.getProperty("file.separator");


	private JTextArea jTextArea = null;
	private JProgressBar jProgressBar = null;


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Downloader d  = new Downloader();
		d.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}

	/**
	 * This is the default constructor
	 */
	public Downloader() {
		super();
		initialize();
		
		
		String os = System.getProperty("os.name");
		String msg = "OS name : " + os + "\n";

		int oscode = supportedOS();
		msg += "OS버전에 맞는 swt.jar 파일을 다운 받고 있습니다." ;//+
				
		
		jTextArea.setText(msg);
		
		this.setVisible(true);
		
		
		
		
		switch (oscode) {
		case OS_WINDOWS:
			remotefile = "swt_win32.jar";
			remoteFileSize = 1399412;
				
			break;
		case OS_LINUX:
			String arch = System.getProperty("sun.arch.data.model"); 
			if(arch == null || arch.equals("32")){
				remotefile = "swt_linuxgtk.jar";
				remoteFileSize = 1245295;
			}
			else{
				remotefile = "swt_linuxgtk64.jar";
				remoteFileSize = 1245295;
			}
			break;
		case OS_MAC:
			remotefile = "swt_mac.jar";
			remoteFileSize = 1273473;
			break;				
		default:
			error();
			break;
		}
		

		InputStream is = null;
		
		try{
			//String remotefile = "swt_win32.jar";
			String url = "http://jateon.kfmes.com/swt33/" + remotefile;
			
			if((!url.startsWith("http://")) && (!url.startsWith("HTTP://")) && (!url.startsWith("file://")))
				url = "http://" + url;
						
			URL Url = new URL( url);
			
			
			InputStream remoteInputStream = Url.openConnection().getInputStream();
			

			//File jateonRoot = new File(this.getClass().getResource("").getFile() ).getParentFile().getParentFile().getParentFile();
			File local =  new File( "lib" + fs + "swt.jar");			
//			File local =  new File(jateonRoot + fs + "lib" + fs + "swt.jar");
			MsgUtil.println(local.getAbsolutePath());
			
			if(!local.exists())
				if(local.createNewFile()==false) 
					error();
			
	
			FileCopy(remoteInputStream, local);
			
			jTextArea.append("\n다운로드가 완료되었습니다.\n자테온을 재실행해 주세요\n\n이 창은 3초후에 사라집니다");
			
			Thread.sleep(3000);
		
			
		}		
		catch (Exception e) {
			e.printStackTrace();
			error();
		}
		
		System.exit(0);
		
		//run();
		
	}
	
	private void FileCopy(InputStream src, File dst) throws Exception{
        
		OutputStream out = new BufferedOutputStream(
				new FileOutputStream(dst));
		byte[] buf = new byte[1024];
		int numRead ;
		
		writtenSize = 0;

		jProgressBar.setMaximum(99);
		jProgressBar.setValue(0);
		
		while((numRead=src.read(buf)) !=-1){
			out.write(buf, 0, numRead);
			writtenSize+=numRead;			
			per = (int)((double)writtenSize/remoteFileSize * 100);
			SwingUtilities.invokeLater(new Runnable(){
				public void run() {
					jProgressBar.setValue(per);
				}
			});
        	}
				
		src.close();
        out.close(); 
     
	}


	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("Downloader");
		Dimension d =Toolkit.getDefaultToolkit().getScreenSize();
		
		this.setLocation(d.width/2 - 150, d.height/2-100);
		
		Method m = null;
		try {
			m = this.getClass().getMethod("setAlwaysOnTop", new Class[] { Boolean.TYPE });
			m.invoke(this, new Object[] { Boolean.TRUE } );
			/*if(alwaysOnTop)
				m.invoke(window, new Object[] { Boolean.TRUE } );
			else 
				m.invoke(window, new Object[] { Boolean.FALSE } );
				*/
		}
		catch( NoSuchMethodError e ) {
			
		}
		catch( NoSuchMethodException e ) {
			
		}
		catch( Exception e ) {
		}
		
		
	}
	private int supportedOS(){
		String os = System.getProperty("os.name");
		String []osarr = {"windows", "linux", "mac"};
		
		for(int i=0;i<osarr.length;i++){
			if(os.toLowerCase().startsWith(osarr[i]))
					//osarr[i].startsWith(os.toLowerCase()))
				return i+1;
		}
		
		
		return OS_UNKNOWN;
		
	}
	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {

			
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jTextArea = new JTextArea();
			jProgressBar = new JProgressBar();
			jContentPane.add(jTextArea, BorderLayout.CENTER);
			jContentPane.add(jProgressBar, BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	private static void error() {
		
		JOptionPane.showMessageDialog(null, "http://eclipse.org/swt 에서\n" +
		"해당 OS의 swt.jar(버전3.3) 파일을 직접구하세요\n");
		System.exit(1);
		
	}
	

}
