/**
 * 
 */
package kfmes.jateon.swt.dialog;

import java.util.ArrayList;

import kfmes.jateon.swt.MainFrame;
import kfmes.jateon.swt.UIToolKit;
import kfmes.natelib.NateFileManager;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.SwitchBoardSession;
import kfmes.natelib.entity.NateFile;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.ftp.AbstractTransfer;
import kfmes.natelib.ftp.FileRecver;
import kfmes.natelib.ftp.FileSender;
import kfmes.natelib.util.MsgUtil;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Label;

/**
 * 파일 전송 모니터 다이얼로그
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: FileTransferDialog.java,v 1.10 2007/11/19 10:13:31 kfmes Exp $
 */
public class FileTransferDialog extends Thread{

	private Shell sShell = null;
	private Display display = null;//Display.getCurrent();  //  @jve:decl-index=0:
	private Table table = null;
	private TableEditor editor = null;
	private Composite btn_ctrl = null;
	private Button btn_cancel_all = null;
	private Button btn_accept_all = null;
	private String[] th = { "상태" , "아이디" , "파일명", "크기", "진행"};
	private NateonMessenger nate;
	private MainFrame main;
	private boolean isopened = false;
	private ArrayList<Integer> state = new ArrayList<Integer>();
	
	private Listener listener = new Listener();
	
	//private Monitor monitor = new Monitor();
	
	private String status_str[] = { "받기", "응답대기" , "보내는중" , "받는중" , "완료", "실패"};
	private Button btn_clear_all = null;
	private Button btn_cancel = null;
	private Label lbl_info = null;
	private Button btn_hide = null;
	

	/**
	 * This method initializes btn_ctrl	
	 *
	 */
	private void createBtn_ctrl() {
		GridData gridData3 = new GridData();
		gridData3.horizontalSpan = 5;
		GridData gridData2 = new GridData();
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.verticalAlignment = GridData.CENTER;
		gridData2.horizontalAlignment = GridData.END;
		GridData gridData1 = new GridData();
		gridData1.grabExcessHorizontalSpace = false;
		gridData1.grabExcessVerticalSpace = false;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 5;
		btn_ctrl = new Composite(sShell, SWT.NONE);
		btn_ctrl.setLayout(gridLayout);
		btn_ctrl.setLayoutData(gridData2);
		lbl_info = new Label(btn_ctrl, SWT.NONE);
		lbl_info.setText("파일목록을 더블클릭하면 파일전송이 시작됩니다");
		lbl_info.setLayoutData(gridData3);
		btn_hide = new Button(btn_ctrl, SWT.NONE);
		btn_hide.setText("숨기기");
		btn_clear_all = new Button(btn_ctrl, SWT.NONE);
		btn_clear_all.setText("완료 목록 지움");
		btn_accept_all = new Button(btn_ctrl, SWT.NONE);
		btn_accept_all.setText("모두 받기");
		/*
		button1.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				addItem();
			}
		});
		*/
		btn_cancel_all = new Button(btn_ctrl, SWT.NONE);
		btn_cancel_all.setText("모두 취소");
		btn_cancel_all.setLayoutData(gridData1);
		btn_cancel = new Button(btn_ctrl, SWT.NONE);
		btn_cancel.setText("취소");
		
		
		btn_hide.addSelectionListener(listener);
		btn_clear_all.addSelectionListener(listener);
		btn_accept_all.addSelectionListener(listener);
		btn_cancel.addSelectionListener(listener);
		btn_cancel_all.addSelectionListener(listener);
		
	}


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FileTransferDialog fdlg = new FileTransferDialog();
		/*
		Display display = Display.getDefault();
		FileTransferDialog thisClass = new FileTransferDialog();
		thisClass.createSShell();
		thisClass.sShell.open();

		while (!thisClass.sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
		*/
	}


	public void addItem(SwitchBoardSession ss, AbstractTransfer trans, ArrayList<NateFile> list  ){
		boolean isRecv = false;
		if (trans instanceof FileRecver) {
			isRecv =  true;
		}
		
		TableItem item = new TableItem(table, SWT.NONE);
		item.setData(trans);
		if(isRecv)
			state.add(NateFileManager.STATUS_RECV_READY);
		else
			state.add(NateFileManager.STATUS_SEND_READY);
		
		//item.setText(th);
		//NateFile dummy = new NateFile();
		//dummy.fileSize = 1024;
		NateFile file = list.get(0);
		
		
		//FileTransferDialogItem ti = new FileTransferDialogItem(table, dummy);
		//ti.pack();
		TableEditor editor = new TableEditor(table );
		editor.grabHorizontal = true;
		editor.grabVertical = true;
		
		//ti.computeSize(SWT.DEFAULT, table.getItemHeight(), true);
		//editor.verticalAlignment = SWT.CENTER;
		
		
		//editor.minimumHeight = // ti.getBtn_accept().getSize().y;
		
		//editor.verticalAlignment = SWT.BOTTOM;
		if(isRecv)
			item.setText(0, "받기");
		else
			item.setText(0,"보내기");
		
		item.setText(1, trans.ref.getNateID());
		item.setText(2, MsgUtil.getRealString( file.getFile().getName() ));
		int filesize = (int) (file.fileSize / 1024);
		if(filesize==0 && file.fileSize!=0)
			filesize = 1;
		
		item.setText(3, filesize + "KB");
		
	
		
		
		
		ProgressBar progressBar = new ProgressBar(table, SWT.SMOOTH);
		//progressBar.computeSize(SWT.DEFAULT, table.getItemHeight(), true);
		
		progressBar.setMinimum(0);
		//progressBar.setLayoutData(gridData);
		progressBar.setMaximum((int)file.fileSize);
		item.setData("prog", progressBar);
		item.setData("ss", ss);
		
		
		editor.setItem(item);
		editor.setEditor(progressBar, item, 4);
		
		
		
		//progressBar.pack();

		
		editor.grabVertical = true;
		
		//b.pack();
		

		//p.computeSize(SWT.DEFAULT, table.getItemHeight());
		
		
		//editor.minimumHeight = b.getSize().y;
		//editor.minimumWidth = b.getSize().x;
		
		//editor.setEditor(p, item, 6);
		//editor.setEditor(ti, item, 2);
		//editor.setItem(item);

	}
	public void setVisible(boolean visible){
		if(!sShell.isDisposed())
		this.sShell.setVisible(visible);
		
	}
	
	public void toogleVisible() {
		sShell.setVisible(!sShell.isVisible());
	}
	
	public void filePosted(final SwitchBoardSession ss, final FileRecver recv, NateFriend ref, final ArrayList<NateFile> list){
		display.asyncExec(new Runnable(){

			public void run() {
				addItem(ss, recv, list);
				
				
				if(!isOpened()){
					open();
				}
				setVisible(true);
				sShell.forceFocus();
				
			}
			
			
		});
		
	}

	public void fileSend(final SwitchBoardSession session, final FileSender sender, 
			NateFriend ref, final ArrayList<NateFile> list) {
		display.asyncExec(new Runnable(){
			public void run() {
				addItem(session , sender, list);				
				
				if(!isOpened()){
					open();
				}
				setVisible(true);
				sShell.forceFocus();
				
			}
		});
		
	}
	
	public void createSShell() {

		
		GridData gridData = new GridData();
		gridData.grabExcessHorizontalSpace = true;
		gridData.horizontalAlignment = GridData.FILL;
		gridData.verticalAlignment = GridData.FILL;
		gridData.grabExcessVerticalSpace = true;
		
		
		sShell = new Shell(  SWT.TITLE | SWT.MIN | SWT.RESIZE );
		sShell.setImage(UIToolKit.DefaultImage);
		
		main.addWindow(sShell);
		sShell.setVisible(false);
		
		sShell.setSize(new Point(450, 300));
		
		table = new Table(sShell,// SWT.BORDER |
				SWT.FULL_SELECTION );
		
		table.setHeaderVisible(true);
		table.setLayoutData(gridData);
		table.setLinesVisible(false);
		editor = new TableEditor(table);
		table.setToolTipText("더블클릭하면 파일 전송이 시작됩니다");
		
		/*
		table.addListener(SWT.MeasureItem, new Listener() {  
			public void handleEvent(Event event) {  
				int clientWidth = table.getClientArea().width;  
				event.height = (int) (event.gc.getFontMetrics().getHeight() * 1.5);  
				event.width = clientWidth * 2;  
				
				}
			});
			*/
		table.addSelectionListener(new SelectionListener(){

			public void widgetDefaultSelected(SelectionEvent e) {

				for( TableItem ti: table.getSelection()){
					if (ti.getData() instanceof FileRecver) {
						FileRecver recv = (FileRecver) ti.getData();
						nate.filemgr.procFileRecv(recv);
					}
					else if (ti.getData() instanceof FileSender) {
						/*
						FileSender send = (FileSender) ti.getData();
						nate.filemgr.pro
						*/					
					}
					
				}
				
			}

			public void widgetSelected(SelectionEvent e) {

				
			}
			
		});
		  

		
		for(int i=0;i<th.length;i++){
			TableColumn h = new TableColumn(table, SWT.NONE);
			h.setText(th[i]);
			//h.pack();
			//h.setWidth(80);
			int w=80;
			switch (i) {
			//case 0: w=50;	break;
			case 1:w=80;	break;
			case 2: w = 100 ; break;	
			//case 3: w = 40;	break;
			case 4: w = 150;	break;

			default:
				w =50;
				break;
			}
			h.setWidth(w);
			//if(i==2)
//				h.setWidth(250);
		}
		
		
		

		
		
		display = Display.getCurrent();
		sShell.setText("파일 전송 모니터");
		createBtn_ctrl();

		sShell.setLayout(new GridLayout());
		
		sShell.addShellListener(new org.eclipse.swt.events.ShellAdapter() {
			public void shellClosed(org.eclipse.swt.events.ShellEvent e) {
				
				sShell.setVisible(false);		
					e.doit=false;
			}
		});
	}
	
	public FileTransferDialog() {
		
			
	}
	
	
	public void updateRow(final AbstractTransfer recv,final int st){
		display.asyncExec(new Runnable(){

			public void run() {
				TableItem items[] = table.getItems();
				if(items.length==0)
					return;
				
				//for(int i=items.length-1;i<=0; i--){
				for(int i=0 ; i<items.length;i++){
					if(items[i].getData().equals(recv)){
						items[i].setText(0, status_str[st]);
					}
				}
			}
			
		});
		
	}
	
	

	
	public void set(NateonMessenger nate, MainFrame main){
		this.nate = nate;
		this.main = main;
	
	}
	public boolean isOpened(){
		return this.isopened;
	}
	
	public void open(){
		isopened = true;
		main.addWindow(sShell);
		//FileTransferMonitor m = new FileTransferMonitor(nate,main);
		
		//monitor.start();
		this.start();
		
	
		
		sShell.open();
		while(!sShell.isDisposed()){
			if(!display.readAndDispatch())
				display.sleep();
		}
		main.removeWindow(sShell);
		
		display.dispose();

	}
	public void fileTransferAborted(final String cookie) {
		display.asyncExec(new Runnable(){
			public void run() {
				for(TableItem ti : table.getItems()){
					AbstractTransfer t = (AbstractTransfer) ti.getData();
					for(NateFile f : t.getFileList()){
						MsgUtil.println(f.getCookie() + "/" + cookie);;
						if(f.getCookie().equals(cookie)){
							updateRow(t, NateFileManager.STATUS_FAIL);
							return;
						}
							
					}
				}
			}
			
		});
		
	}
	
	@Override
	public void run() {
		while(true){
			try{
				Thread.sleep(100);
			}catch (Exception e) {
				e.printStackTrace();
			}
			
			
			Display.getDefault().asyncExec(new Runnable(){
				public void run() {
					
					
					AbstractTransfer trans;
					int curstat = 0;
					int prevstat  = 0;
					boolean isRecv = false;

					TableItem is[] = table.getItems();
					for(int i=0;i<is.length;i++){
						prevstat = curstat = state.get(i);

						
						if( //curstat>=0 && 
								curstat<NateFileManager.STATUS_END){
		
							trans = 	((AbstractTransfer)is[i].getData());
							
							/*
							if (is[i].getData() instanceof FileRecver) 
								isRecv = true;
							else 
								isRecv = false;
							*/
							curstat = trans.getFileStat(0);
							
							
							long cur =trans.getCurrentFileSize(0);
							/*
							
							if(cur<trans.getNateFile().fileSize){
								if(isRecv)
									curstat = STATUS_RECVING;
								else
									curstat = STATUS_SENDING;
							}
							*/
					
							
							if(curstat!=prevstat)
								updateRow(trans, curstat);
							
							ProgressBar p = (ProgressBar) is[i].getData("prog");
							if(p.getSelection()!=cur)
								p.setSelection((int) cur);

						}
					}
					
					
						
				}
				
			});
			
			
		}
		

	}
	
	class Listener implements SelectionListener{
		public void widgetDefaultSelected(SelectionEvent e) {		}

		public void widgetSelected(SelectionEvent e) {
			
			if (e.getSource() instanceof Button) {
				Button b = (Button) e.getSource();				
				if(b==btn_hide)
					setVisible(false);
				else if(b==btn_accept_all)
					accept_all();
				else if(b==btn_cancel_all){
					for(int i=0;i<state.size();i++)
						cancel(i);					
				}					
				else if(b==btn_cancel)
					cancel(table.getSelectionIndex());
				else if(b==btn_clear_all)
					clear_all();
				
				
			}
			
		}

	
		
	}

	public void accept_all() {
		for(TableItem ti : table.getItems() )
			if (ti.getData() instanceof FileRecver) {
				FileRecver recv = (FileRecver) ti.getData();
				nate.filemgr.procFileRecv(recv);
			}
	}

	public void clear_all() {
		for(int i =state.size()-1 ; i>=0 ;i-- ){
			
			int s = ((AbstractTransfer)table.getItem(i).getData()).getFileStat(0);

			
			if(s==NateFileManager.STATUS_END || s==NateFileManager.STATUS_FAIL){
				state.remove(i);
				((ProgressBar)table.getItem(i).getData("prog")).dispose();
				table.remove(i);
			}
				
		}

		
		
		/*
		for(int i =0 ; i<state.size();i++ ){
			
			int s = ((AbstractTransfer)table.getItem(i).getData()).getFileStat(0);

			
			if(s==NateFileManager.STATUS_END || s==NateFileManager.STATUS_FAIL){
				state.remove(i);
				((ProgressBar)table.getItem(i).getData("prog")).dispose();
				table.remove(i);
			}
				
		}
		 
		 */
	}

	public void cancel(int index) {
		if(index==-1)
			return;
		int st = ((AbstractTransfer)table.getItem(index).getData()).getFileStat(0);

		if(st==NateFileManager.STATUS_END || st==NateFileManager.STATUS_FAIL 		)
			return;
		
		
		TableItem ti = table.getSelection()[0];
				
		if (ti.getData() instanceof FileRecver) {
			FileRecver recv = (FileRecver) ti.getData();
			SwitchBoardSession ss = (SwitchBoardSession)ti.getData("ss");
			nate.filemgr.stopRecv(ss, recv);//.getNateFile().getCookie());
		}
		else if (ti.getData() instanceof FileSender) {
			FileSender send = (FileSender) ti.getData();
			SwitchBoardSession ss = (SwitchBoardSession)ti.getData("ss");
			nate.filemgr.stopSend(ss, send);//.getNateFile().getCookie());
			//nate.filemgr.stopSend(send.getNateFile().getCookie());
		}
		
	}





	




	

	
	

}
