/**
 * 
 */
package kfmes.jateon.swt.dialog;

import kfmes.natelib.entity.NateFile;


import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Button;

/**
 * 파일 전송 모니터의 아이템
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: FileTransferDialogItem.java,v 1.5 2007/11/19 10:13:30 kfmes Exp $
 */
public class FileTransferDialogItem extends Composite {

	private ProgressBar progressBar = null;
	private Button btn_accept = null;
	private Button btn_cancel = null;
	private NateFile file = null;
	
	public ProgressBar getProgressBar() {
		return progressBar;
	}
	public Button getBtn_accept() {
		return btn_accept;
	}
	public Button getBtn_cancel() {
		return btn_cancel;
	}
	
	public FileTransferDialogItem(Composite parent, NateFile file) {
		super(parent, SWT.NORMAL);
		this.file = file;
		initialize();
		
		
		// TODO 자동 생성된 생성자 스텁
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO 자동 생성된 메소드 스텁
		/* Before this is run, be sure to set up the launch configuration (Arguments->VM Arguments)
		 * for the correct SWT library path in order to run with the SWT dlls. 
		 * The dlls are located in the SWT plugin jar.  
		 * For example, on Windows the Eclipse SWT 3.1 plugin jar is:
		 *       installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
		 */
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		shell.setLayout(new FillLayout());
		shell.pack();
		//shell.setSize(new Point(300, 200));
		new FileTransferDialogItem(shell, SWT.NONE);
		shell.open();

		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	public FileTransferDialogItem(Composite parent, int style) {
		super(parent, style);
		initialize();
	}

	private void initialize() {
		RowLayout rowLayout = new RowLayout();
		rowLayout.fill = true;
		this.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_LIST_BACKGROUND));
		this.setLayout(rowLayout);
		progressBar = new ProgressBar(this, SWT.SMOOTH);
		progressBar.setMinimum(0);
		progressBar.setMaximum((int) file.fileSize);
		btn_accept = new Button(this, SWT.NONE);
		btn_accept.setText("받기");
		btn_cancel = new Button(this, SWT.NONE);
		btn_cancel.setText("취소");
	
		
		
		btn_accept.pack();
		btn_cancel.pack();
		
		//setSize(new Point(300, 200));
		pack();
	//	this.setSize(120, 50);
	}

}
