/**
 * 
 */
package kfmes.jateon.swt.dialog;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import kfmes.jateon.swt.ConfUtil;
import kfmes.jateon.swt.MainFrame;
import kfmes.jateon.swt.UIToolKit;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.msg.NateSMS;
import kfmes.natelib.util.MsgUtil;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * SMS 보내기 다이얼로그
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: JateonSMS.java,v 1.13 2007/11/19 10:13:30 kfmes Exp $
 */
final public class JateonSMS implements KeyListener, ModifyListener, SelectionListener{

	private Display display = null;
	private Shell sShell = null;  //  @jve:decl-index=0:visual-constraint="10,10"
	private Group grp_send = null;
	private Group grp_preview = null;
	private StyledText txt_smsmsgs = null;
	private Text txt_smsmsg = null;
	private Text txt_preview = null;
	private Label lbl_byteCnt = null;
	private Label lbl_space = null;
	private Group grp_nums = null;
	private Label lbl_recver = null;
	private Combo txt_recver = null;
	private Label lbl_sender = null;
	private Text txt_sender = null;
	private Button btn_preview = null;
	private Button btn_send = null;
	private Label lbl_freeCnt = null;
	private Composite grp_ctrl = null;
	
	
	
	
	private int freeCnt=-1;
	private int freePlusCnt = -1;
	private NateSMS smsEngine = null;  //  @jve:decl-index=0:
	private NateonMessenger nate = null;
	private MainFrame frmmain = null;
	private ConfUtil conf =null;
	private JateonSMS thisfrm = null;
	
	private String ticket = null;
	private String uid = null;
	private String sendNum = null;  //  @jve:decl-index=0:
	private String recvNum = null;
	private String sendSMS = "";  //  @jve:decl-index=0:
	
	private NateFriend recvFriend = null;
	private ArrayList<String> recvList = new ArrayList<String>();  //  @jve:decl-index=0:
	
	/** 
	 * Dummy Constructor
	 */
	public JateonSMS() {
		// TODO 자동 생성된 생성자 스텁
	}
	
	public JateonSMS(NateonMessenger nate, MainFrame frmmain) {
		this.nate = nate;
		this.frmmain = frmmain;
		this.thisfrm = this;
		NateFriend recvFriend = null;
		this.ticket = nate.getTicket();
		
		
		
		this.uid = nate.getOwner().getNateID();
		sendNum = nate.getOwner().getPhoneNumber();
		this.conf = frmmain.getConf();
		
		if(sendNum==null||sendNum.equals("%00")) sendNum = "";
		
		try{
			recvFriend = frmmain.getBuddyTree().getSelectedFriend()  ;
			if(recvFriend!=null)
				recvNum = recvFriend.getPhoneNumber();
			if(recvNum==null||recvNum.equals("%00")) recvNum = "";
						
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
		{
			String list = conf.get("smsRecent");
			if(list!=null){
				String recvList[] = list.split("/");
				for(int i=0;i<recvList.length;i++){
					if(!(recvList[i].equals("") || recvList[i].equals(recvNum)))
						this.recvList.add(recvList[i]);
				}
			}
			recvList.add(0, recvNum);
			
		}
		//kfmes.jateon.swt.MainFrame.newDialog(this);
		
		display = Display.getDefault();
		JateonSMS thisClass = new JateonSMS();
		createSShell();		
		sShell.open();
		frmmain.addWindow(sShell);
		
		btn_send.setEnabled(false);
		
		start();
	
		while (!sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		frmmain.removeWindow(sShell);
		sShell.dispose();
	}
	
	private void start(){
		if(MainFrame.useStyledText())
			txt_smsmsgs.setText("서비스에 연결중이니 잠시 기다려주세요");
		else 
			txt_smsmsg.setText("서비스에 연결중이니 잠시 기다려주세요");
		updateRecentCombo();
		smsEngine = new NateSMS(this.ticket, this.uid);
		if(MainFrame.useStyledText())
			txt_smsmsgs.setText("");
		else
			txt_smsmsg.setText("");
		updateUI();
		
		
		
	}
	private void updateUI(){
		this.freeCnt = smsEngine.getFreeCnt();
		this.freePlusCnt = smsEngine.getFreePlusCnt();
		//this.txt_recvnum.setText(this.recvNum);
		//this.cmb_recvnum.set
		MsgUtil.println("FreeCnt : " + freeCnt + "\nFreePlusCnt : " + freePlusCnt);
		
		this.freeCnt = (freePlusCnt<=0) ? freeCnt : freeCnt + freePlusCnt;
		
		this.txt_sender.setText(this.sendNum);
		lbl_freeCnt.setText("남은 문자 : " + freeCnt + "건");
	}
	
	private void updateRecentCombo(){
		recvList.remove(recvNum);
		
		//recvList.remove(idx);
		recvList.add(0, recvNum);

		for(int i=recvList.size()-1;i>9;i--)
			recvList.remove(i);

		
		txt_recver.removeAll();
		
		for(int i=0;i<recvList.size();i++)
			txt_recver.add(recvList.get(i));
		txt_recver.select(0);

	}
	private boolean chkSMSValid(){

		int idx = txt_recver.getSelectionIndex();
		if(idx<0)
			this.recvNum = txt_recver.getText();
		else 
			this.recvNum = txt_recver.getItem(txt_recver.getSelectionIndex());
		this.recvNum = recvNum.replaceAll("-", "");
		
		this.sendNum = txt_sender.getText();
		
		if(MainFrame.useStyledText()){
			
			if(this.txt_smsmsgs.getText().length()<=0){
				showMessageBox("에러", "보낼 내용을 입력하세요", SWT.ICON_WARNING);
				txt_smsmsgs.setFocus();
				return false;
			}
		}
		else{
			if(this.txt_smsmsg.getText().length()<=0){
				showMessageBox("에러", "보낼 내용을 입력하세요", SWT.ICON_WARNING);
				txt_smsmsg.setFocus();
				return false;
			}
			
		}
		
		
		if(!isValidNum(recvNum)){
			showMessageBox("에러", "받는이 번호 형식 오류", SWT.ICON_WARNING);
			txt_recver.setFocus();
			return false;
			}
		
		
		if(!isValidSendNum(sendNum)){
			showMessageBox("에러", "보내는 번호 형식 오류", SWT.ICON_WARNING);
			txt_sender.setFocus();
			return false;
		}
		if(freeCnt<=0){
			showMessageBox("에러", "남은 문자 없음", SWT.ICON_ERROR);
			return false;
		}
		return true;
			
	}
	

	
	private boolean isValidSendNum(String num){ 
		if(num.length()<1 )
			return false;
		/*
		if(!num.startsWith("01"))
			return false;*/
		for(int i=0;i<num.length();i++)
			if(!Character.isDigit(num.charAt(i)))
				return false;		
		
		return true;		
	}
	
	private boolean isValidNum(String num){ 
		if(num.length()>11 || num.length()<10)
			return false;
		if(!num.startsWith("01"))
			return false;
		for(int i=0;i<num.length();i++)
			if(!Character.isDigit(num.charAt(i)))
				return false;		
		
		return true;		
	}
	
	private void sendSMS(){
		boolean retval = false;
		retval = smsEngine.sendSMS(this.sendSMS, recvNum, sendNum);
		String msg= "문자 전송 실패";
		// 최근 문자 목록 업데이트 
		
		if(retval){//전송 성공
			this.freeCnt --;
			this.btn_send.setEnabled(false);
			
			msg = "문자 전송 접수완료";
		}
		showMessageBox("결과", msg, 
				(retval) ? SWT.ICON_INFORMATION : SWT.ICON_ERROR);
		updateRecentCombo();
		updateUI();
		if(MainFrame.useStyledText())
			txt_smsmsgs.setText("");
		else
			txt_smsmsg.setText("");
		
	}
	
	
	/**
	 * This method initializes grp_send	
	 *
	 */
	private void createGrp_send() {
		GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.CENTER;
		gridData2.verticalAlignment = GridData.CENTER;
		GridData gridData = new GridData();
		gridData.grabExcessVerticalSpace = true;
		gridData.horizontalAlignment = GridData.FILL;
		gridData.verticalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		grp_send = new Group(sShell, SWT.NONE);
		grp_send.setLayout(new GridLayout());
		grp_send.setText("보낼 내용");
		
		if(MainFrame.useStyledText()){
			txt_smsmsgs = new StyledText(grp_send, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);
			txt_smsmsgs.setText("");
			txt_smsmsgs.setLayoutData(gridData);
		}
		else{
			txt_smsmsg = new Text(grp_send, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);
			txt_smsmsg.setText("");
			txt_smsmsg.setLayoutData(gridData);
		}
			
		
		lbl_byteCnt = new Label(grp_send, SWT.BOLD);
		lbl_byteCnt.setText("0 bytes");
		
		lbl_byteCnt.setLayoutData(gridData2);
		
		grp_send.setBounds(new Rectangle(0, 0, 152, 166));
	}

	/**
	 * This method initializes grp_preview	
	 *
	 */
	private void createGrp_preview() {
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.grabExcessVerticalSpace = true;
		gridData1.verticalAlignment = GridData.FILL;
		grp_preview = new Group(sShell, SWT.NONE);
		grp_preview.setLayout(new GridLayout());
		grp_preview.setText("미리 보기");
		
		txt_preview = new Text(grp_preview, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);
		txt_preview.setLayoutData(gridData1);
		txt_preview.setEditable(false);
		txt_preview.setBackground(new Color(Display.getCurrent(), 255,255,255));
		txt_preview.setText("미리보기\n 버튼을\n  누르세요");
		lbl_space = new Label(grp_preview, SWT.NONE);
		lbl_space.setText("");
		
		grp_preview.setBounds(new Rectangle(165, 0, 152, 166));
	}

	/**
	 * This method initializes grp_nums	
	 *
	 */
	private void createGrp_nums() {
		GridData gridData4 = new GridData();
		gridData4.horizontalAlignment = GridData.FILL;
		gridData4.verticalAlignment = GridData.CENTER;
		GridData gridData3 = new GridData();
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.verticalAlignment = GridData.CENTER;
		gridData3.horizontalAlignment = GridData.FILL;
		grp_nums = new Group(sShell, SWT.NONE);
		grp_nums.setLayout(new GridLayout());
		
		lbl_recver = new Label(grp_nums, SWT.NONE);
		lbl_recver.setText("받는 사람 번호");
		txt_recver = new Combo(grp_nums, SWT.NONE);
		//txt_recver = new CCombo(grp_nums, SWT.BORDER);
		txt_recver.setLayoutData(gridData3);
		lbl_sender = new Label(grp_nums, SWT.NONE);
		lbl_sender.setText("보내는 사람 번호");
		txt_sender = new Text(grp_nums, SWT.BORDER);
		txt_sender.setLayoutData(gridData4);
		
		grp_nums.setBounds(new Rectangle(0, 165, 152, 106));
	}

	/**
	 * This method initializes grp_ctrl	
	 *
	 */
	private void createGrp_ctrl() {
		GridData gridData7 = new GridData();
		gridData7.horizontalAlignment = GridData.FILL;
		gridData7.grabExcessHorizontalSpace = true;
		gridData7.grabExcessVerticalSpace = false;
		gridData7.verticalAlignment = GridData.CENTER;
		GridData gridData6 = new GridData();
		gridData6.horizontalAlignment = GridData.FILL;
		gridData6.verticalAlignment = GridData.CENTER;
		GridData gridData5 = new GridData();
		gridData5.horizontalAlignment = GridData.FILL;
		gridData5.grabExcessHorizontalSpace = true;
		gridData5.verticalAlignment = GridData.CENTER;
		grp_ctrl = new Composite(sShell, SWT.NONE);
		grp_ctrl.setLayout(new GridLayout());
		
		btn_preview = new Button(grp_ctrl, SWT.NONE);
		btn_preview.setBounds(new Rectangle(150, 180, 121, 22));
		btn_preview.setLayoutData(gridData5);
		btn_preview.setText("미리보기");
		
		btn_send = new Button(grp_ctrl, SWT.NONE);
		btn_send.setBounds(new Rectangle(150, 210, 121, 22));
		btn_send.setLayoutData(gridData6);
		btn_send.setText("문자 보내기");
		lbl_freeCnt = new Label(grp_ctrl, SWT.NONE);
		lbl_freeCnt.setBounds(new Rectangle(150, 246, 121, 12));
		lbl_freeCnt.setLayoutData(gridData7);
		lbl_freeCnt.setText("남은 문자 : -1건");
		lbl_freeCnt.setAlignment(SWT.CENTER);
		btn_preview.addSelectionListener(this);
		btn_send.addSelectionListener(this);
		
		if(MainFrame.useStyledText()){
			txt_smsmsgs.addKeyListener(this);
			txt_smsmsgs.addModifyListener(this);
		}else{
			txt_smsmsg.addKeyListener(this);
			txt_smsmsg.addModifyListener(this);
		}
		
		grp_ctrl.setBounds(new Rectangle(165, 180, 152, 107));
	}

	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		sShell = new Shell(SWT.TITLE | SWT.MIN | SWT.CLOSE);
		sShell.setImage(UIToolKit.DefaultImage);
		sShell.setText("문자 보내기");
		createGrp_send();
		createGrp_preview();
		createGrp_nums();
		sShell.setSize(new Point(326, 309));
		sShell.setLayout(null);
		
		createGrp_ctrl();
		sShell.addShellListener(new org.eclipse.swt.events.ShellAdapter() {
			public void shellClosed(org.eclipse.swt.events.ShellEvent e) {
				StringBuffer sb = new StringBuffer();
				
				for(int i=0;i<recvList.size();i++){
					if(!recvList.get(i).equals(""))
						sb.append(recvList.get(i) + "/");
				}
									
				if(sb.length()>2){
					conf.set("smsRecent", sb.substring(0, sb.length()-1));
					conf.writeData();
				}
				frmmain.removeWindow(sShell);
			}
		});
	}

	
	
	
	
	private void displayPreview(){
		
		
		txt_preview.setText("");
		String src = null;
		
		if(MainFrame.useStyledText())
			src = txt_smsmsgs.getText();
		else
			src = txt_smsmsg.getText();
		
		StringBuffer sb = new StringBuffer();
		int col=0;
		int bytes ;
		int totalbytes = 0;
		
		try {
			for(int i=0;i<src.length();i++){
					bytes = src.substring(i, i+1).replaceAll("\r\n", "\n").getBytes("MS949").length;
				
				if( col+ bytes  >16 ){
					txt_preview.append("\n");
					col =0;
				}
				if(src.charAt(i)=='\n'){
					col = 0;
					bytes=0;
		
				}
				
				txt_preview.append(src.charAt(i) + "");
				sb.append(src.charAt(i));
				col+=bytes;
				totalbytes+=bytes;
				
				//if(sb.getChars(arg0, arg1, arg2, arg3)  txt_preview.getText().getBytes("MS949").length>80)
				if(totalbytes>=80)
					break;
			}
		} catch (UnsupportedEncodingException e) {
			// TODO 자동 생성된 catch 블록
			e.printStackTrace();
		}
		
		
		this.sendSMS = sb.toString();
		if(chkSMSValid()){ 
			
			
			this.btn_send.setEnabled(true);
		}
		
		//XXX: Testing
		updateRecentCombo();
	}

	public void showMessageBox(String title, String message , int type){
		MessageBox msgb = new MessageBox(sShell, type);
		msgb.setMessage(message);
		msgb.setText(title);
		msgb.open();
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO 자동 생성된 메소드 스텁
		/* Before this is run, be sure to set up the launch configuration (Arguments->VM Arguments)
		 * for the correct SWT library path in order to run with the SWT dlls. 
		 * The dlls are located in the SWT plugin jar.  
		 * For example, on Windows the Eclipse SWT 3.1 plugin jar is:
		 *       installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
		 */
		Display display = Display.getDefault();
		JateonSMS thisClass = new JateonSMS();
		thisClass.createSShell();
		thisClass.sShell.open();
	
		while (!thisClass.sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	public void keyPressed(KeyEvent evt) {
		
		
	}

	public void keyReleased(KeyEvent evt) {
		if(evt.getSource()==txt_smsmsgs) {
			if (evt.keyCode == SWT.TAB) {
				txt_smsmsgs.setText(txt_smsmsgs.getText()
					.replaceAll("\t", ""));
				//txt_recvnum.requestFocus();
				txt_recver.setFocus();
				evt.doit = false;
			}
		}
		else if(evt.getSource()==txt_smsmsg) {
			if (evt.keyCode == SWT.TAB) {
				txt_smsmsg.setText(txt_smsmsg.getText()
					.replaceAll("\t", ""));
				//txt_recvnum.requestFocus();
				txt_recver.setFocus();
				evt.doit = false;
			}
		}	
		
	}

	public void widgetDefaultSelected(SelectionEvent e) {
		// TODO 자동 생성된 메소드 스텁
		
	}

	public void widgetSelected(SelectionEvent e) {
		if (e.getSource() instanceof Button) {
			Button btn = (Button) e.getSource();
			String c= btn.getText();
			
			if(c.equals("미리보기")){
				displayPreview();
			}
			
			else if(c.equals("문자 보내기")){
				if(chkSMSValid()){}
					sendSMS();
			}
				
		}
	}

	public void modifyText(ModifyEvent evt) {
		try {
			if(MainFrame.useStyledText()){
			lbl_byteCnt.setText(txt_smsmsgs.getText().replaceAll("\r\n", "\n")
				.getBytes("MS949").length
				+ " bytes");
			}else{
				lbl_byteCnt.setText(txt_smsmsg.getText().replaceAll("\r\n", "\n")
						.getBytes("MS949").length
						+ " bytes");
			}
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
	}


	
}
