package kfmes.jateon.swt.dialog;


import kfmes.jateon.swt.ConfUtil;
import kfmes.jateon.swt.MainFrame;
import kfmes.jateon.swt.UIToolKit;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.util.PasswordEncryptor;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * 로그인 창
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: LoginDialog.java,v 1.15 2007/11/19 10:13:30 kfmes Exp $
 */
final public class LoginDialog {
	
	private Shell sShell = null;  //  @jve:decl-index=0:visual-constraint="0,0"
	private Label lbl_id = null;
	private Label lbl_pw = null;
	private Text txt_id = null;
	private Text txt_pass = null;
	private Button chk_savepass = null;
	private Button chk_autologin = null;
	private Button chk_offlogin = null;
	private Button btn_ok = null;
	private Button btn_cancel = null;

	private String passwd = null;
	private ConfUtil conf = null;
	private Listener listener = new Listener();  //  @jve:decl-index=0:
	public static boolean isReady = false;
	private Composite chk_group = null;
	private Composite cpz_idpass = null;
	
	/**
	 * This method initializes chk_group	
	 *
	 */
	private void createChk_group() {
		GridData gridData5 = new GridData();
		gridData5.verticalSpan = 6;
		gridData5.verticalAlignment = GridData.FILL;
		gridData5.horizontalAlignment = GridData.FILL;
		chk_group = new Composite(sShell, SWT.NONE);
		chk_group.setLayout(new GridLayout());
		chk_group.setLayoutData(gridData5);
		chk_savepass = new Button(chk_group, SWT.CHECK);
		chk_savepass.setText("패스워드 저장(&S)");
		//chk_savepass.setLayoutData(gridData);
		
		chk_autologin = new Button(chk_group, SWT.CHECK);
		chk_autologin.setText("자동 로그인(&A)");
		//chk_autologin.setLayoutData(gridData1);
		sShell.setDefaultButton(btn_ok);		
		chk_offlogin = new Button(chk_group, SWT.CHECK);
		chk_offlogin.setText("몰래 로그인");
		//chk_offlogin.setLayoutData(gridData2);
	}

	/**
	 * This method initializes cpz_idpass	
	 *
	 */
	private void createCpz_idpass() {
		GridData gridData8 = new GridData();
		gridData8.horizontalAlignment = GridData.FILL;
		gridData8.verticalAlignment = GridData.CENTER;
		GridData gridData7 = new GridData();
		gridData7.grabExcessHorizontalSpace = true;
		gridData7.verticalAlignment = GridData.CENTER;
		gridData7.horizontalAlignment = GridData.FILL;
		GridLayout gridLayout1 = new GridLayout();
		gridLayout1.numColumns = 2;
		GridData gridData6 = new GridData();
		gridData6.horizontalSpan = 3;
		gridData6.horizontalAlignment = GridData.FILL;
		gridData6.verticalAlignment = GridData.CENTER;
		gridData6.grabExcessHorizontalSpace = true;
		cpz_idpass = new Composite(sShell, SWT.NONE);
		cpz_idpass.setLayoutData(gridData6);
		cpz_idpass.setLayout(gridLayout1);
		lbl_id = new Label(cpz_idpass, SWT.NONE);
		lbl_id.setText("메일주소");
		txt_id = new Text(cpz_idpass, SWT.BORDER);
		txt_id.setLayoutData(gridData7);
		
		
		lbl_pw = new Label(cpz_idpass, SWT.NONE);
		lbl_pw.setText("패스워드");
		txt_pass = new Text(cpz_idpass, SWT.BORDER | SWT.PASSWORD);
		txt_pass.setLayoutData(gridData8);

		txt_id.addFocusListener(listener);
		txt_id.addKeyListener(listener);

		txt_pass.addFocusListener(listener);
		txt_pass.addKeyListener(listener);
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		Display display = Display.getDefault();
		LoginDialog thisClass = new LoginDialog();
		thisClass.createSShell();
		thisClass.sShell.open();

		while (!thisClass.sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		
		/*display.
		display.dispose();*/
	}

	/**
	 * Dummy Constructor
	 * @param main
	 */
	public LoginDialog() {
		conf = new ConfUtil(System.getProperty("user.home") + "/.jateon/" + MainFrame.conffile);
		
		
		
	}
	
	public LoginDialog(MainFrame main) {
		this.conf = main.getConf();
		isReady = false;
		
		Display display = Display.getDefault();
		//LoginDialog thisClass = new LoginDialog();
		//thisClass.createSShell();
		//thisClass.sShell.open();

		createSShell();
		{
			int x = main.shell.getLocation().x + (main.shell.getSize().x - this.sShell.getSize().x)/2;
			int y = main.shell.getLocation().y + (main.shell.getSize().y - this.sShell.getSize().y)/2;
			
			sShell.setLocation(x,y);
		}
		sShell.pack();
		sShell.open();
		
		
		/*
		 * 	this.setLocation( 
			p.x + (d.width - getWidth()) / 2,
			p.y + (d.height - getHeight()) / 2);
		this.setSize(new java.awt.Dimension(280, 154));
		 */
		


		while (!sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		//display.dispose();
		
//		readconf();
	}
	
	/**
	 * 로그인 정보를 읽는다
	 *
	 */
	private void readconf(){
		chk_savepass.setSelection(conf.getBoolean("savepasswd"));
		chk_autologin.setSelection(conf.getBoolean("autologin"));
		txt_id.setText(conf.getString("loginName"));
		if(chk_savepass.getSelection())
		{
			this.passwd = conf.getString("passwd");
			if(passwd.length()>0){
				txt_pass.setText("foobarmelong");
			}			
		}
				
	}
	/**
	 * 설정값을 저장한다.
	 *
	 */
	private void commit(){

		MessageBox msgBox = new MessageBox(sShell, SWT.ICON_WARNING);
		msgBox.setText("정보");
		String loginName = txt_id.getText();;
		
		if(loginName.length()==0){
			msgBox.setMessage("메일 주소를 넣지 않았습니다");
			msgBox.open();
			txt_id.setFocus();
			return;
		}
		
		int atpos = loginName.indexOf("@");
		if(atpos<1){
			msgBox.setMessage("메일 주소 형식으로 넣어주세요");
			msgBox.open();
			txt_id.setFocus();
			return ;
		}
		
		if(txt_pass.getText().length()==0)
		{
			msgBox.setMessage("패스워드를 넣지 않았습니다");
			msgBox.open();
			txt_pass.setFocus();
			return ;
		}
		
		
		if(!txt_pass.getText().equals("foobarmelong") ) { //&& isloadedpass){
			//passwd = PasswordEncryptor.encrypt(new String(jpw.getPassword()));
			passwd = new String( txt_pass.getText());
			if(loginName.endsWith("@nate.com"));
			
			passwd = PasswordEncryptor.getMD5String(	passwd
					+ (loginName.endsWith("@nate.com") ? 
							PasswordEncryptor.getID( loginName) : loginName ));

			
		
		}
		/*
		chk_savepass.setSelection(conf.getBoolean("savepasswd"));
		chk_autologin.setSelection(conf.getBoolean("autologin"));
		txt_id.setText(conf.getString("loginName"));
		if(chk_savepass.getSelection())
		{
			this.passwd = conf.getString("passwd");
			if(passwd.length()>0){
				this.isloadedpass = true;
				txt_pass.setText("foobarmelong");
			}			
		 * */
		
		conf.set("loginName", txt_id.getText());
		conf.set("savepasswd", chk_savepass.getSelection());
		
		conf.set("autologin", chk_autologin.getSelection());
		//if(chk_savepass.getSelection())
		conf.set("passwd", passwd);
		
		conf.writeData();
		
		NateonMessenger.setOffLogin(this.chk_offlogin.getSelection());
		isReady = true;
		sShell.dispose();
	}

	
	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		GridData gridData22 = new GridData();
		gridData22.horizontalAlignment = GridData.FILL;
		gridData22.verticalSpan = 6;
		gridData22.verticalAlignment = GridData.FILL;
		GridData gridData21 = new GridData();
		gridData21.horizontalAlignment = GridData.FILL;
		gridData21.grabExcessHorizontalSpace = true;
		gridData21.verticalSpan = 6;
		gridData21.verticalAlignment = GridData.FILL;
		GridData gridData4 = new GridData();
		gridData4.verticalAlignment = GridData.CENTER;
		gridData4.horizontalSpan = 3;
		gridData4.horizontalAlignment = GridData.FILL;
		GridData gridData3 = new GridData();
		gridData3.verticalAlignment = GridData.CENTER;
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.horizontalSpan = 3;
		gridData3.horizontalAlignment = GridData.FILL;
		GridData gridData2 = new GridData();
		gridData2.horizontalSpan = 2;
		GridData gridData1 = new GridData();
		gridData1.horizontalSpan = 2;
		GridData gridData = new GridData();
		gridData.horizontalSpan = 2;
		GridLayout gridLayout = new GridLayout();
		gridLayout.makeColumnsEqualWidth = false;
		gridLayout.numColumns = 3;
		
		sShell = new Shell(  SWT.APPLICATION_MODAL| SWT.TITLE | SWT.CLOSE);
		sShell.setText("로그인");
		sShell.setImage(UIToolKit.DefaultImage);
		sShell.setLayout(gridLayout);
		createCpz_idpass();
		sShell.setSize(new Point(287, 159));
		sShell.setImage(UIToolKit.DefaultImage);
		

		
		createChk_group();
		btn_ok = new Button(sShell, SWT.NONE);
		btn_ok.setText("로그인");
		btn_ok.setLayoutData(gridData21);
		sShell.setDefaultButton(btn_ok);
		
		btn_cancel = new Button(sShell, SWT.NONE);
		btn_cancel.setText("취  소");
		btn_cancel.setLayoutData(gridData22);
				
		txt_id.addKeyListener(listener);
		txt_id.addFocusListener(listener);
		txt_id.addSelectionListener(listener);
		
		txt_pass.addFocusListener(listener);
		txt_pass.addKeyListener(listener);
		txt_pass.addSelectionListener(listener);
		
		btn_ok.addSelectionListener(listener);
		btn_cancel.addSelectionListener(listener);
		chk_savepass.addSelectionListener(listener);
		chk_autologin.addSelectionListener(listener);
		readconf();

	}

	private class Listener implements KeyListener, SelectionListener, FocusListener{


		public void keyPressed(KeyEvent e) {

			if(e.keyCode == SWT.ESC)
				sShell.dispose();				
		}

		public void keyReleased(KeyEvent e) {
		
		}

		public void widgetDefaultSelected(SelectionEvent e) {
			// TODO 자동 생성된 메소드 스텁

			
		}

		public void widgetSelected(SelectionEvent e) {
			// TODO 자동 생성된 메소드 스텁
			Object o = e.getSource();
			if(o==btn_ok)
				commit();
			
			else if(o==btn_cancel)
				sShell.dispose();
			else if(o==chk_savepass){
				if(!chk_savepass.getSelection() && chk_autologin.getSelection())
					chk_autologin.setSelection(false);
			}
			else if(o==chk_autologin){
				if(chk_autologin.getSelection() && !chk_savepass.getSelection())
					chk_savepass.setSelection(true);					
			}
			
							
			
		}

		public void focusGained(FocusEvent e) {
			if (e.getSource() instanceof Text) {
				Text t = (Text) e.getSource();
				t.setSelection(0, t.getTextLimit());
			}	
			
			
		}

		public void focusLost(FocusEvent e) {
			// TODO 자동 생성된 메소드 스텁
			
		}			
		
	};
	
}
