
/**
 * 
 */
package kfmes.jateon.swt.dialog;

import kfmes.jateon.swt.ConfUtil;
import kfmes.jateon.swt.MainFrame;
import kfmes.natelib.NateonMessenger;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;

/**
 * 환경 설정 다이얼로그
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: OptionDialog.java,v 1.9 2007/11/19 10:13:29 kfmes Exp $
 */
public final class OptionDialog {

	private Shell sShell = null;  //  @jve:decl-index=0:visual-constraint="10,10"
	private MainFrame frmmain = null;
	private ConfUtil conf = null;  //  @jve:decl-index=0:
	
	
	private TabFolder tab = null;
	private Composite cpz_buttongrp = null;
	private Button btn_ok = null;
	private Button btn_cancel = null;
	private Composite tab1 = null;
	private Composite tab2 = null;
	private Button chk_useTray = null;
	private Button chk_useNotify = null;
	private Button chk_viewOnTop = null;
	private Button chk_useSound = null;
	private Group grp_dblClickAction = null;
	private Button opt_Defaction_msg = null;
	private Button opt_Defaction_chat = null;
	private Label lbl_savepath = null;
	private Text txt_savepath = null;
	private Button btn_browse = null;
	private Button chk_useFR = null;
	private NateonMessenger nate = null;
	/**
	 * This method initializes tab	
	 *
	 */
	private void createTab() {
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessVerticalSpace = true;
		gridData.grabExcessHorizontalSpace = true;
		gridData.verticalAlignment = GridData.FILL;
		tab = new TabFolder(sShell, SWT.NONE);
		tab.setLayoutData(gridData);
		createTab1();
		createTab2();
		TabItem tabItem1 = new TabItem(tab, SWT.NONE);
		tabItem1.setText("기본");
		tabItem1.setControl(tab1);
		TabItem tabItem2 = new TabItem(tab, SWT.NONE);
		tabItem2.setControl(tab2);
		tabItem2.setText("파일전송");
	}

	/**
	 * This method initializes cpz_buttongrp	
	 *
	 */
	private void createCpz_buttongrp() {
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.END;
		gridData1.grabExcessHorizontalSpace = false;
		gridData1.verticalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		cpz_buttongrp = new Composite(sShell, SWT.NONE);
		cpz_buttongrp.setLayout(gridLayout);
		cpz_buttongrp.setLayoutData(gridData1);
		btn_ok = new Button(cpz_buttongrp, SWT.NONE);
		btn_ok.setText("확인");
		btn_ok.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				saveConf();
				sShell.dispose();
			}
		});
		
		btn_cancel = new Button(cpz_buttongrp, SWT.NONE);
		btn_cancel.setText("취소");
		btn_cancel.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				sShell.dispose();
			}
		});
		
	
		
		sShell.setDefaultButton(btn_ok);
	}

	/**
	 * This method initializes tab1	
	 *
	 */
	private void createTab1() {
		RowLayout rowLayout1 = new RowLayout();
		rowLayout1.type = org.eclipse.swt.SWT.VERTICAL;
		rowLayout1.fill = false;
		RowLayout rowLayout = new RowLayout();
		rowLayout.type = org.eclipse.swt.SWT.VERTICAL;
		tab1 = new Composite(tab, SWT.NONE);
		tab1.setLayout(rowLayout);
		chk_useTray = new Button(tab1, SWT.CHECK);
		chk_useTray.setText("트레이 사용");
		chk_useNotify = new Button(tab1, SWT.CHECK);
		chk_useNotify.setText("접속 알림 사용");
		chk_viewOnTop = new Button(tab1, SWT.CHECK);
		chk_viewOnTop.setText("항상 위에 표시");
		chk_useSound = new Button(tab1, SWT.CHECK);
		chk_useSound.setText("소리 알림 사용");
		grp_dblClickAction = new Group(tab1, SWT.NONE);
		grp_dblClickAction.setText("대화 상대 더블 클릭시");
		grp_dblClickAction.setLayout(rowLayout1);
		opt_Defaction_msg = new Button(grp_dblClickAction, SWT.RADIO);
		opt_Defaction_msg.setText("쪽지 보내기");
		opt_Defaction_chat = new Button(grp_dblClickAction, SWT.RADIO);
		opt_Defaction_chat.setText("대화 걸기");
	
		
	}

	/**
	 * This method initializes tab2	
	 *
	 */
	private void createTab2() {
		GridData gridData3 = new GridData();
		gridData3.horizontalSpan = 2;
		GridData gridData2 = new GridData();
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.verticalAlignment = GridData.CENTER;
		gridData2.horizontalAlignment = GridData.FILL;
		GridLayout gridLayout1 = new GridLayout();
		gridLayout1.numColumns = 2;
		tab2 = new Composite(tab, SWT.NONE);
		tab2.setLayout(gridLayout1);
		lbl_savepath = new Label(tab2, SWT.NONE);
		lbl_savepath.setText("받은 파일 저장 위치");
		Label filler = new Label(tab2, SWT.NONE);
		txt_savepath = new Text(tab2, SWT.BORDER);
		txt_savepath.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_LIST_SELECTION_TEXT));
		txt_savepath.setLayoutData(gridData2);
		txt_savepath.setText(nate.filemgr.getSavePath());
		//txt_savepath.setEditable(false);
		txt_savepath.setEnabled(false);
		
		btn_browse = new Button(tab2, SWT.NONE);
		btn_browse.setText("...");
		btn_browse.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				DirectoryDialog dd = new DirectoryDialog(sShell);
				
				dd.setFilterPath(nate.filemgr.getSavePath());
				String foo = dd.open();
				
				if(foo!=null)
				{
					txt_savepath.setText(foo);
				}
				
				/*
				if(foo!=null  ){
					File dir = new File(foo);
					if( !dir.canRead() || !dir.exists() || !dir.isDirectory()){
						foo = nate.filemgr.getSavePath();
						txt_savepath.setText(foo);
					}
				}*/
				
				
				//nate.filemgr.setDefaultSavePath(foo);
				
			}
		});
		chk_useFR = new Button(tab2, SWT.CHECK);
		chk_useFR.setText("중계서버 사용(파일 전송에 문제가 있을때 체크해주세요)");
		chk_useFR.setLayoutData(gridData3);
		
		
		
	}
	
	
	/**
	 * 설정값을 읽어온다.
	 */
	private void loadConf() {
		conf = frmmain.getConf();
//		conf.readData();
		String foo;
		
		chk_useTray.setSelection(conf.getBoolean("useTray"));
		//chk_useTray.setSelection(frmmain.useTray);
		
		//chk_useFlashing.setSelected(conf.getBoolean("useFlashing"));
		chk_useNotify.setSelection(conf.getBoolean("useNotify"));
		chk_viewOnTop.setSelection(conf.getBoolean("useAlwaysOnTop"));
		/*
		foo = conf.get("useAutoAway"); 		if(foo==null) foo = "0";
		txt_fun_autoAway.setText(foo);
		*/
		foo = conf.get("DefaultAction");			if(foo==null) foo = "0";
		if(foo.equals("0"))
			opt_Defaction_msg.setSelection(true);
		else
			opt_Defaction_chat.setSelection(true);
	
		foo = conf.get("useSound");					if(foo==null) foo = "default";
		if(foo.equals("default"))
			chk_useSound.setSelection(true);
		else if(foo.equals("noSound"))
			chk_useSound.setSelection(false);
		
		chk_useFR.setSelection(conf.getBoolean("useFR"));
		
		
	}
	/**
	 * 설정값을 저장한다
	 */
	private void saveConf() {
		conf = frmmain.getConf();
				
		
		String foo;
		int bar;
		
		//chk_useTray.setSelected(conf.getBoolean("useTray"));
		
		conf.set("useTray", (chk_useTray.getSelection()) ? "true" : "false" );
		//conf.set("useFlashing", (chk_useFlashing.isSelected()) ? "true" : "false" );
		conf.set("useNotify" , (chk_useNotify.getSelection()) ? "true" : "false" );
		conf.set("useAlwaysOnTop" , (chk_viewOnTop.getSelection()) ? "true" : "false" );
		
		/*
		foo = txt_fun_autoAway.getText();
		
		try{
			bar = Integer.parseInt(foo);
		}catch (NumberFormatException e) {
			bar = 0;
		}
		bar = (bar<0) ? 0: bar;
		conf.set("useAutoAway", bar+"");
		*/
		conf.set("DefaultAction" , (opt_Defaction_msg.getSelection()) ? "0" : "1" );

		foo = "default";
		//foo = opt_snd_default.isSelected() ? "default" : null;
		foo = chk_useSound.getSelection() ?  foo : "noSound" ;
		//foo = opt_snd_custom.isSelected() ? "custom" : foo;
		
		
		conf.set("useSound" ,foo );
		//MsgUtil.println(foo);
		//MusicBox.setEnabled(chk_useSound.getSelection());
		//kfmes.jateon.swt.MusicBox.useSound = ;
		conf.set("FileSavePath", nate.filemgr.getSavePath());
		conf.set("useFR" , chk_useFR.getSelection());
		nate.filemgr.setForceUseFR(chk_useFR.getSelection());
		nate.filemgr.setDefaultSavePath(txt_savepath.getText());
		
		
		conf.writeData();
		//MsgUtil.errPrintln("-_- " + chk_useSound.getSelection());
		
		frmmain.reset();
			
	}

	// dummy constructor
	public OptionDialog() {
		// TODO 자동 생성된 생성자 스텁
	}
	public OptionDialog(MainFrame main, NateonMessenger nate){
		this.frmmain = main;
		this.nate  = nate;
		this.conf = main.getConf();
		
		Display display = Display.getDefault();
		createSShell();
		loadConf();
		sShell.open();
		
		while (!sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		sShell.dispose();
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO 자동 생성된 메소드 스텁
		/* Before this is run, be sure to set up the launch configuration (Arguments->VM Arguments)
		 * for the correct SWT library path in order to run with the SWT dlls. 
		 * The dlls are located in the SWT plugin jar.  
		 * For example, on Windows the Eclipse SWT 3.1 plugin jar is:
		 *       installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
		 */
		Display display = Display.getDefault();
		OptionDialog thisClass = new OptionDialog();
		thisClass.createSShell();
		thisClass.sShell.open();

		while (!thisClass.sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		if(frmmain==null)
			sShell = new Shell(SWT.DIALOG_TRIM);
		else
			sShell = new Shell(MainFrame.shell, SWT.DIALOG_TRIM);
		
		sShell.setText("JaTeOn 환경설정");
		
		createTab();
		createCpz_buttongrp();
		
		sShell.setLayout(new GridLayout());
		sShell.setSize(new Point(400	, 300));
		sShell.setSize(400, 300);
	}

}
