package kfmes.natelib;

import java.io.File;
import java.io.IOException;
import java.net.ServerSocket;
import java.util.ArrayList;

import kfmes.natelib.entity.NateFile;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.ftp.FileRecver;
import kfmes.natelib.ftp.FileSender;
import kfmes.natelib.util.LocalHostLookup;
import kfmes.natelib.util.MsgUtil;

/**
 * 파일전송을 관리하는 클래스이다
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: NateFileManager.java,v 1.28 2007/11/19 10:13:29 kfmes Exp $
 */
public class NateFileManager {

	
	
	public static String fileSep = System.getProperty("file.separator"); 
	private ArrayList<FileSender> senders = new  ArrayList<FileSender>();
	private ArrayList<FileRecver> recvers= new ArrayList<FileRecver>();
	
	private NateonMessenger nate = null;
	private static String DefaultSavePath = System.getProperty("user.home");
	//user.home=C:\Documents and Settings\hyun
	
	public static final int STATUS_RECV_READY = 0;
	public static final int STATUS_SEND_READY = 1;
	public static final int STATUS_SENDING = 2;
	public static final int STATUS_RECVING = 3;
	public static final int STATUS_END = 4;
	public static final int STATUS_FAIL = 5;
	private boolean isForceUseFR = false;
	
	public boolean isForceUseFR(){
		return isForceUseFR;
	}
	
	public void setForceUseFR(boolean flag){
		this.isForceUseFR = flag;
	}
	
	public static String getSavePath(){
		return DefaultSavePath;
	}
	public static void setDefaultSavePath(String path){
		DefaultSavePath = path;
	}
	private int sendCnt = 0;
	public static String localhost = null;
	
	@SuppressWarnings("unchecked")
	public NateFileManager(NateonMessenger nate){
		this.nate  = nate;
		localhost = "127.0.0.1";
		
		try{
			ArrayList<String> list = LocalHostLookup.getLocalhost();
			if(list.size()>0)
				localhost = list.get(0);
			
		//localhost = LocalHostLookup.getLocalhost()// InetAddress.getLocalHost().getHostAddress();
		}catch (Exception e) {e.printStackTrace();
		}
		
	}
	
	
	
	public void putFileSender(FileSender sender){
		senders.add(sender);
	}
	public void putFileRecever(FileRecver recv){
		 recvers.add(recv);
	}
	public void removeFileSender(FileSender sender){
		senders.remove(sender);
	}
	public void removeFileRecever(FileRecver recv){
		recvers.remove(recv);
	}
	public FileSender getFileSender(NateFriend ref){
		for(int i=senders.size()-1;i>=0;i--)
			if(senders.get(i).ref.getNateID().equals(ref.getNateID()))
				return senders.get(i);
		//for(FileSender s : senders)
			//if(s.ref == ref)
//			//if(s.getCookie().equals(cookie))
	//			return s;
		return null;
	}
	public FileRecver getFileRecver(String cookie){
		for(FileRecver r : recvers)
			if(r.getCookie().equals(cookie))
				return r;
		return null;
	}
	
	
	public int getAvailablePort(){
		return getAvailablePort(5004, 5104,1);
	}
	
	public int getAvailablePort(int lowBound, int upperBound, int step){
		for(int i=lowBound;i<upperBound;i+=step){
			if(portTest(i))
				return i;
		}
		return -1;
	}
	
	/**
	 * 포트를 사용할 수 있는지 확인한다.
	 * @param port
	 * @return
	 */
	public boolean portTest(int port){
		ServerSocket  test = null;
		try{
			test = new ServerSocket(port);
			test.setSoTimeout(10);
			test.accept();
			test.close();
			
		}catch (java.io.InterruptedIOException e) {
			try{test.close();}catch (Exception ste) {			};
			return true;
		}
		catch (Exception e) {
			//e.printStackTrace();
			MsgUtil.println("Used port " + port);
			return false;
		}		
		return true;		
	}
	
	
	

	public int genKey(){
		
		int v ;
//		do{
			v = (int) (Math.random()*0x7fff);
//			for(FileRecever r :recevers)
//				r.
//		}while (recevers. .keySet().contains(nate.getOwner().getUid() +":" + v));
		return v;
		
	}
	
	
	public int genRandomNum(int limit){
		int v ;
		//do{
			v = (int) (Math.random()*limit);
		//}while (send_map.keySet().contains(v));
		return v;
	}
	
	
	public void startFileRecv(FileRecver recv ,
			//NateFriend ref, String host, int port, String cookie,
			boolean isDirect) {
		//FileRecver recv = getFileRecver(cookie);
		recv.init();
		//recv.start();		
	}
	

	// 파일받기 처리
	/*
CTOC 80 id@nate.com N 43

REQC NEW 192.168.0.3:5004 100254215:10147

PNAK 80

CTOC 0 id@nate.com 45

REQC RES 111.111.11.11:5004 100254215:10147
 */
	public void procFileRecv(FileRecver recv/*, NateFriend ref, ArrayList<NateFile> list*/) {
		
		if(recv.getFileStat(0)!=STATUS_RECV_READY)
			return;
		recv.setFileStat(0, STATUS_RECVING);
		
		String localip = "127.0.0.1";
		int port = nate.filemgr.getAvailablePort();
		try{
			localip = localhost;////InetAddress.getLocalHost().getHostAddress();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		try{
			int unknown = nate.filemgr.genKey();
			String cookie = nate.getOwner().getUid()+":"+unknown;
			String data = "REQC NEW " + localip +":" + port + " " + nate.getOwner().getUid() + ":" + unknown;
			
			recv.setCookie(cookie);
			recv.setPort(port);
			
			//recv.set(nate,  cookie, port);
			//recv.addFileList(list);
		
			nate.getNS().sendCTOC(recv.ref.getNateID(), data);
		}catch (Exception e) {
			e.printStackTrace();
		}
		putFileRecever(recv);
		
	}



	public void procFileSend(NateFriend ref, File file, SwitchBoardSession ss) {
		try{
			//String cookie = getNextSendCookie(ss.getNateFriend());
			int rnum = genRandomNum(1000);
			String tag = nate.getOwner().getUid() + ":" + rnum;
			MsgUtil.println(tag);
			
			
			
			
			
			//natefile.recver = nateFriend.getNameID();
			//natefile.uId = Long.parseLong(nateFriend.getUid());
			
			//REQC RES 192.168.0.3:5004 1037613324:14489
			//                 0          1           2            3           4          5
			
			String sendFilename = file.getName();
			sendFilename = sendFilename.replaceAll("%", "%25");
			sendFilename = sendFilename.replaceAll(" ", "%20");
			sendFilename = sendFilename.replaceAll("\t", "%20");
			sendFilename = sendFilename.replaceAll("\n", "%0A");
			
			ss.send("WHSP", ss.getNateFriend().getNateID() +
					" FILE REQUEST%091%09" + sendFilename + "|" +
					 file.length()  + "|" + sendCnt + ":" + tag);
			
			NateFile natefile = new NateFile(file.getAbsolutePath(), file.length(), sendCnt ,
					Integer.parseInt(nate.getOwner().getUid()) , rnum);
			
			natefile.isFullPath = true;
			FileSender sender = new FileSender(nate,  ref, tag);
			//natefile.tag = sendCnt + ":"
			sender.addFile(natefile);
	
			//putSendFile( sendCnt + ":" + tag, natefile);
			putFileSender(sender);
			
			ArrayList<NateFile> list = new ArrayList<NateFile>();
			list.add(natefile);
			
			nate.fireFileSend(ss, sender, ref, list );
			
			
			//send_procs.put(nateFriend.getNateID(), sender);
			//putSendFile( nateFriend.getNateID(), natefile);
			//putSendFile(sendCnt + ":" + tag, natefile);
			sendCnt++;
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		
	}



	public void procRecvFR(FileRecver recver) {
		NotificationProcessor ns = nate.getNS();
		//REQC RES 124.136.183.44:5004 10014827278:13306
		//recver.setFR();
		ns.tempStor.put( ns.getTrid()+"","REQC RES 111.111.111:1111 " + recver.getCookie());
		try {
			ns.send("REFR", nate.getOwner().getNateID());
		} catch (IOException e) {
			// TODO 자동 생성된 catch 블록
			e.printStackTrace();
		}
		
	}	
	
	public void stopRecv(String cookie) {
		nate.fireFileTransferAborted(cookie);

		for(FileRecver r : recvers){
			for(NateFile f : r.getFileList()){
				if(f.getCookie().equals(cookie)){
					r.stopFileTransfer();
					
//					ss.sendFileReject(r.ref, r);
					return ;
				}
			}
		}
	}



	public void stopRecv(SwitchBoardSession ss, FileRecver r){// String cookie) {
		nate.fireFileTransferAborted(r.getNateFile().getCookie());
		r.stopFileTransfer();
		ss.sendFileReject(r.ref, r);
		
		/*
		
		*/
	}



	public void stopSend(SwitchBoardSession ss, FileSender s){
		nate.fireFileTransferAborted(s.getNateFile().getCookie());
		s.stopFileTransfer();
		ss.sendFileCancel(s.ref, s);
		/*
		for(FileSender s: senders){

			for(NateFile f : s.getFileList()){
				MsgUtil.errPrintln("f : " + f.getCookie() + " / " + cookie);
				if(f.getCookie().equals(cookie)){
					s.stopFileTransfer();
					return ;
				}
				
			}
		}*/

		
	}

	
	/*
	<<<CTOC 0 id@nate.com 42
	<<<CTOC:REQC NEW 192.168.0.3:5004 100254215:5821
	                 0         1           2            3         4          5
	 */
		public void setSendFileNew(NateFriend ref, String[] ll) {
			//MsgUtil.prints(ll);
			
			FileSender sender = getFileSender(ref);
			if(sender==null)
				sender = new FileSender(nate, ref, ll[4]+":" + ll[5]);
			sender.setCookie(ll[4]+":"+ ll[5]);
			
			
				//sender = new FileSender(nate, ref, ll[4]+":" + ll[5]);
			
			
			/*
			if( (ll[2].startsWith("192.168."))){
			
				sender.isLive = false;
			}*/
			
			//else{
				sender.setNetwork(ll[2], Integer.parseInt(ll[3]));
				
				
				//sender.init(ll[2], Integer.parseInt(ll[3]), ref.getNateID(), ll[4]+":" +ll[5]);;
				
				sender.init();
			//}
			
			//startFileSend(ll[3]);		
			
		}
		
	/*
	<<<CTOC 0 id@nate.com 55
	<<<CTOC:REQC FR 211.234.239.181:5004 100254215:5821 910651557
	               0         1          2                      3            4  5                 6
	 */

		public void setSendFileFR(NateFriend ref, String[] ll) {

			MsgUtil.prints(ll);
			FileSender s= getFileSender(ref);
			if(s!=null)
				removeFileSender(s);
			
			
			if(s==null)
				s = new FileSender(nate,ref,ll[4]+":" +ll[5]);
			
			s.setFR( " " + ll[6]);
			
			if(s.isLive==false){
				s.setNetwork(ll[2], Integer.parseInt(ll[3]));
				
				s.init();			
				
			}	
		}



		
	
	
	

	
}
