package kfmes.natelib;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

import kfmes.natelib.entity.FriendList;
import kfmes.natelib.entity.GroupList;
import kfmes.natelib.entity.NateFile;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.entity.UserStatus;
import kfmes.natelib.event.NateAdapter;
import kfmes.natelib.event.NateListener;
import kfmes.natelib.event.PluginListener;
import kfmes.natelib.ftp.FileRecver;
import kfmes.natelib.ftp.FileSender;
import kfmes.natelib.msg.InstanceMessage;
import kfmes.natelib.msg.MimeMessage;

/**
 * 네이트 메신저를 구현해놓은 클래스이다.
 *
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: NateonMessenger.java,v 1.78 2007/11/19 10:13:29 kfmes Exp $
 */
public class NateonMessenger {

//	private ArrayList<E> SBSessonList = null;
	/**
	 * build date
	 */
	public static final String ver = "20071108";
	boolean isLogged = false;
	private String loginName = null;
	private String password = null;
	public boolean is_encodedpasswd = false;
	protected String initStatus = UserStatus.Online;
	
	private NateListener base = null;
	private FriendList friendlist = null;
	
	private NateonMessenger thiscls = this;
	public static boolean isDebugMode = false;
	protected static boolean isOffLogin = false;
	public NateFileManager filemgr = new NateFileManager(this);
	
	public static boolean isSMSmode = false; // sms 전용 모드일 경우 사용
	
	public String ticket = null;
	
	
	public static void setDebugMode(boolean flag){
		isDebugMode = flag;
	}
	public static void setOffLogin(boolean flag){
		isOffLogin = flag;
	}

	
	private NotificationProcessor ns = null;//new NotificationProcessor( this );
	//private Hashtable sessionMap = new Hashtable();
	private Hashtable<String,SwitchBoardSession> sessionMap = new Hashtable<String,SwitchBoardSession>();
	public ArrayList<SwitchBoardSession> sessionList = new ArrayList<SwitchBoardSession>();
	
	protected ArrayList<NateListener> listeners = new ArrayList<NateListener>();
	protected ArrayList<PluginListener> plisteners = new ArrayList<PluginListener>();

	private NateFriend owner = null;


	
	public NateonMessenger() {
		this( null, null);
	}
	
	public NateonMessenger(String loginname, String passwd){
		this.loginName = loginname;
		this.password = passwd;
		this.owner = new NateFriend(loginName);
		this.base = new Listener();
		
	}
	

	private void initLogon()
	{
		if(friendlist==null)
			friendlist = new FriendList();
		friendlist.clear();
	
	}
	
	protected void loginImpl()
	{
		
		//MsgUtil.println("**LoginImpl");
		// 이미 로그인이 되어 있는경우 먼저 접속을 끊고 재 로그인을 한다.
		try{
			if(isLoggedIn()){
				
				logout();
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		
			
		if(this.ns== null)
			this.ns = new NotificationProcessor( this );

		
		//else if(this.ns.isInterrupted())
		//MsgUtil.println("**LoginImpl NS : NS status is " + ns.isInterrupted());
			
		
		//initLogon();
		//this.ns.start();
		initStatus = UserStatus.Online;
	
		boolean retval  = false;
		retval = ns.Login(loginName, password,is_encodedpasswd);
		
		
		//MsgUtil.println("**LoginImpl / ns.start : " + retval);
		
		//ns.Login(loginName,password);
		
		if(retval ==true ) // socket이  살아있을경우
			ns.start();
		
		
	}


	/**
	 * 주어진 이름과 비밀번호로 로그인을 시작한다.
	 * 이럴 경우 생성자에서 받은 이름과 비밀번호는 무시된다.
	 */
	public void login( String username, String password )
	{
		
		
		this.loginName = username;
		this.password = password;
		
		//MsgUtil.println("**void login()");
		
		loginImpl();
	}
	

	/**
	 * 로그인을 시작한다.
	 */
	public void login()
	{
		if( loginName==null || password==null )
			throw new IllegalArgumentException( "Login name and password must not be null" );
		
	
		
		ns.isRunning = true;
		
		login( this.loginName, this.password );
	}

	/**
	 * 열려있던 모든 Switchboard session과의 연결을 종료하고
	 * NS에 Logout한 후 연결을 종료한다.
	 */
	public void logout() throws IOException
	{
		this.isLogged = false;
		//TODO : SB session close
		for(int i=0;i<sessionList.size();i++)
			sessionList.get(i).close();
		
		//listeners.clear();
		
		try{
			ns.isRunning = false;
			ns.closeConnection();
			//ns.interrupt();
			ns = null;
			System.gc();
			
			//sendMessage("PING",null);
		}
		catch (Exception e) {
			// TODO: handle exception
			//e.printStackTrace();
		}
		
	}
	
	
	public NateFriend getOwner(){
		return this.owner;
	}
	
	public void setOwner(NateFriend owner){
		this.owner = owner;		
	}

	/**
	 * 자신의 상태를 변경한다. 상태 문자열은 UserStatus 인터페이스에
	 * 정의되어있는 문자열만을 사용하여야만 한다.
	 * 로그인이 끝난 직후에는 Default로 온라인 상태가 되어있을 것이다.
	 */
	public void setMyStatus(String status) 
	{
		this.owner.setStatus(status);
		
		try{
			if(ns.socket!=null)
				this.ns.setMyStatus(status);
		}
		catch (NullPointerException e) {
			// TODO: handle exception
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	

	/**
	 * 현재 자기 자신의 상태코드값을 얻어온다.
	 
	public String getMyStatus()
	{
		if( ns==null )
			return UserStatus.Offline;
		return this.ns.getMyStatus();
	}
	*/

	public void setMyNickName( String newName )
	{
		newName = newName.replaceAll("%", "%25").replaceAll(" ", "%20"); //공백 처리 
		this.owner.setNickName(newName);
		this.ns.setMyNickName( newName );
	}
	
	public void setTicket(String ticket) {
		this.ticket = ticket;
	}
	public String getTicket() {
		return ticket;
	}
	
	/**
	 * 현재 로그인 된 상태인지 확인한다.
	 */
	public boolean isLoggedIn()
	{
		return this.isLogged;
	}

	/**
	 * 서버로부터 발생되는 이벤트나 메시지들을 처리할 MsnListner
	 * 인터페이스를 설정한다. 원래는 multi-listener를 지원해야하지만,
	 * 현재는 단일 Listener 구조를 사용한다. 그러므로
	 * 반드시 리스너를 설정해야한다.
	 */
	public synchronized void addNateListener( NateListener l )
	{
		if( !listeners.contains(l) )
			listeners.add(l);
	}

	/**
	 * 현재 등록된 NATEListener의 수를 반환해준다.
	 */
	public int getListenerCount()
	{
		return listeners.size();
	}

	/**
	 * 해당 이벤트리스너를 해제한다.
	 */
	public synchronized void removeNateListener( NateListener l )
	{
		listeners.remove(l);
	}
	
	
	/**
	 * 서버로부터 발생되는 이벤트나 메시지들을 처리할 MsnListner
	 * 인터페이스를 설정한다. 원래는 multi-listener를 지원해야하지만,
	 * 현재는 단일 Listener 구조를 사용한다. 그러므로
	 * 반드시 리스너를 설정해야한다.
	 */
	public synchronized void addPluginListener( PluginListener l )
	{
		if( !plisteners.contains(l) )
			plisteners.add(l);
	}

	/**
	 * 현재 등록된 pluginListener의 수를 반환해준다.
	 */
	public int getPluginListenerCount()
	{
		return plisteners.size();
	}

	/**
	 * 해당 이벤트리스너를 해제한다.
	 */
	public synchronized void removePluginListener( PluginListener l )
	{
		plisteners.remove(l);
	}
	
	public void fireLoginError(String header){
		base.loginError(header);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).loginError(header);
	}

	public void fireInstanceMessageReceived(InstanceMessage imsg){

		base.instanceMessageReceived(imsg);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).instanceMessageReceived(imsg);
	}
	
	/**
	 * NS로 메세지를 보낸다.
	 * @param string
	 * @throws IOException
	 */		
	public void send(String string) throws IOException {
		ns.send(string);
	}
	//protected void sendMessage(String msgtype, String msg) throw
	
	/**
	 * 
	 */
	
	/**
	 * NS로 메세지를 보낸다.
	 */
	public void sendMessage(String msgtype, String msg) throws IOException{
		ns.sendMessage(msgtype,msg);
	}

	/**
	 * NS로 메세지를 보낸다.
	 * @param msg
	 * @throws IOException
	 */
	public void sendIMessage(InstanceMessage msg) throws IOException{
		ns.sendIMessage(msg);
	}
	
	/**
	 * NS를 얻어온다
	 * @return
	 */
	public NotificationProcessor getNS(){
		return this.ns;
	}

	/**
	 * 스위치보드 세션 리스트에서 
	 * 해당 친구에 연결된 세션을 반환해준다
	 * @param friend
	 * @return
	 */
	/*
	public SwitchBoardSession getSBuser(NateFriend fr){
		for(int i =0;i<sessionList.size();i++)
			if(((SwitchBoardSession)sessionList.get(i)).getNateFriend()==fr)
				return (SwitchBoardSession)sessionList.get(i); 
		return null;
	}*/
	

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		//nate.login();
	

	}
	


/**
 * 로그인 완료
 */
	public void fireLoginComplete() {
		base.loginComplete();
		this.isLogged = true;
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).loginComplete();
	}

	public void fireBuddyListInit(GroupList grouplist) {
		base.buddyListInit(grouplist);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).buddyListInit(grouplist);
		
	}
	public void fireBuddyModified(NateFriend friend) {
		base.buddyModified(friend);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).buddyModified(friend);
			
		
	}
	
	public void fireKilled(){
		base.killed();
		
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).killed();
	}
	/*
	public void fireRemoveKilled(){
		base.logoutNotify();
		for(int i=listeners.size()-1; i>=0; i--)
			((NateListener)listeners.get(i)).RemovedKilled();
		
	}
	*/

	public void fireSwitchboardSessionStarted(SwitchBoardSession session){
		base.switchboardSessionStarted(session);
		sessionMap.put(session.getSessionId(), session);
		
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).switchboardSessionStarted(session);		
	}
	
	/**
	 * 해당 loginName과 1:1로 연결된 세션을 찾아준다.
	 * 만약 세션이 존재하지 않는다면, null을 반환한다.
	 */
	public SwitchBoardSession findSwitchboardSessionAt( String loginName )
	{
		
		Enumeration e = sessionMap.elements();
		while( e.hasMoreElements() )
		{
			SwitchBoardSession ss = (SwitchBoardSession)e.nextElement();
			if( ss.getFriendCount()==1 && ss.isInFriend(loginName) )
				return ss;
		}
		
		return null;
	}

	public void fireSwitchboardSessionEnded(SwitchBoardSession session) {
		base.switchboardSessionEnded(session);
		sessionMap.remove(session);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).switchboardSessionEnded(session);
	}

	public void fireChatMessageReceived(SwitchBoardSession ss, NateFriend friend, MimeMessage mime){
		base.chatMessageReceived(ss, friend, mime);
		
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).chatMessageReceived(ss, friend, mime);
	}

	public void fireBuddyListModified(){
		base.buddyListModified();
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).buddyListModified();
	}
	
	public void fireOwnerStatusUpdated(){
		base.OwnerStatusUpdated();
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).OwnerStatusUpdated();
	}
	public void fireUserOnline(NateFriend friend){
		base.userOnline(friend);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).userOnline(friend);
	}
	public void fireUserOffline(NateFriend friend){
		base.userOffline(friend);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).userOffline(friend);
	}
	
	
	
	public void fireProgressTyping( SwitchBoardSession ss, NateFriend friend, int flag){

		base.progressTyping(ss, friend, flag);
		
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).progressTyping(ss, friend, flag);
	
	}
	
	public void fireWhoAddme(NateFriend friend){
		base.whoAddedMe(friend);
		
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).whoAddedMe(friend);
		
	}
	
	public String getInitialStatus() {
		return this.initStatus;
	}
	
	
	public void fireFilePosted(SwitchBoardSession session, FileRecver recv, NateFriend ref, ArrayList<NateFile> list) {
		base.filePosted(session , recv, ref, list);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).filePosted(session , recv, ref, list);
		
		
	}
	
	public void fireFileSendAccepted(SwitchBoardSession ss, String cookie){
		base.fileSendAccepted(ss, cookie);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).fileSendAccepted(ss, cookie);		
	}
	public void fireFileRecved(FileRecver recver, NateFile natefile) {
		base.fileRecved(recver, natefile);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).fileRecved(recver, natefile);
		
	}
	
	public void fireFileSend(SwitchBoardSession session, FileSender sender, NateFriend ref, ArrayList<NateFile> list) {
		base.fileSend(session, sender, ref, list);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).fileSend(session, sender, ref, list);
	}
	
	public void fireFileSended(FileSender sender, NateFile natefile) {
		base.fileSendEnded(sender, natefile);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).fileSendEnded(sender, natefile);
		
	}
	
	
	public void fireFileSendRejected(SwitchBoardSession ss, String cookie, String reason){
		base.fileSendRejected(ss, cookie, reason);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).fileSendRejected(ss, cookie, reason);
	}
	public void fireFileTransferAborted(String cookie) {
		base.fileTransferAborted(cookie);
		for(int i=listeners.size()-1; i>=0; i--)
			listeners.get(i).fileTransferAborted(cookie);
		
	}
	
	public void firePluginData(String data) {
		for(int i=plisteners.size()-1; i>=0; i--)
			plisteners.get(i).incomming(data);		
	}
	

	private class Listener extends NateAdapter
	{
	
	}







	public GroupList getBuddyGroup() {
		return ns.grouplist;
	}

	public void reqAdsb(boolean isAccept, NateFriend friend) {
		ns.sendADSB(isAccept, friend);
		
	}
	
	/**
	 * 그룹을 이동한다
	 * @param friend
	 * @param newg
	 */
	public void moveGroup(NateFriend friend, String newg) {
		ns.moveGroup(friend, friend.getGroup().getNumber(), newg);
		
	}
	

	















}
