package kfmes.natelib.entity;

import java.util.ArrayList;
// import java.util.LinkedList;

import kfmes.natelib.util.MsgUtil;

/**
 * 친구 리스트
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: FriendList.java,v 1.20 2007/11/19 10:13:33 kfmes Exp $
 */
public class FriendList {

	private ArrayList<NateFriend> list = null;
	
	public FriendList() {
		list = new ArrayList<NateFriend>();
	}
	public FriendList(NateFriend friend){
		list = new ArrayList<NateFriend>();
		list.add(friend);
	}
	
	public boolean isNew(NateFriend friend)
	{
		for(int i=0; i< list.size(); i++)
			if(list.get(i).getUid().equals(friend.getUid()))
				return false;
		return true;
	}
	
	public void add(NateFriend friend) {
		if(this.isNew(friend))
			list.add(friend);
	}
	public void remove(NateFriend friend){
		list.remove(friend);
	}
	
	public NateFriend popup() {
		return list.remove(0);
	}
	public NateFriend find(String uid) {
		for(int i=0; i< list.size(); i++)
			if(list.get(i).getUid().equals(uid))
				return list.get(i);
		return null;
	}
	public boolean setFriendStatus(String nateID, String status, String useFTP, String ftpName, String one)
	{
		for(int i=0; i < list.size(); i++)
		{
			//MsgUtil.println("<"+ String.valueOf(i)+">" + list.get(i).getNateID() + " :: " + nateID);
			NateFriend f = list.get(i);
			if(f.getNateID().equals(nateID))
			{
				f.setStatus(status);
				//MsgUtil.println("<><>" + status + " : " + nateID);
				if(useFTP == "1")
					f.setFTP(ftpName);
				return true;
			}
			
		}
		
		return false;
		
	}
	
	/*
	public String getFriendStatus(String nateID)
	{
		for(int i=0; i < list.size(); i++)
		{
			if(((NateFriend)list.get(i)).getNateID().equals(nateID)){
				MsgUtil.println("FList" + ((NateFriend)list.get(i)).getStatus());
				return ((NateFriend)list.get(i)).getStatus();
			}
		}
		return null;
	}
	*/
	
	public void clear(){
		list.clear();
	}
	
	public int count()
	{
		return list.size();
	}
	
	public void listNameID()
	{
		for( int i=0; i < list.size(); i++){
			MsgUtil.println(" ㄴ " + list.get(i).getNameID());
		}
	}
	public void listNameNick()
	{

		for( int i=0; i < list.size(); i++){
			if(list.get(i).getStatus() != "F")
				MsgUtil.println(" ㄴ " + list.get(i).getNameNick());
		}
	}
	public ArrayList<NateFriend> getFriendList(){
		return this.list;
	}
	

	public int searchID(String id){
		for(int i=list.size()-1;i>=0;i--){
			if(id.equals(list.get(i).getID()))
				return i;
		}
		return -1;
	}
	
	/**
	 * 리스트에서 네이트 아이디를 검색해서
	 * NateFriend를 돌려준다
	 * 해당 네이트 아이디가 없는경우 null을 리턴
	 * @param nateID
	 * @return
	 */
	public NateFriend getFriend(String nateID) {
		NateFriend ret;
			for(int i=0;i<list.size();i++){
				ret = list.get(i);
				if(ret.getNateID().equals(nateID))
					return ret;
				
			}
		return null;
	}
	/**
	 * 리스트에서 네이트 uid를 검색해서
	 * NateFriend를 돌려준다
	 * 해당 네이트 아이디가 없는경우 null을 리턴
	 * @param nateID
	 * @return
	 */
	public NateFriend getFriendUid(String uID) {
		NateFriend ret;
			for(int i=0;i<list.size();i++){
				ret = list.get(i);
				if(ret.getUid().equals(uID))
					return ret;
				
			}
		return null;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FriendList test = new FriendList();
		test.clear();	
	}


}