package kfmes.natelib.entity;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

/**
 * 그룹 리스트
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: GroupList.java,v 1.25 2007/11/19 10:13:33 kfmes Exp $
 */

public class GroupList  {

	private ArrayList<NateGroup> list = null;
	
	public GroupList() {
		list = new ArrayList<NateGroup>();
	}
	public GroupList(int index, NateGroup group){
		list = new ArrayList<NateGroup>();
		list.add(index, group);
	}
	
	public boolean isNew(NateGroup group)
	{
		for(int i=0; i< list.size(); i++)
			if(list.get(i).getNumber().equals(group.getNumber()))
				return false;
		return true;
	}
	
	public void add(int index, NateGroup group) {
		for(int i = list.size(); index > list.size(); i++){
			list.add(i, new NateGroup("N", String.valueOf(i), "~not Group"));
			//XXX: 후덜덜 여기서 찍어대고 있었음...
			//MsgUtil.println("Empty group[" + i + "] Created.");
		}
		
		
		if(this.isNew(group))
			list.add(index, group);
	}
	
	
	public void addFriend(int index, NateFriend friend) {
		list.get(index).addList(friend);
	}
	
	public void removeFriend(String nateid){
		
		ArrayList glist= null;
		//FriendList friend = null;
		NateFriend fr;
		
		for(int i=0;i<list.size();i++){
			glist = ((NateGroup)list.get(i)).getList();
			for(int j=0;j<glist.size();j++){
				fr = ((FriendList)glist.get(j)).getFriend(nateid);
				if(fr!=null){
					((FriendList)glist.get(j)).remove(fr);
					return ;
				}
			}
			
		}
	}
	
	public void remove(NateGroup group){
		list.remove(group);
	}
	public void clear(){
		list.clear();
	}
	
	public int count()
	{
		return list.size();
	}
	
	public void listNameId() {
		for(int i=0; i< list.size(); i++)
			list.get(i).listNameId();
	}
	
	public void listNameNick()
	{
		for(int i=0; i< list.size(); i++) 
			list.get(i).listNameNick();
	}
	public int length(){
		return list.size();
	}
	
	public NateGroup get(int index){
		return list.get(index);
	}
	
	public void sortGroup()
	{
		ArrayList<NateGroup> tempList = new ArrayList<NateGroup>();
		for(int i=0; i < list.size(); i++) {
			if(list.get(i).getVisual().equals("Y"))
				tempList.add(list.get(i));
		}
		
		list = tempList;
		int current; 
		NateGroup tempGroup;
		
		Collections.sort(list, new Comparator<NateGroup>(){
			public int compare(NateGroup a, NateGroup b) {
				String c1 = a.getName();
				String c2 = b.getName();
				
				if(c1.equals("미분류"))
					return 1;
				if(c1.equals("기타"))
					return 1;
				
				if(c1.charAt(0) > 0xac00 && c2.charAt(0) > 0xac00 )
					return c1.compareTo(c2);
				else if(c1.charAt(0) > 0xac00  && c2.charAt(0) < 0xac00)
					return -1;
				//else
				
		
					
					
				return a.getName().compareTo(b.getName());
				//return 0;
			}
			
		});
/*
		for(int i=0; i < list.size(); i++) {
			//if(list.get(i).getVisual().equals("N")) continue;
			current = i;
			
			for(int j=i; j < list.size(); j++) {
				//if(list.get(j).getVisual().equals("N")) continue;
				if(list.get(j).getName().compareTo(list.get(current).getName()) < 0)
					current = j;
			}
			
			tempGroup = list.get(i);
			list.set(i, list.get(current)); 

			list.set(current, tempGroup);
		}
		*/ 
	}
	
	public boolean setFriendStatus(String nateID, String status, String useFTP, String ftpName, String one)
	{
		for(int i=0; i < list.size(); i++) {
			if(list.get(i).get().setFriendStatus(nateID, status, useFTP, ftpName, one))
				return true;
		}
		
		return false;
		
	}
	
	/*

	public String getFriendStatus(String nateID)
	{
		for(int i=0; i < list.size(); i++) {
			MsgUtil.println("GList : "+ ((NateGroup)list.get(i)).get().getFriendStatus(nateID));
			return (((NateGroup)list.get(i)).get().getFriendStatus(nateID));
		}
		
		return null;
		
	}
*/	
	
	/**
	 * 그룹리스트에서 아이디로 해당 NateFriend 를 얻어온다.
	 * 찾지 못했을 경우는 null을 리턴한다.
	 * @param nateID
	 * @return
	 */
	
	public NateFriend getFriend(String nateID)
	{
		NateFriend foo;
		
		for(int i=0; i < list.size(); i++) {
			foo = list.get(i).get().getFriend(nateID);
			if(foo!=null)
				return foo;
		}
		
		return null;
		
	}
	/**
	 * 그룹리스트에서 uid 로 해당 NateFriend 를 얻어온다.
	 * 찾지 못했을 경우는 null을 리턴한다.
	 * @param nateID
	 * @return
	 */
	
	public NateFriend getFriendUid(String uID)
	{
		NateFriend foo;
		
		for(int i=0; i < list.size(); i++) {
			foo = list.get(i).get().getFriendUid(uID);
			if(foo!=null)
				return foo;
		}
		
		return null;
		
	}
	public NateGroup getGroup(int index){
		for(NateGroup g : list){
			if(Integer.parseInt(g.getNumber())==index)
				return g;
		}
		return null;
	}
	
	public NateGroup getGroup(String name){
		for(NateGroup g : list){
			if(g.getName().equals(name))
				return g;
		}
		return null;
	}
	
	public ArrayList<NateGroup> getList(){
		return this.list;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		GroupList test = new GroupList();
		test.clear();
	

	}
}
