/**
 * 
 */
package kfmes.natelib.entity;

import java.io.File;

import kfmes.natelib.NateFileManager;

/**
 * 네이트온 파일을 추상화
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: NateFile.java,v 1.8 2007/11/19 10:13:34 kfmes Exp $
 */
public class NateFile {
	public String fileName = null;
	public boolean isFullPath = false;
	public long fileSize = -1;
	
	private int cookie_idx = -1;
	private long cookie_uid = -1;
	private int cookie_rno = -1;
	
	
	public String getCookie(){
		return cookie_idx + ":" + cookie_uid + ":" + cookie_rno;
	}
	
	
	public NateFile(String filename, long fileSize, int idx, int uid, int rno){
		this.fileName = filename;
		this.fileSize = fileSize;
		setCookie(idx, uid, rno);
	}
	public NateFile(String fileInfo){
		String ll[] = fileInfo.split("[|:]");
		//MsgUtil.prints(ll);
		this.fileName = ll[0];
		this.fileSize = Long.parseLong(ll[1]);
		this.cookie_idx = Integer.parseInt(ll[2]);
		this.cookie_uid = Long.parseLong(ll[3]);
		this.cookie_rno = Integer.parseInt(ll[4]);
		
	}
	
	public void setCookie(int idx, int uid, int rno){
		this.cookie_idx = idx;
		this.cookie_uid = idx;
		this.cookie_rno = rno;
	}
	public File getFile(){
		if(isFullPath)
			return new File(fileName);
		return new File(
					NateFileManager.getSavePath() + 
					NateFileManager.fileSep +
					fileName);
	}
	
	private int toInt(String i){
		return Integer.parseInt(i);
	}

}
