/**
 * 
 */
package kfmes.natelib.entity;


/**
 * 네이트 폰트
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: NateFont.java,v 1.10 2007/11/19 10:13:33 kfmes Exp $
 */
public class NateFont {
	private String name = "굴림";
	private String style = "";
	private String size = "10";
	private String color = FontColor.Black;
	
	public final int FontStyle_none = 0; 
	public final int FontStyle_Strike = 1; //"S";
	public final int FontStyle_Underline = 2;//"U";
	public final int FontStyle_StrikeUnderline = 3;//"SU";
	
	
	public NateFont(){
		setDefault();
	}
	
	
	public NateFont(String Name, String Style, String size, String Color){
		setFont(Name, Style, size, Color);
	}
	
	public void setDefault(){
		name = "굴림";
		style = "";
		size = "9";
		color = FontColor.Deafult;		
	}
	
	public void setFont(String Name, String Style, String size, String Color){
		this.name = Name;
		this.style = Style;
		//this.setStyle(Style);
		this.size = size;
		this.color = Color;		
	}
	
	public void setStyle(int Style){
		switch (Style) {
		case FontStyle_none:
			this.style = "";
			break;
		case FontStyle_Strike:
			this.style = "S";
			break;
		case FontStyle_Underline:
			this.style = "U";
			break;
		case FontStyle_StrikeUnderline:
			this.style = "SU";
			break;

		default:
			break;
		}
	}
	public void setColor(String Color){
		this.color = Color;
	}
	
	public String toString(){
		String str =
			"font-color:" + this.color + "\r\n" +
			"font-name:" + this.name + "\r\n" +
			"font-size:" + this.size + "\r\n" + 
			"font-style:" + this.style + "\r\n" 
			;
			
		return str;
	}
	/*
font-color:#050505
font-name:......
font-size:9
font-style:%00
	 */
	
	public String[] toArrayString(){
		return new String[]{
			"font-color:" + this.color  ,
			"font-name:" + this.name ,
			"font-size:" + this.size  ,
			"font-style:" + this.style };			
		
	}
}
/*

<<<font-name:굴림
<<<font-style:
<<<font-size:10
<<<font-color:#808080

font-name:굴림
font-style:
font-size:10
font-color:#050505
*/