package kfmes.natelib.entity;

/**
 * Nateon Friend
 * @author bronks, kfmes
 * @version $Id: NateFriend.java,v 1.34 2007/11/19 10:13:33 kfmes Exp $
 */
public class NateFriend {
	private String listFABR = null;
	private String nateID = null;
	private String uid = null;
	private String realname = null;
	private String nickname = null;
	private String phoneNumber = null;
	private String email = null;
	private String birth = null;
	private String cyworldNum = null;
	private String unknown1 = null;		// 1
	private String unknown2 = null;		// 1
	private String unknown3 = null;		// %20 | 011xxxxxxxx@sktims.net 
	private String unknown4 = null;		// %20
	private String unknown5 = null;		// N
	private String status = null;
	private boolean useFTP = false;
	private String ftpName = null;
	private String tag = null;
	private NateGroup nateGroup;
	
	/**
ForwardList, AllowList, BlockList, ReverseList 에요 
F는 내 친구목록에 보여지는 사람들이고 
A는 나에게 메시지나 쪽지를 보낼 수 있도록 허용된 사람들 
B는 차단~ 
R은 나를 F에 등록한 사람들! 

	 */
	
	public static final int VIEW_NAME = 0;
	public static final int VIEW_NICK= 1;
	public static final int VIEW_ID = 2;
	public static final int VIEW_NAME_ID = 3;
	public static final int VIEW_NAME_NICK = 4;
	
	/*
1.1.1.1.1. <<< LIST [1][2][3][4][5][6][7][8][9][10][11][12][13][14]
1.1.1.1.2. [1] TrID
1.1.1.1.3. [2] 친구 번호
1.1.1.1.4. [3] 전체 친구 수
1.1.1.1.5. [4] 리스트 관계 표시 : 연속된 4개의 숫자는 FL(Forward List), AL(Allow List), BL(Block List), RL(Reverse List) 순으로 해당 리스트에 속해 있는지 여부를 표시한다.
1.1.1.1.6. [5] 네이트 접속 계정 （E-mail address)
1.1.1.1.7. [6] 개인 고유 번호
1.1.1.1.8. [7] 친구 이름
1.1.1.1.9. [8] 친구 대화명
1.1.1.1.10. [9] 휴대전화 번호 : 등록하지 않았을 경우 %00으로 표시됨.
1.1.1.1.11. [10] 추가 메일 주소 : 등록하지 않았을 경우 %00으로 표시됨.
1.1.1.1.12. [11] 그룹 고유 번호 : GLST 명령의 [5] 파라미터와 연동.
1.1.1.1.13. [12] 싸이월드 홈페이지 고유 번호 : 등록하지 않았을 경우 %00으로 표시됨.
1.1.1.1.14. [13] ??
1.1.1.1.15. [14] ??
1.1.1.1.16. [15] %00
1.1.1.1.17. [16] %00
1.1.1.1.18. [17] 네이트 Tong 서비스 연동 여부

	 */
	

	public NateFriend(String loginName) {
		this(null, loginName, null, null, null, null, null, null,null, null, null,null, null, null);
	}
	
	public NateFriend(String nateID, String NickName, String RealName)
	{
		this(null, nateID, null, RealName, NickName, null, null, null,null, null, null,null, null, null);
	}
	
	public NateFriend(String nateID, String uid, String realname, String nickname, String phoneNumber)
	{
		this(null, nateID, uid, realname, nickname, phoneNumber, null, null, null, null, null, null, null, null);
	}
	
	public NateFriend(String listFABR, String nateID, String uid, String realname,
	 		String nickname, String phoneNumber, String email, String birth, String groupID,
	 		String one, String two, String three, String four, String five)
	{
		this.listFABR = listFABR;
		this.nateID = nateID;
		this.uid = uid;
		this.realname = realname;
		this.nickname = nickname;
		this.phoneNumber = phoneNumber;
		this.email = email;
		this.birth = birth;
		this.cyworldNum = groupID;
		this.unknown1 = one;
		this.unknown2 = two;
		this.unknown3 = three;
		this.unknown4 = four;
		this.unknown5 = five;
		this.status = UserStatus.Offline;
	}
	/*
if(this.listFABR!=null && this.listFABR.charAt(2)=='1' ){ // blocked user
			if(this.status.equals(UserStatus.Offline)){
				this.status = UserStatus.OFF_Blocked;
				return UserStatus.OFF_Blocked;
			}
			this.status = UserStatus.OFF_Blocked;
			return UserStatus.ON_Blocked;
		}
	 */
	public boolean isBlocked(){
		
		if(listFABR!=null && listFABR.charAt(2)=='1')
			return true;
		return false;
	}


	public void setFABR(String listFABR)
	{
		this.listFABR = listFABR;
	}
	public String getFABR()
	{
		return this.listFABR;
	}

	public void setNateID( String nateID )
	{
		this.nateID = nateID;
	}
	
	
	public String getNateID()
	{
		return this.nateID;
	}
	
/**
 * 수동으로 ForwardList, AllowList, BlockList, ReverseList를 설정한다
 * 인자로 해당 FABR 에 해당되는 비트를  flag속성으로 바꾼다
 * 
 * @param flag
 * @param Fabr
 */
	public void setFABR(boolean flag, String Fabr){
		char foo[] = Fabr.toCharArray();
		char fabr[]= new char[4];
		char val = (flag) ? '1' : '0';
		
		if(this.listFABR==null)
			fabr = "0000".toCharArray();
		else
			fabr = this.listFABR.toCharArray();
		
		for(int i=0;i<foo.length;i++){
			switch (foo[i]) {
			case 'F':
				fabr[0] = val;				
				break;
			case 'A':
				fabr[1] = val;		
				break;
			case 'B':
				fabr[2] = val;
				break;
			case 'R':
				fabr[3] = val;
				break;
			}
		}// end for
		this.listFABR = fabr.toString();
	}
	
	public void setUid(String uid){
		this.uid = uid;
	}
	public String getUid(){
		return this.uid;
	}
	
	public void setRealName(String name){
		this.realname = name;
	}
	public String getRealName(){
		return this.realname;
	}
	
	public void setNickName( String nickname )
	{
		this.nickname = nickname;
	}
	public String getNickName()
	{
		if(this.nickname==null){
			if(this.realname!=null)
				return this.realname;
			else 
				return null;
		}
		
		if(this.nickname.equals("%00"))
			return this.realname;
		return this.nickname;//.replace("%20", " ").replace("%25", "%");
	}
	


	public void setPhoneNumber(String num){
		this.phoneNumber = num;
	}
	public String getPhoneNumber(){
		return this.phoneNumber;
	}

	public void setEmail(String email)
	{
		this.email = email;
	}
	public String getEmail()
	{
		return this.email;
	}
	
	public void setBirth(String birth)
	{
		this.birth = birth;
	}
	public String getBirth()
	{
		return this.birth;
	}
	/* 이거 call 할 일이 없지않은가 -_-;
	public void setCyworldNum( String index )
	{
		this.groupID = index;
	}*/
	public String getCyworldNum()
	{
		return this.cyworldNum;
	}

	public void setStatus( String st )
	{
		if( st==null )
			st = UserStatus.Offline;
		this.status = st;
	}
	public String getStatus()
	{
		if(this.status==null)
			return UserStatus.Offline;
		if(isBlocked()){
			if(status.equals(UserStatus.Offline))
				return UserStatus.OFF_Blocked;
			return UserStatus.ON_Blocked;
		
		}
		return this.status;
	}
	
	/*
	public final static String Online = "O";
	public final static String Away = "A";
	public final static String Busy = "B"; 
	public final static String Phone = "P";
	public final static String Meeting = "M";
	public final static String Invisible = "X";
	public final static String Offline = "F";
	 */
	public String getFormattedStatus(){
		String retval = "";

		
		if(status.equals("O"))
			retval = "온라인";
		else if(status.equals("A"))
		retval = "자리비움";
		else if(status.equals("B"))
			retval = "다른 용무 중";
		else if(status.equals("P"))
			retval = "통화 중";
		else if(status.equals("M"))
			retval = "회의 중";
		else if(status.equals("X"))
			retval = "오프라인으로 표시";
		else 
			retval = "오프라인";
		
		
		
		return retval;
	}
	/**
	 * 네이트 아이디를 가져온다.
	 * @return
	 */
	public String getID(){
		return this.nateID;
	}
	

	public String getNameID()
	{
		return this.realname + "(" + this.nateID + ")";
	}
	public String getNameNick()
	{
		if(realname==null || nickname==null)
			return "null";
		return this.realname + "(" + this.nickname.replaceAll("%20", " ").replaceAll("%25", "%") + ")";
	}
	public String getFormattedBuddy(){
		String foo = getNickName() + "(" + this.realname + ")";
		
		return foo.replaceAll("%20", " ").replaceAll("%25", "%") ;
	}
	
	
	public void setFTP(String ftpName)
	{
		this.ftpName = ftpName;
		this.useFTP = true;
	}
	
	
	public String getFTP()
	{
		if(this.useFTP)
			return this.ftpName;
		return null;
	}
	
	/**
	 * 평소엔 잘 안쓰이는 method
	 * 친추요청같은걸 할때 요청인사밀 정도 를 넣는 용도로 사용
	 * @param text
	 */
	public void setTag(String text){
		this.tag = text;
	}
	/**
	 * 평소엔 잘 안쓰이는 method
	 * 친추요청같은걸 할때 요청인사밀 정도 를 넣는 용도로 사용
	 * @param text
	 */	
	public String getTag(){
		return this.tag;
	}
	@Override
	public boolean equals(Object f) {
		if (f instanceof NateFriend) {
			NateFriend fr = (NateFriend) f;
			return this.nateID.equals(fr.nateID);
		}
		
		return false;
	}
	
	public String toString(){
		return listFABR + '\n' + nateID+ '\n'+ uid+ '\n'+realname +'\n'+ nickname
			+'\n'+phoneNumber +'\n'+ email+'\n'+birth +'\n'+cyworldNum +"\nUNKNOWN FIELD:\n"+unknown1 +'\n'+
			unknown2 +'\n'+ unknown3+'\n'+ unknown4+'\n'+unknown5+'\n'+status;
	}
	
	public String getBuddyText(int viewMode){
		String txt = null;
		try{
			switch( viewMode )
			{
			case VIEW_NAME:
				txt = getRealName();//.concat(status);
				break;
			case VIEW_NICK:
				txt = getNickName().replaceAll("%20", " ").replaceAll("%25", "%");
				break;
			case VIEW_ID:
				txt = getID().concat(status);
				break;
			case VIEW_NAME_ID:
				txt = getRealName() + "(" + getID() + ")" ;
				break;
			case VIEW_NAME_NICK:
				txt = getRealName() + "(" + getNickName().replaceAll("%20", " ").replaceAll("%25", "%") + ")";
				break;
				/*
			case VIEW_LOGIN_NAME:
				setText( friend.getNameID() .getLoginName().concat(status) );
				break;*/
			}
		}catch (Exception e) {
			txt = "(NULL)";
		}
	return txt;		
	}

	public void setGroup(NateGroup group) {
		this.nateGroup = group;
		
	}
	public NateGroup getGroup(){
		return this.nateGroup;
	}
	
}