/**
 * 
 */
package kfmes.natelib.ftp;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.SocketException;
import java.util.ArrayList;

import kfmes.natelib.NateFileManager;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFile;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.util.MsgUtil;

/**
 * 파일전송에 쓰이는 Thread
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: AbstractTransfer.java,v 1.12 2007/11/19 10:13:35 kfmes Exp $
 */
public abstract class AbstractTransfer extends Thread{
	protected Socket socket = null;
	protected int trId = 0;
	public NateFriend ref = null;
	protected NateonMessenger nate = null;
	protected NateFileManager mgr = null;
	public boolean isLive = false;
	protected InputStream in = null;
	protected OutputStream out = null;
	protected ArrayList<NateFile> list = new ArrayList<NateFile>();
	protected ArrayList<Integer> stats = new ArrayList<Integer>();
	protected String cookie = null;
	
	protected String host = null;
	protected int port = 5004;
	
	protected boolean isFR = false;
	
	protected long[] offset = {0,};
	protected byte[] buf;
	protected String frCookie = null;;

	protected void close() 
	{
		isLive = false;
		
					
		if( in!=null )
		{
			try{ in.close(); } catch( Exception e ) {}
		}
		if( out!=null )
		{
			try{ out.close(); } catch( Exception e ) {}
		}
		if( socket!=null )
		{
			try{ socket.close(); } catch( Exception e ) {}
		}
	}
	public void stopFileTransfer(){

		stats.set(0, NateFileManager.STATUS_FAIL);
		close();
		
	}
	
	protected String readLine() throws IOException
	{
		ByteArrayOutputStream inbuf = new ByteArrayOutputStream();
		inbuf.reset();
		while(true)		{	
			try{			
				if(socket==null || socket.isClosed())		return null;

					if(in.available()>0){
						int v = in.read();					
						if( v==-1 )		return null;
						if( v==13 )		continue;
						if( v==10 )		break;
						inbuf.write(v);
					}
					else{
						try{
							sleep(10);
						}
						catch (Exception e) {	e.printStackTrace();	}
					}
			}catch (SocketException e) {
				return null;
			}
		}
	
		MsgUtil.println("<" + inbuf.toString());
		return new String(inbuf.toByteArray(),"UTF8");
	}

	/**
	 * 현재 실제로 수신된 byte 수를 반환한다.
	 */
	public long getCurrentFileSize(int i)
	{
		return this.offset[i];
	}

	public long getCurrentPercent(int i)
	{
		return (long)(((double)offset[i] / (double)list.get(i).fileSize) * 100.0D);
	}
	

	protected void sendMessage( String header, String body ) throws IOException
	{
		StringBuffer sb = new StringBuffer();
		sb.append( header );
		sb.append( ' ' );
		sb.append( trId++ );
		sb.append( ' ' );
		sb.append( body );
		sb.append( "\r\n" );
		MsgUtil.println(">" + sb.toString());
		out.write(sb.toString().getBytes("UTF8"));
		out.flush();
	}
	public int getFileCount() {
		return list.size();		
	}
	protected NateFile getFile(NateFile file){
		for(NateFile f : list)
			if(f.equals(file))
				return f;
		return null;
	}
	public void addFile(NateFile file){
		this.list.add(file);
	}
	public void addFileList(ArrayList<NateFile> srclist) {
		this.list.addAll(srclist);
			
	}
	
	
	public void removeFile(NateFile file){
		list.remove(file);		
	}
	public String getCookie(){
		return this.cookie;
	}
	public ArrayList<NateFile> getFileList() {
		return this.list;
	}
	public NateFile getNateFile(){
		return list.get(0);
	}

	
	public void set(NateonMessenger nate,  NateFriend ref, String cookie){
		this.nate = nate;
		this.mgr = nate.filemgr;
		this.ref =ref;
		this.cookie = cookie;

	}
	public void set(NateonMessenger nate,  NateFriend ref, String cookie,int port){
		this.nate = nate;
		this.mgr = nate.filemgr;
		this.ref =ref;
		this.cookie = cookie;
		this.port = port;
	}
	public void setNetwork(String host ,int port){
		this.host = host;
		this.port = port;
	}
	public void setNetwork(String string) {
		String l[] = string.split("[:]");
		this.host = l[0];
		this.port = Integer.parseInt(l[1]);		
	}
	public void setRef(NateFriend ref){
		this.ref = ref;
	}
	public void setCookie(String cookie){
		this.cookie = cookie;
	}
	
	public void setFR(){
		this.isFR = true;
	}
	public void setFR(String frCookie){
		this.frCookie  = frCookie;
		this.isFR = true;
	}

	public int getFileStat(int i) {
		return stats.get(i);
		
	}
	public void setFileStat(int idx, int mode){
		stats.set(idx, mode);
	}
	
}
