/**
 * 
 */
package kfmes.natelib.ftp;

import java.io.FileOutputStream;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;

import kfmes.natelib.NateFileManager;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFile;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.util.MsgUtil;

/**
 * 파일 받기
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: FileRecver.java,v 1.19 2007/11/19 10:13:35 kfmes Exp $
 */
public class FileRecver extends AbstractTransfer {
	/** 
	 * server socket
	 * socket accept 
	 * file recv
	 */
	private ServerSocket servSocket = null;
	
	
	
	private FileOutputStream fos = null;
	private NateFile natefile = null;
	
	public FileRecver() {
		
	}
	public FileRecver(NateonMessenger nate, NateFriend ref, String cookie
			//, int port
			){
		set(nate,  ref, cookie);
	}

	
	private void netinit() {
		/*
		this.host = host;
		this.port = port;
		*/
		//boolean isdbg = true;
		try{
			//if(isdbg)
//				throw new SocketTimeoutException();
			
			servSocket = new ServerSocket(port);
			servSocket.setSoTimeout(1000);
		}catch (java.io.InterruptedIOException /*SocketTimeoutException*/ ste) {
			// timeout 이 발생했을시에 fr로 받는다
			isLive =false;
			
			nate.filemgr.procRecvFR(this);

			return;
		}catch (java.net.BindException be) {
			MsgUtil.err.println("bind err port : " + port);
			
		} catch (IOException e) {
		
			e.printStackTrace();
		}
		try{
			socket = servSocket.accept();
			//this.socet = new Socket( this.host, this.port );
			this.in = socket.getInputStream();
	
			this.out = socket.getOutputStream();//new PrintWriter(sock.getOutputStream());
			for(long o : offset)
				o =0;
			isLive = true;

		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void netinitFR(){
		/*
		this.host = host;
		this.port = port;
		this.cookie = cookie;
		*/
		try{
			socket = new Socket(host, port);
			in = socket.getInputStream();
			out = socket.getOutputStream();
			
			sendMessage("FRIN", 
					//nate.getOwner().getNateID()
					ref.getNateID()
					+" " + frCookie );
			
			//CTOC 134 id@nate.com N 58
			//REQC FR 211.234.239.175:5004 10014827278:13306 841114845
			}catch (Exception e) {
				isLive = false;
				e.printStackTrace();
			}
	}
	
	public void init(){
		this.isLive = true;
		setName("FILE RECV : " + ref.getNateID());
		
		if(isFR)
			netinitFR();
		else
			netinit();
	
			
		
		this.natefile = list.get(0);
		
		try{
			fos = new FileOutputStream(this.natefile.getFile());
		}catch (Exception e) {
			e.printStackTrace();
			this.isLive = false;
		}
		
		buf = new byte[8191];
		
		if(isLive)
			start();		
	}
	
	public void run(){
		//init();
	
		
		while(isLive){
			try{
				String line = null;
			
				if(offset[0]==natefile.fileSize){
					sendMessage("FILE" , "END N 0");
					
					isLive = false;
					stats.set(0, NateFileManager.STATUS_END);
					nate.fireFileRecved(this, natefile);
					break;
				}
				
				line = readLine();
				if(line==null)
					break;
				//ll = line.split(" ");
				
				if(line.startsWith("ATHC"))
					procATHC(line);
				else if(line.startsWith("FILE"))
					procFILE(line);
				else if(line.startsWith("FRIN")){
					nate.getNS().sendCTOC(ref.getNateID(), "REQC FR " + host + ":" + port + " " + cookie +" " + frCookie);
				}
			
			}catch (Exception e) {
				e.printStackTrace();
			}
			
			
		}
		try{
			fos.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
		if(offset[0]!=natefile.fileSize)
			stats.set(0, NateFileManager.STATUS_FAIL);

		nate.filemgr.removeFileRecever(this);
		close();
		MsgUtil.println("Terminated : " + this.getName());
	}

	private void procATHC(String line) throws IOException{
		String ll[] = line.split(" ");

		String body = "100 " + ll[6] + " " + ll[7];
		sendMessage("ATHC", body);
		//sendMessage("ATHC", "100 6004 0");
		trId--;;
		sendMessage("FILE", "ACCEPT " + natefile.getCookie() + " 0");
		
				
	}
	private void procFILE(String line) throws IOException{
		//FILE 0 INFO FILENAME 26 CHAT 0
		String ll[] = line.split(" ");
		if(ll[2].equals("INFO")){
			//FILE 0 ACCEPT 71:2147483647:156 0
		//	this.natefile =filemgr.getRecvFile(ll[3]);
			//this.fileCookie = ll
			sendMessage("FILE", "START 0 0");
			stats.set(0, NateFileManager.STATUS_RECVING);
			
			//nate.fireFileRecvStart(this, natefile);
		}
			
		if(ll[2].equals("DATA"))
			getFileSegment(0,Integer.parseInt(ll[3]));
		
		
	}
	
	public void addFileList(ArrayList<NateFile> list) {
		super.addFileList(list);
		for(int i=0;i<list.size();i++)
			stats.add(NateFileManager.STATUS_RECV_READY);
			
	}
	
	private void getFileSegment(int idx, int limit) throws IOException {

		try{
			for(int i=0;i<limit;){
				int toReadsize  = limit-i > buf.length ? buf.length : limit-i;
				int read = in.read(buf,0,  toReadsize);
				

				fos.write(buf, 0, read);

				offset[0]+=read;
				i+=read;
				
			}
			if(natefile.fileSize<offset[0])
				MsgUtil.errPrintln("File Size over");
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		fos.flush();
		
		
	}
	public void setPort(int port) {
		this.port = port;
		
	}
	
	
	
	

}
