/**
 * 
 */
package kfmes.natelib.ftp;

import java.io.FileInputStream;
import java.io.IOException;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.util.ArrayList;

import kfmes.natelib.NateFileManager;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFile;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.util.MsgUtil;


/**
 * 파일 보내기
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: FileSender.java,v 1.13 2007/11/19 10:13:35 kfmes Exp $
 */
public class FileSender extends AbstractTransfer{
	/** 
	 * socket connect
	 * file send
	 * close
	 */
	private FileInputStream fis = null;
	private boolean sendFlag =false;

	private NateFile natefile = null;
	
	public FileSender() {
		frCookie = "";
	}
	
	public FileSender(NateonMessenger nate, NateFriend ref, String cookie
			//, int port
			){
		frCookie = "";
		set(nate,  ref, cookie);
	}
	/*
	public FileSender(NateonMessenger nate, NateFileManager mgr, NateFriend ref, String cookie){
		set(nate, mgr, ref, cookie);
	}*/
	
	public void set(NateonMessenger nate, NateFileManager mgr, NateFriend ref, String cookie){
		this.nate = nate;
		this.mgr = mgr;
		this.ref =ref;
		this.cookie = cookie;
	}
	
	private void procFILE(String line) throws IOException{
		
		//FILE 0 INFO FILENAME 26 CHAT 0
		//<FILE 0 ACCEPT 0:1037613324:585 0
		String ll[] = line.split(" ");
		if(ll[2].equals("ACCEPT")){
			
			
			//sendMessage(header, body)
			//sendMessage("FILE", "START 0 0");
			//MsgUtil.prints(ll);
			//this.natefile = // filemgr.getSendFile(ll[3]);
			sendMessage("FILE", "INFO FILENAME " + natefile.fileSize+" CHAT 0");
			//this.file = new File(natefile.getFile());
			fis = new FileInputStream(natefile.getFile());
			
			
			
			//sendFlag  = true;
		}
		else if(ll[2].equals("START")){
			//nate.fireFileSendStart(this, natefile);
			// TODO: 나중에 이어받기 처리도 해야됨
			offset[0] = Long.parseLong(ll[3]);
			stats.set(0, NateFileManager.STATUS_SENDING);
			sendFlag = true;
		}
		else if(ll[2].equals("END")){
			stats.set(0, NateFileManager.STATUS_END);
			sendFlag = false;
			isLive = false;
			nate.fireFileSended(this, natefile);
		}
		
	}
	
	
	public void init(){
		this.isLive = true;
		
			netinit();
		if(!isLive)
			return;
		
		
		this.natefile = list.get(0);
		
		try{
			fis = new FileInputStream(this.natefile.getFile());
		}catch (Exception e) {
			e.printStackTrace();
			this.isLive = false;
		}
		
		buf = new byte[8191];
		
		if(isLive)
			start();		
	}
	
	

	private void netinit() {
		try{
		
			if(!isFR){
				try{			
					
					String data = "REQC RES " + NateFileManager.localhost + ":5004 " + cookie;
					
					nate.getNS().sendCTOC(ref.getNateID(),data );
					
				}catch (Exception e) {
					e.printStackTrace();
				}
			}
			//if(isFR)
//				MsgUtil.println("FR MODE : " + host + ":" + port);
			
			
			
			this.socket = new Socket( host, port );
			
			MsgUtil.println("sender : connected");
			
			this.in = socket.getInputStream();
	
			this.out = socket.getOutputStream();//new PrintWriter(sock.getOutputStream());
			
			offset[0]  =0 ;
			isLive = true;
		}catch (SocketTimeoutException e) {
			isLive = false;
		
		}catch (Exception e) {
			MsgUtil.err.println("host : " + host + " port : " + port);
			e.printStackTrace();
			isLive = false;
		}
	}

	public void run(){
		setName("FILE SEND " + ref.getNateID());
	
		
		
		//if(nate.filemgr.isForceUseFR()){
			try{
				sendMessage("ATHC", nate.getOwner().getID() + " " + 
						ref.getNateID() + " " + cookie + frCookie + "   6004 0");
				trId --;
			}catch (Exception e) {
				e.printStackTrace();
			}
			/*
		if(isFR){
			nate.getNS().sendCTOC(ref.getNateID(), data)
		}*/
			
		//}
		
		int length;
		String line = null;
		natefile = list.get(0);
		
		while(isLive){
			try{
			
				/*
				if(offset==natefile.fileLength){
					sendMessage("FILE" , "END N 0");
					break;
				}*/
				
				if(sendFlag){
					
					length = (int) (natefile.fileSize- offset[0] < buf.length ?
							natefile.fileSize- offset[0] : buf.length);
					putFileSegment(length);
					if(natefile.fileSize == offset[0]){
						stats.set(0, NateFileManager.STATUS_END);
						sendFlag = false;
					}
				}
				
				if(!sendFlag)
					line = readLine();
				
				if(line==null)
					continue;
				//ll = line.split(" ");
				
				//if(line.startsWith("ATHC"))
//					procATHC(line);
				else if(line.startsWith("FILE"))
					procFILE(line);
				
				
				
				
				line = null;
			//ATHC 0 A@dreamwiz.com B@dreamwiz.com 1037613324:17996  6004 0
			
			}catch (Exception e) {
				e.printStackTrace();
			}
			
		}
		
		try{
			fis.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
		if(offset[0]!=natefile.fileSize)
			stats.set(0, NateFileManager.STATUS_FAIL);
		close();
		MsgUtil.println("Terminated : " + this.getName());
		isLive = false;
		nate.filemgr.removeFileSender(this);
		
	}
	
	@Override
	public void addFile(NateFile file) {
		super.addFile(file);
		stats.add(NateFileManager.STATUS_SEND_READY);
	}
	
	public void addFileList(ArrayList<NateFile> list) {
		super.addFileList(list);
		for(int i=0;i<list.size();i++)
			stats.add(NateFileManager.STATUS_SEND_READY);
			
	}

	private void putFileSegment(int length) throws IOException {
		
		//String foo ;
		try{
			
			sendMessage("FILE", "DATA " + length);
			
			for(int i=0;i<length;){
				//int toReadsize  = length-i > buf.length ? buf.length : length-i;
				int read = fis.read(buf,0,  length);
				
				
				/*
				try{
				foo = new String(buf,read-50,50);
				System.out.println("DBG[" + (offset + read-50 ) +"]" + foo);
				}catch (Exception e) {		e.printStackTrace()	; }
				*/
				//fis.read() .write(buf, 0, read);
			//	MsgUtil.err.println("written bytes " + read);
				
				offset[0]+=read;
				i+=read;
				out.write(buf, 0, read);
	
				
				
			}
			if(natefile.fileSize<offset[0])
				MsgUtil.errPrintln("File Size over");
			
		}catch (Exception e) {
			e.printStackTrace();
			this.isLive = false;
		}
		
		//fis.flush();
		

	}
	

}
