package kfmes.natelib.msg;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;

import kfmes.natelib.entity.NateFont;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.util.DateUtil;
import kfmes.natelib.util.MsgUtil;

/**
 * 네이트온 쪽지
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: InstanceMessage.java,v 1.9 2007/11/19 10:13:35 kfmes Exp $
 */
public class InstanceMessage extends Message {

	private HashMap<String, String> data = new HashMap<String, String>();
/*
	private String title = null;
	private String from = null;
	private String ref = null;
	private String date = null;
	private int session_id = -1;
	private String uuid = null;
	private String contenttype = null;
	private int length = -1;
*/	
	private String message = null;

	private NateFont font = null;
	private NateFriend friend = null;
	
	
	

	public InstanceMessage(){
		
	}
	
	public InstanceMessage(String from, String to, String Msg) {
		this(from,to,Msg,null);
	
	}
	
	/**
	 * ctoc body 내용으로 만든다.
	 * @param ctocBody
	 * @added 2007. 08. 20
	 */
	public InstanceMessage(String ctocBody){
		data.clear();
		ctocBody = MsgUtil.getRealString(ctocBody);
		String ctoc[] =ctocBody.split("\r\n"); 
		
		int i;
		
		for(i=0;i<ctoc.length;i++){
			String e = ctoc[i];
			if(e.equals("IMSG"))	continue; 
			if(e.equals("")) 			break;// msg body
			
			int idx = e.indexOf(":");
			data.put(e.substring(0,idx), e.substring(idx+1));
		}
		
		i++;
		this.message = ctoc[i];
	}
	

	public void setFriend(NateFriend friend){
		this.friend = friend;
	}
	
	public NateFriend getFriend() {
		return friend;
	}
	
/**
 * 보낼때 사용하는 생성자
 * @param from
 * @param to
 * @param Msg
 * @param font
 */		 
	public InstanceMessage(String from, String to, String Msg, NateFont font ) {
/*
CTOC 0 id@nate.com 273
IMSG
contenttype:text
date:20070820000138
font-color:#050505
font-name:......
font-size:9
font-style:%00
from:id@nate.com
length:22
ref:ref@dreamwiz.com
session_id:395172
title:hello%20world
uuid:b8370847-619d-4705-afd0-098daa2769db

hello world 

 */		
		type = "IMSG";
		header = "IMSG";
		String title;
		
		data.clear();
		
		
		
		this.message = Msg.trim();
		{
			String tmp[] = this.message.split("\r\n");
			title = tmp[0];
		}
		
		data.put("title" , title.replaceAll(" " ,"%20"));		
		data.put("from", from);
		data.put("ref", to);
		data.put("date", DateUtil.getFormattedDate());
		data.put("session_id", this.getRandomSessionID()+"");
		data.put("uuid", this.getRandomUuid());
		data.put("contenttype", "text");
		
		
		
		
		//this.from = from;
		//this.ref = to;
		//this.date = DateUtil.getFormattedDate();
		////session_id = "1509354";
		//session_id = this.getRandomSessionID();
		//uuid = this.getRandomUuid();//"1f3e9d5a-c071-4e71-bfa0-ef8cb27bf9da";
		//contenttype = "text";
		
		
		//this.length =this.message.getBytes().length+1;//Msg.length();// Msg.getBytes().length;
		data.put("length", this.message.getBytes().length+1 +"");
			
		if(font==null)
			this.font = new NateFont();
		else
			this.font = font;
		putFont(this.font);
		
	}
	
	private void putFont(NateFont f){
		for(String e : f.toArrayString()){
			int idx = e.indexOf(":");
			data.put(e.substring(0,idx), e.substring(idx+1));
		}		
	}
	
	private void set(String K, String V){
		data.remove(K);
		data.put(K, V);
	}
	
	public void setRecv(String to){
		set("ref", to);
	}
	/*
	public void setTrid(String id){
		this.session_id = id;
	}
	*/
	
	public String toString(){
		/*
		String ret =
			"IMSG\r\n" +
			"title:" + this.title + "\r\n" +
			"from:" + this.from + "\r\n" + 
			"ref:" + this.ref  + "\r\n" +
			"date:" + this.date + "\r\n" +
			"session_id:" + this.session_id + "\r\n" +
			"uuid:" + this.uuid + "\r\n" +
			"contenttype:" + this.contenttype + "\r\n" +
			"length:" + this.length + "\r\n" +
			this.font.toString() + "\r\n" +
			this.message + " " ; //\r\n" ;
			*/
		ArrayList<String> ls = new ArrayList<String>();
		ls.addAll(data.keySet());
		Collections.sort(ls);
		
		StringBuffer ref = new StringBuffer("IMSG\r\n");
		
		for(int i=0;i<data.size();i++){
			ref.append( ls.get(i));
			ref.append(':');
			ref.append(data.get(ls.get(i)));
			ref.append("\r\n");
		}
		ref.append("\r\n");
		ref.append(this.message);
		ref.append(' ');
		
		return ref.toString();
	}
	
	public String getFrom() {		
		return data.get("from");
	}
	public String getRef() {		
		return data.get("ref");
	}
	public int getLength() {

		int length;
		/*
		try {
			length = this.toString().getBytes().length;//("UTF-8").length; // .getBytes().length;
		} catch (UnsupportedEncodingException e) {

			e.printStackTrace();
			return -1;
		}*/
		
		length = this.toString().getBytes().length;
		return length;
	}
	
	private int  getRandomSessionID() {
		int foo = (int) (Math.random()*999999);//+123456;
		if(foo<100000)
			foo += 123456;
		return foo;
	}
	private String getRandomUuid() {
		StringBuffer sb = new StringBuffer();
		sb.append(getRandomHex(8) + "-");
		sb.append(getRandomHex(4) + "-");
		sb.append(getRandomHex(4) + "-");
		sb.append(getRandomHex(4) + "-");
		sb.append(getRandomHex(12) );
		return sb.toString();
	}
	
	private String getRandomHex(int digit){
		StringBuffer sb = new StringBuffer(digit);

		int foo;
		for(int i=0;i<digit;i++){
			foo = (int) (Math.random()*16);
			if(i==0 && foo ==0) 
				foo++;
			
			sb.append( Character.forDigit(foo,16));
			
		}
	
		return sb.toString(); 
	}
	
	public String getContenttype() {
		return data.get("contenttype");
	}
	public String getDate() {
		return data.get("date");
	}
	public String getMessage() {
		return message;
	}
	
	public NateFont getFont() {		
		if(this.font!=null)
			return this.font;
		else
			return new NateFont(
				data.get("font-name") , //name,
				data.get("font-style"), //style,
				data.get("font-size"), //size,
				data.get("font-color")); //color
	}
				
				
	public String getTitle() {
		return data.get("title");
	}
	public void setFrom(String from) {
		set("from", from);
	}
	public void setRef(String ref) {
		set("ref", ref);
	}
	

	
	public static void main(String[] args) {
		InstanceMessage t = new InstanceMessage();
		//MsgUtil.println(t.parseDate());		

	}

}
