package kfmes.natelib.msg;

/**
 * MIME 메시지들을 관리하는 클래스이다.
 *
 * @author Jang-Ho Hwang, rath@linuxkorea.co.kr
 * @version $Id: MimeMessage.java,v 1.8 2007/11/19 09:36:44 kfmes Exp $
 */
public class MimeMessage
{
	private String nateID = null;
	private String type = "MSG";
	private String fontName = "굴림";
	private String unknownItem1 = null;
	private String unknownItem2 = null;
	private String message = "";
	private boolean success = true;
	
	public MimeMessage(String rawline) {
		String line[] = rawline.split(" ");
		
		
		this.nateID = line[2];
		this.type = line[3];
		String list[] = line[4].split("%09");
		
		if(list.length>1){
			
			this.fontName = list[0];
			this.unknownItem1 = list[1];
			this.unknownItem2 = list[2];
			this.message = list[3];
		}
		else {
			this.message = line[4];
		}

	}
	
	public MimeMessage(String nateID, String message) {
		this.nateID = nateID;
		this.message = message;

	}
	public MimeMessage(String nateID, boolean success) {
		this.nateID = nateID;
		this.success = false;
	}
	/*
	public MimeMessage(String nateID, String message, String fontname, String unknownStrings) {
		this.nateID = nateID;
		this.message = message;
		this.fontName = fontname;
		this.unknownStrings = unknownStrings;
		
	}
	*/
	
	public String getFontName() {
		return fontName;
	}
	public String getMessage() {
		return message;
	}

	public String toString() {
		return message;
	}
	public String getNateID() {
		return nateID;
	}
	
	public String getType() {
		return type;
	}
	
	public void setType(String type) {
		this.type = type;
	}

	public boolean isSuccess() {
		return success;
	}

	public void setMessage(String message) {
		this.message = message;
	}


	
	//<<<MESG 0 id@nate.com MSG 굴림%098388736%09%09덜덜덜
	//<<<MESG 0 id@nate.com MSG 왜안된
	

};
