/**
 * 
 */
package kfmes.natelib.msg;

import kfmes.natelib.util.HttpClient;
import kfmes.natelib.util.HttpOutgoingMsg;
import kfmes.natelib.util.MsgUtil;


/**
 * 네이트온의 SMS를 구현한 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: NateSMS.java,v 1.11 2007/11/19 10:13:36 kfmes Exp $
 */
public class NateSMS {
	private String Cookie = null;
	private String Ticket = null;
	private String ID = null;
	private HttpClient ie = null;
	private HttpOutgoingMsg msg = null;
	
	private int freeCnt = 0;
	private int fplusCnt = -1;
	
	
	/**
	 * NateSMS 내부적으로 사용됨
	 * http post 로 ticket 을 보낼때 사용
	 */
	private String getPostTicketID(){
		return "t=" + this.Ticket + "&code=G009&param=%3fTICKET%3d" + this.Ticket + 
		"%26ID%3d" + this.ID + "%26mobile%3d" ;
	}

	/**
	 * 무료 문자 + 유료문자의 개수를 얻는다.
	 * @return
	 */
	private String getFreeCntNplusCnt(){
		return "freeCnt=" + this.freeCnt + "&fplusCnt=" + this.fplusCnt;
	}
	
	/**
	 * 기본적인 NateSMS 생성자
	 * Nateon 의 티켓과 아이디를 필요로 한다.
	 * @param Ticket
	 * @param ID
	 */
	public NateSMS(String Ticket, String ID) {
		this.Ticket = Ticket;
		this.ID = ID;
		connect();
	}
	
	/**
	 * Test 용 생성자
	 * 쓰지마셈
	 */
	public NateSMS(){
		
		String foo= "var freeAmount = \"21\";\n" +
		"			var fplusAmount = \"-1\";\n" +
		"			var fplus100Amount = \"-1\";\n" +
		"			var fplus500Amount = \"-1\";\n" +
		"			var cashAmount = \"0\";\n" +
		"			var couponAmount = \"0\";\n" +
		"			var isPBill = false;\n" +
		"			var sSaveMsg = \"Y\";\n" +
		"			var VERSION = \"3.0\";\n" +
		"						var iMemberGrade = \"2\";\n" +
		"			var iMemberGradeForMMS = \"2\";\n" +
		"			var smcgHost = \"http://color-web.nate.com/mms/web/nateon_static/\";\n			";

		foo = foo.replaceAll("[\t|\"|;\r ]|var", "");
		String bar[] = foo.split("\n|=");
		/**
		 * freeAmount 1
		 * fplusAmount 3
		 * fplus100Amount 5
		 * fplus500Amount 7
		 * cashAmount 9
		 * couponAmount 11 
		 */
		
		{
			this.freeCnt= getAmount(bar[1]);
			this.fplusCnt = getAmount(bar[3]) + getAmount(bar[5]) +getAmount(bar[7]); 
			
		}
		
	}
	
	/**
	 * NateSMS 내부적으로 사용되는 메소드
	 * 단순히 String 입력값을 받아 
	 * -1 인경우 0 , 아닌경우 그 숫자를 리턴
	 * @param amount
	 * @return
	 */
	private int getAmount(String amount){
		int num = Integer.parseInt(amount);
		return num<0 ? 0 : num;
	}
	
	/**
	 * 문자를 보내기 위한 준비과정이다
	 * SMS에 연결하고 사용가능한 문자개수를 알아낸다.
	 */
	public void connect() {
		String html = null;
		try{
			
			msg = new HttpOutgoingMsg("POST","br.nate.com","/index.php");
			
			msg.setBody(getPostTicketID());
			
			
			
			ie = new HttpClient();
			ie.makeConnection("br.nate.com");
			ie.setMessage(msg);
			html = ie.navigate();
			
			String ref = html.substring(html.indexOf("location.href")+17, html.indexOf("\';\">"));
			//System.out.println("--------");
			//System.out.println(html);
			
			msg.set("GET", "sms.nate.com", ref);
			
			ie.makeConnection("sms.nate.com");
			html = ie.navigate();
			/*
			System.out.println("--------");
			System.out.println(html);
			
		//msg.set("POST", "sms.nate.com", "/nateon2007/index.jsp");
			msg.Referer = ref;
			msg.setBody("mobile=&ticket="+Ticket+"&ID=" + ID);
			ie.makeConnection("sms.nate.com");
			ie.setMessage(msg);
			html = ie.navigate();
			System.out.println("--------");
			System.out.println(msg.getHeader() + msg.getBody());
			System.out.println(html);
			*///
			//System.out.println(html);
			//
			
			{
				String co = html.substring(html.indexOf("Set-Cookie: ") +12 , html.indexOf(";") +1);
				
				int pos = html.indexOf("path=/")+18;
				String coo = html.substring(pos,  html.indexOf(";", pos));
				
				Cookie = co + ' ' + coo;
				//String foo = html.substring(html.indexOf("<form action"), html.indexOf("</form>"));
				//pos =foo.indexOf("<input type=hidden name=freeCnt value=")+39;
				//freeCnt = 1;
				//freeCnt = Integer.parseInt(foo.substring(pos,foo.indexOf("\"", pos)));				
				//pos = foo.indexOf("<input type=hidden name=fplusCnt value=") + 40;				
				//fplusCnt = Integer.parseInt(foo.substring(pos,foo.indexOf("\"", pos) ));				
												
			}
			msg.set("POST", "sms.nate.com", "/nateon2007/index.jsp");
			msg.Cookie = Cookie;
			msg.Referer = ref;
			msg.setBody("mobile=&ticket=" + this.Ticket );//+ this.getFreeCntNplusCnt() );
			
			ie.makeConnection("sms.nate.com");
			html = ie.navigate();
			//System.out.println(html);
			msg.set("POST", "sms.nate.com", "/nateon2007/sms.jsp");
			msg.Referer = ie.getVisitedURL();
			
			msg.setBody("msg=&mobile=&mode=&id=&url=&price=&title=&xtfile=&giffile=&tctype=&t=" +
					this.Ticket + "&category=0" );//+ this.getFreeCntNplusCnt()			);
			
			ie.makeConnection("sms.nate.com");
			html = ie.navigate();
			//System.out.println("--------------------");
			//System.out.println(html);
			
			{
				int pos = html.indexOf("var freeAmount");
				int pos2 = html.indexOf("function", pos);
				String foo  = html.substring(pos, pos2);
				foo = foo.replaceAll("[\t|\"|;|\r| ]|var", "");
				String bar[] = foo.split("\n|=");
				//MsgUtil.prints(bar);
				/**
				 * freeAmount 1
				 * fplusAmount 3
				 * fplus100Amount 5
				 * fplus500Amount 7
				 * cashAmount 9
				 * couponAmount 11 
				 */
				
				{
					this.freeCnt= getAmount(bar[1]);
					this.fplusCnt = getAmount(bar[3]) + getAmount(bar[5]) +getAmount(bar[7]); 
					
				}
				
			}
			
			
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * sms를 발송한다.
	 * @param message 메세지 내용
	 * @param recv 받는 사람 번호
	 * @param send 보내는 사람 번호
	 * @return 전송여부
	 */
	public boolean sendSMS(String message, String recv, String send){
		String html = null;
		try{

			
			//sms send
			
			String sms_msg = escape(message);
	/*			
	//POST /servlets/NateonSparrow?receivenum=0164108421&receivename=%20&
			v_message=abcdefghijk%0D%0A%uAC00%uB098%uB2E4%uB77C%0D%0A%uC548%uB155%uD558%
			uC138%uC694%0D%0A%251%252%253%254%2520
			&sendnum=0164108421&rsvdate=000000000000&display=MMS&freeA  */
			String sms_uri = "/servlets/NateonSparrow?receivenum=" + recv + 
				"&receivename=%20&v_message="+ sms_msg + 
				"&sendnum=" + send + 
				"&rsvdate=000000000000&display=MMS&freeA";
			
			msg.Referer = ie.getVisitedURL();
			msg.set("POST","sms.nate.com", sms_uri );
			msg.setBody("msg=&isFirst=first");
			
			ie.makeConnection("sms.nate.com");
			html = ie.navigate();
			{
				int pos = html.indexOf("\'");
				String data = html.substring(pos+1, html.indexOf("\'",pos+1));
				msg.Referer = null;
				msg.set("GET", "sms.nate.com", data);
			}
			
			ie.makeConnection("sms.nate.com");
			html = ie.navigate();
			
			//System.out.println(html);
		}
		catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		MsgUtil.println(html);
		
		if(html.indexOf("function start")<0)
			return false;
		this.freeCnt--;
		return true;		
		
	}
	
	/**
	 * 개발시 테스트용 method 
	 * 쓰지마셈
	 */
	public void testSend(){
		String html = null;
		try{
			System.err.println("please wait");
			Thread.sleep(5000);
			System.err.println("HAHAHA");
			
			//sms send
			String str = "흐음...-_-";
			String sms_msg = escape(str);
	/*			
	//POST /servlets/NateonSparrow?receivenum=0164108421&receivename=%20&
			v_message=abcdefghijk%0D%0A%uAC00%uB098%uB2E4%uB77C%0D%0A%uC548%uB155%uD558%
			uC138%uC694%0D%0A%251%252%253%254%2520
			&sendnum=0164108421&rsvdate=000000000000&display=MMS&freeA  */
			String sms_uri = "/servlets/NateonSparrow?receivenum=" + "0164108421" + 
				"&receivename=%20&v_message="+ sms_msg + 
				"&sendnum=" + "0164108421" + 
				"&rsvdate=000000000000&display=MMS&freeA";
			
			msg.Referer = ie.getVisitedURL();
			msg.set("POST","sms.nate.com", sms_uri );
			msg.setBody("msg=&isFirst=first");
			
			ie.makeConnection("sms.nate.com");
			html = ie.navigate();
			{
				int pos = html.indexOf("\'");
				String data = html.substring(pos+1, html.indexOf("\'",pos+1));
				msg.Referer = null;
				msg.set("GET", "sms.nate.com", data);
			}
			
			ie.makeConnection("sms.nate.com");
			html = ie.navigate();
			
			System.out.println(html);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * SMS내용을 보낼때 사용된다
	 * 자바스크립트의 escape 함수를 구현한것
	 * @param string
	 * @return
	 */
	private static String escape(String string){
		StringBuffer sb = new StringBuffer();
		String ncStr = "*+-./0123456789@ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz";
		char c;
		
		for(int i=0;i<string.length();i++){
			c = string.charAt(i);
			if(c>0x7f)
				sb.append("%u" + Integer.toHexString((int)c).toUpperCase());
			else if(ncStr.indexOf((int)c)==-1){
				sb.append('%');
				if(c<=0xf)
					sb.append('0');
				sb.append(Integer.toHexString((int)c).toUpperCase());
			}
			else 
				sb.append(c);
		}
		
		return sb.toString();
	}
	
	/**
	 * 사용가능한 무료 문자수를 얻어온다.
	 * @return
	 */
	public int getFreeCnt(){
		return this.freeCnt;
	}
	/**
	 * 사용가능한 유로 문자수를 얻어온다.
	 * @return
	 */
	public int getFreePlusCnt(){
		return this.fplusCnt;
	}
	
	
	/**
	 * 테스트용 -_-)/
	 * @param args
	 */
	public static void main(String[] args){
		new NateSMS();

	}
	
	

}
