/**
 * 
 */
package kfmes.natelib.util;

import java.util.Calendar;
import java.util.Date;

/**
 * 날짜 및 시간 관련유틸리티성 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: DateUtil.java,v 1.7 2007/11/19 10:13:37 kfmes Exp $
 */
public class DateUtil {
	
	/**
	 * 현재 시각을 
	 * 20070920205037 과같은 형태로 리턴해준다.
	 * @return formattedDate
	 */
	public static String getFormattedDate() {
		Calendar cur = Calendar.getInstance();
				
		String yy,mm,dd, th, tm , ts;
		int t;
		String Date;
		yy = cur.get(Calendar.YEAR) + "";
		t =  cur.get(Calendar.MONTH)+1;
		mm = (t <10) ? "0"+t : t+"";
		t = cur.get(Calendar.DAY_OF_MONTH);
		dd = (t<10)  ? "0"+t : t+"";
		t = cur.get(Calendar.HOUR_OF_DAY);
		th = (t<10)  ? "0"+t : t+"";
		t = cur.get(Calendar.MINUTE);
		tm = (t<10)  ? "0"+t : t+"";
		t = cur.get(Calendar.SECOND);
		ts = (t<10)  ? "0"+t : t+"";
		
		Date = yy + mm + dd + th + tm + ts;
	
		return Date;
	
	}
	
	/**
	 * timestamp를 기준으로 
	 * 20070920205037 과같은 형태로 리턴해준다.
	 * @return formattedDate
	 */
	public static String getFormattedDate(long timestamp) {
		
		Calendar cur = Calendar.getInstance();
		cur.setTime(new Date(timestamp));
		
		String yy,mm,dd, th, tm , ts;
		int t;
		String Date;
		yy = cur.get(Calendar.YEAR) + "";
		t =  cur.get(Calendar.MONTH)+1;
		mm = (t <10) ? "0"+t : t+"";
		t = cur.get(Calendar.DAY_OF_MONTH);
		dd = (t<10)  ? "0"+t : t+"";
		t = cur.get(Calendar.HOUR_OF_DAY);
		th = (t<10)  ? "0"+t : t+"";
		t = cur.get(Calendar.MINUTE);
		tm = (t<10)  ? "0"+t : t+"";
		t = cur.get(Calendar.SECOND);
		ts = (t<10)  ? "0"+t : t+"";
		
		
		
		Date = yy + mm + dd + th + tm + ts;
	
		return Date;
	}
	
///////////01234567 89012345
//###date:20060905 232333
	/**
	 * 연속된 Date String 을 입력받아 (20070101121233)
	 * 2007-01-01 12:12:33 과 같은 형태로 만들어준다
	 * @param date
	 * @return formattedDate
	 */

	public static String toFormattedDate(String date){
		char datearr[]  = date.toCharArray();
		StringBuffer to = new StringBuffer(date.length()+10);
		
		for(int i=0;i<datearr.length;i++){
			switch (i) {
			case 4:
			case 6:
				to.append('-');
				break;
			case 8:
				to.append(' ');
				break;

			case 10:
			case 12:
				to.append(':');
				break;
			}
			
			to.append(datearr[i]);
		}
		
		return to.toString();			
	}
	
	/**
	 * 현재 날짜와 시각을 
	 * xxxx.xx.xx xx:xx 형태로 출력한다.
	 * @return formattedDate
	 */
	public static String toTextString(){
		Calendar cur = Calendar.getInstance();
		
		String yy,mm,dd, th, tm , ts;
		int t;
		String Date;
		yy = cur.get(Calendar.YEAR) + "";
		t =  cur.get(Calendar.MONTH)+1;
		mm = (t <10) ? "0"+t : t+"";
		t = cur.get(Calendar.DAY_OF_MONTH);
		dd = (t<10)  ? "0"+t : t+"";
		t = cur.get(Calendar.HOUR_OF_DAY);
		th = (t<10)  ? "0"+t : t+"";
		t = cur.get(Calendar.MINUTE);
		tm = (t<10)  ? "0"+t : t+"";
		t = cur.get(Calendar.SECOND);
		ts = (t<10)  ? "0"+t : t+"";
		
		Date = yy+ "." + mm +"."+ dd + " " + th + ":" + tm;
	
		
		return Date;
	}
	
	
	/**
	 * 테스트용
	 * @param args
	 */
	public static void main(String[] args){
		System.out.println(DateUtil.getFormattedDate());
	}

}
