package kfmes.natelib.util;


import java.io.InputStreamReader;
import java.net.URL;


/**
 * HTML을 웹에서 가져오는 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: HtmlReader.java,v 1.8 2007/11/19 10:13:36 kfmes Exp $
 */
public class HtmlReader {
	private InputStreamReader in;
	private URL Url;
	public String document ="";
	public StringBuffer StrBuffer;
	
		
	public HtmlReader(){}	// 기본 생성자
	
	/*********************************
	 * url 에서 html소스를 읽어오기만 한다. 
	 * @param url
	 ********************************/
	public HtmlReader(String url){

		document = this.read(url);
	}
	public HtmlReader(String url,String charset){
		if(charset.equalsIgnoreCase("UTF8"))
			document = this.readUTF8(url);
		else
			document = this.read(url);
					
				
	}

	
	/*********************************************
	 * url로 부터 html을 읽어서 String 형태로 리턴한다.
	 * @param url
	 * @return document
	 ********************************************/
	public String read(String url){
		boolean flag = true;
		String page =""; 
		String tmpURL = "";
		int ch;
			
		try{
			//MsgUtil.println(url);			
			while(flag){
				StrBuffer = new StringBuffer();
				
				if((!url.startsWith("http://")) && (!url.startsWith("HTTP://")) && (!url.startsWith("file://")))
					url = "http://" + url;
				
				Url = new URL( url);
				in = new InputStreamReader(Url.openStream());
				
///				System.out.println(in.getEncoding());
				
				
				while((ch = in.read()) != -1 ){
					StrBuffer.append((char)ch);		
				}
				StrBuffer = new StringBuffer(new String(StrBuffer.toString().getBytes(in.getEncoding())));
				
				int idx1=-1, idx2=-1;
				int end;
				
				flag = false;
			
				//MsgUtil.print(buf);
				if(StrBuffer.indexOf("<meta http-equiv=") >=0 ){
					if(StrBuffer.indexOf("refresh")>0 || StrBuffer.indexOf("REFRESH")>0  )
						if(StrBuffer.indexOf("content") >0 || StrBuffer.indexOf("CONTENT") >0 )
							if((idx1 = StrBuffer.indexOf("url")) >0 || (idx2 = StrBuffer.indexOf("URL")) >0 )
							{
									if (idx1==-1)  idx1 = idx2 ;
									if (idx1==-1) break;
									tmpURL = StrBuffer.substring(idx1+4);	
									
									//MsgUtil.println("> " + tmpURL);
									
									tmpURL.trim();
									if (tmpURL.startsWith("\"") || tmpURL.startsWith("'"))
										tmpURL = tmpURL.substring(1);
									tmpURL.trim();
									
									if((!tmpURL.startsWith("http://")) && (!tmpURL.startsWith("HTTP://")))
										tmpURL = "http://" + tmpURL;
									
									if((end = tmpURL.indexOf("'"))>0) tmpURL = tmpURL.substring(0,end);
									if((end = tmpURL.indexOf("\""))>0) tmpURL = tmpURL.substring(0,end);
									if((end = tmpURL.indexOf(">"))>0) tmpURL = tmpURL.substring(0,end);
						
									//MsgUtil.println("> " + tmpURL);
									end = StrBuffer.length();
									url = tmpURL;
									flag = true;
				
							}
											
				}
			}
			
		}
		
		catch(Exception ex){
			ex.printStackTrace();
		}
		
		document = StrBuffer.toString();
		
		return document;
	}

	/*********************************************
		 * url로 부터 html을 읽어서 String 형태로 리턴한다.
		 * @param url
		 * @return document
		 ********************************************/
		public String readUTF8(String url){
			boolean flag = true;
			String page =""; 
			String tmpURL = "";
			int ch;
				
			try{
				//MsgUtil.println(url);			
				while(flag){
					StrBuffer = new StringBuffer();
					
					if((!url.startsWith("http://")) && (!url.startsWith("HTTP://")) && (!url.startsWith("file://")))
						url = "http://" + url;
					
					Url = new URL( url);
					in = new InputStreamReader(Url.openStream(),"UTF-8");
					
	///				System.out.println(in.getEncoding());
					
					
					while((ch = in.read()) != -1 ){
						StrBuffer.append((char)ch);		
					}
				
					
					int idx1=-1, idx2=-1;
					int end;
					
					flag = false;
				
					//MsgUtil.print(buf);
					if(StrBuffer.indexOf("<meta http-equiv=") >=0 ){
						if(StrBuffer.indexOf("refresh")>0 || StrBuffer.indexOf("REFRESH")>0  )
							if(StrBuffer.indexOf("content") >0 || StrBuffer.indexOf("CONTENT") >0 )
								if((idx1 = StrBuffer.indexOf("url")) >0 || (idx2 = StrBuffer.indexOf("URL")) >0 )
								{
										if (idx1==-1)  idx1 = idx2 ;
										if (idx1==-1) break;
										tmpURL = StrBuffer.substring(idx1+4);	
										
										//MsgUtil.println("> " + tmpURL);
										
										tmpURL.trim();
										if (tmpURL.startsWith("\"") || tmpURL.startsWith("'"))
											tmpURL = tmpURL.substring(1);
										tmpURL.trim();
										
										if((!tmpURL.startsWith("http://")) && (!tmpURL.startsWith("HTTP://")))
											tmpURL = "http://" + tmpURL;
										
										if((end = tmpURL.indexOf("'"))>0) tmpURL = tmpURL.substring(0,end);
										if((end = tmpURL.indexOf("\""))>0) tmpURL = tmpURL.substring(0,end);
										if((end = tmpURL.indexOf(">"))>0) tmpURL = tmpURL.substring(0,end);
							
										//MsgUtil.println("> " + tmpURL);
										end = StrBuffer.length();
										url = tmpURL;
										flag = true;
					
								}
												
					}
				}
				
			}
			
			catch(Exception ex){
				ex.printStackTrace();
			}
			
			document = StrBuffer.toString();
			
			return document;
		}

	/******************************
	 * 전에 읽었던 html 소스를 리턴한다. 
	 * @return document
	 *****************************/
	public String toString(){
		return this.document;
	}
	
	/******************************
	 * 전에 읽었던 html 소스를 리턴한다. 
	 * @return document
	 *****************************/
	public String getHTML(){
		return this.toString();
	}
	
	/****************************
	 * html 문서에서 태그를 없애준다.
	 * @param document
	 * @return document
	 ***************************/
	public static String Strip_tags(String s){
		return s.replaceAll("(?:<!.*?(?:--.*?--s*)*.*?>)|(?:<(?:[^>'\"]*|\".*?\"|'.*?')+>)","");
	}
	
	/****************************
	 * html 문서에서 A 태그를 없애준다.
	 * @param document
	 * @return document
	 ***************************/
	public static String removeATag(String s) {
        return s.replaceAll("(?:<s*[a|A]s*(?:[^>'\"]*|\".*?\"|'.*?')+>)|(?:<s*/[a|A]s*>)","");
    }
	
	/********************
	 * 잘 돌아가는지 테스트용
	 * @param args
	 ********************/
	public static void main(String args[])
	{
		String html;
		HtmlReader WReader = new HtmlReader();
		//html = WReader.read("http://doc.dnip.net");
		html = WReader.readUTF8("http://open.sempee.com/~kfmes/jateonLog/accessBeta.php?id=id@dreamwiz.com");
		//html = WReader.read("http://traffic.local.naver.com/Traffic_Browser/SubwayLine/SubwayLane.asp?sOpt=1&CID=4000&SSN=칠성&ESN=서문시장");
		System.out.println( html );
	}	
	

}
