package kfmes.natelib.util;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * 웹 브라우저를 흉내내는 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: HttpClient.java,v 1.7 2007/11/19 10:13:37 kfmes Exp $
 */
public class HttpClient {
	private InputStream in = null;
	private OutputStream out = null;
	private Socket socket= null;
	private String Server = null;
	private int port = 80;
	
	private String URI = null;
	private String cookie = null;
	public String method = null;

	private String visitedURL = null;
	
	//private String Referer = null;

	private StringBuffer htmlData = null;
	
	private HttpOutgoingMsg msg = null;
	
	

	public HttpOutgoingMsg getMessage(){
		return msg;
	}
	public void setMessage(HttpOutgoingMsg msg){
		this.msg = msg;
	}
	
	public HttpClient(String server, String uri) {
		msg = new HttpOutgoingMsg();
	}	
	public HttpClient(){
		msg = new HttpOutgoingMsg();
	}

	
    public void makeConnection(String Server) throws UnknownHostException, IOException{
    	makeConnection(Server, 80);
    }
    public void makeConnection(String Server, int port) throws UnknownHostException, IOException  {
    	this.Server = Server;
    	this.port = port;
    	
    	closeConnection();
    	socket = new Socket(Server,port);
    }
    
    public void setServer(String Server)    {
    	this.Server = Server;
    }
    public void setServer(String Server, int port){
    	this.Server =Server;
    	this.port = port;
    }
    
    public void closeConnection(){
        if ( in != null ) try{in.close();}catch(Exception e){}
        if ( out != null ) try{out.close();}catch(Exception e){}
        if ( socket != null ) try{socket.close();}catch(Exception e){}    	
    }
    
    public String getHTML(){
    	return htmlData.toString();    	
    }
    public String toString(){
    	return htmlData.toString();
    }
	
    public String navigate(){
    	try{
    		if(in==null || out==null)
    			makeConnection(Server, port);
    		
            in = socket.getInputStream();
            out = socket.getOutputStream();
            htmlData = new StringBuffer();
            this.method = msg.Method;

            PrintWriter pw = new PrintWriter(new BufferedWriter(new OutputStreamWriter(out)));

            this.visitedURL = "http://" + msg.host + msg.URI; 
            
            pw.print(msg.getHeader());
            pw.println(); // dummy line
            pw.flush();

            //System.out.println(body);
            if(method.equals("POST")){
            	
	            pw.print(msg.getBody());
	            pw.flush();
            }
            
            htmlData = read();
        }
        catch(Exception e){
	        e.printStackTrace();
	    }
    	
        return htmlData.toString();
    		
    }
    
        
    public StringBuffer read(){
    	StringBuffer sb = new StringBuffer();
    	try{
	        int length = -1;
	        //read header info
	        String line = null;
	        while( ( line = read_line(in)) != null ) {
	        	sb.append(line + "\n");
	            //System.out.println(line);
	            if ( line.length() == 0 ) break;
	            String key = "Content-Length:";
	            int x = line.indexOf(key);
	
	            if ( x > -1 ) {
	                length = Integer.valueOf(line.substring(x+key.length()+1)).intValue();
	            }
	        }
	        if ( line == null ) throw new Exception("unexcepted header data format");
	
	        if ( length != -1 ) {
	        	sb.append(new String(read_data(in,length)));
	        }
	        else {
	            // NO "Content-Length" field exist in the header
	        	String length_hex =null;
	        	while(in.available()>0){
		        	//if(in.available()>0)
		        		length_hex = read_line(in);
	        		
		            if ( length_hex == null ) throw new Exception("there is no HTTP body data");
		            //sb.append(length_hex);
		  
	            
		            try{
		                length = Integer.valueOf(length_hex.trim(),16).intValue();
		            }
		            catch(Exception e){
		  
		            }
		            
		            if ( length != -1 ) {
		            	sb.append(new String(read_data(in,length)));
		            	length_hex = read_line(in);
		            	}
		            
		            /*
		           else {
		            	sb.append(new String(read_data(in)));
		           }*/
	        	}
	        }
	    }
    	catch (IOException e) {
    		
		}
	    catch(Exception e){
	        e.printStackTrace();
	    }
	    finally {
            if ( in != null ) try{in.close();}catch(Exception e){}
            if ( out != null ) try{out.close();}catch(Exception e){}
            if ( socket != null ) try{socket.close();}catch(Exception e){}
	    }
	    return sb;
    }
	
	public void httpGET(String URI){
		
	}

	public String getVisitedURL(){
		return this.visitedURL;
	}
	


    



    public static final int INTPUTSTREAM_READ_RETRY_COUNT = 10;

    /** 
     * The <code>read_data</code> method of <code>SocketUtil</code> reads the
     * specified length of bytes from the given input stream.
     *
     * @param      in   an inputstream
     * @param      len  the number of bytes read.
     * @return     The specified number of bytes read until the end of
     *             the stream is reached.
     * @exception  Exception  if an I/O error or unexpected EOF occurs
     */
    private static byte[] read_data(InputStream in, int len) throws Exception {
        java.io.ByteArrayOutputStream bout = new java.io.ByteArrayOutputStream();
        int bcount = 0;
        byte[] buf = new byte[2048];
        int read_retry_count = 0;
        while( bcount < len ) {
            int n = in.read(buf,0, len-bcount < 2048 ? len-bcount : 2048 );
            // What would like to do if you've got an unexpected EOF before
            // reading all data ?
            //if (n == -1) break;
            if ( n == -1 ) throw 
                 new java.io.IOException("inputstream has returned an unexpected EOF");

            if ( n == 0 && (++read_retry_count == INTPUTSTREAM_READ_RETRY_COUNT) )
                throw new java.io.IOException("inputstream-read-retry-count( " +
                    INTPUTSTREAM_READ_RETRY_COUNT + ") exceed !");
            if ( n != 0 ) {
                bcount += n;
                bout.write(buf,0,n);
            }
        }
        bout.flush();
        return bout.toByteArray();
    }

    /** 
     * The <code>read_data</code> method of <code>SocketUtil</code> reads all
     * the bytes from the given inputstream until the given input stream 
     * has not returned an EOF(end-of-stream) indicator.
     *
     * @param      in   an inputstream
     * @return     all bytes read if the end of the stream is reached.
     * @exception  Exception  if an I/O error occurs
     */
    private static byte[] read_data(InputStream in) throws Exception {
        java.io.ByteArrayOutputStream bout = new java.io.ByteArrayOutputStream();
        int bcount = 0;
        byte[] buf = new byte[2048];
        int read_retry_count = 0;
        while( true ) {
            int n = in.read(buf);
            if (n == -1) break;
            if ( n == 0 && (++read_retry_count == INTPUTSTREAM_READ_RETRY_COUNT) )
                throw new java.io.IOException("inputstream-read-retry-count( " +
                    INTPUTSTREAM_READ_RETRY_COUNT + ") exceed !");
            if ( n != 0 ) {
                bcount += n;
                bout.write(buf,0,n);
            }
        }
        bout.flush();
        return bout.toByteArray();
    }
  
    /**
     * Read a line of text.  A line is considered to be terminated by a line
     * feed ('\n') or a carriage return followed immediately by a linefeed.
     *
     * @return     A String containing the contents of the line, not including
     *             any line-termination characters, or null if the end of the
     *             stream has been reached
     *
     * @exception  IOException  If an I/O error occurs
     */
    private static String read_line(InputStream in) throws Exception {
        java.io.ByteArrayOutputStream bout = new java.io.ByteArrayOutputStream();
        boolean eof = false;
        while( true ) {
            int b = in.read();
            if (b == -1) { eof = true; break;}
            if ( b != '\r' && b != '\n' ) bout.write((byte)b);
            if (b == '\n') break;
        }
        bout.flush();
        if ( eof && bout.size() == 0 ) return null; 
        //Or return ""; ? what's fit for you?
        return bout.toString();
    }   }
