/**
 * 
 */
package kfmes.natelib.util;

/**HttpClient 에서 보내는 데이터를 구현한 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com );
 * @version $Id: HttpOutgoingMsg.java,v 1.5 2007/11/19 10:13:37 kfmes Exp $
 */
public class HttpOutgoingMsg {

	public String Method = null;
	public String host = null;
	public String URI = null;
	
	public String Content_Type = null;
	
	public String Accept_Charset = null;
	public String Accept = null;
	public String Accept_Language = null;
	public String Accept_Encoding = null;
	public String User_Agent = null;
	
	public String Referer = null;
	public String Cache_Control = null;
	public String Cookie = null;
	public String Connection = null;
	public String Body = null;
	
	public String Header = null;

	public HttpOutgoingMsg() {
	
	}
	public HttpOutgoingMsg(String Method, String host, String URI) {
		set(Method, host, URI);
	}
	
	public void set(String Method, String host, String URI) {
		this.Method= Method;
		this.host = host;
		this.URI = URI;
		makeDefault();
	}
	
	public void makeDefault(){
		Accept = "Accept: */*\n";
		Accept_Language = "Accept-Language: ko,en;q=0.5\n";
		
		Content_Type = (Method.equals("POST")) ? "Content-Type: application/x-www-form-urlencoded\n" : "";
		
		Accept_Encoding = "Accept-Encoding: gzip, deflate\n";
		User_Agent = "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727; .NET CLR 1.1.4322)\n";
		Connection = "Connection: Keep-Alive\n";
		
		Cache_Control = (Method.equals("POST")) ? "Cache-Control: no-cache\n" : "";
		
	}
	
	public void setHeader(String Header){
		this.Header = Header;
	}
	public void setBody(String Body){
		this.Body = Body;
	}
	public String getBody() {
		return this.Body;
	}
	
	/*
	        "Connection: Keep-Alive\n\n" +
	        "Cache-Control: no-cache\n" +
	        ((this.cookie!=null) ? "Cookie: " + this.cookie +"\n" : "") +
	        "\n";
	        //"Cookie: UVID=DwALD
	 */
	
	public String getHeader(){
		this.Header =
			((Method.equals("POST") ? "POST " : "GET ")) + this.URI + " HTTP/1.1\n" +
			((Accept!=null) ? Accept : "") +
			((Referer!=null) ? "Referer: " + Referer : "") +
			((Accept_Language!=null) ? Accept_Language : "") +
			((Content_Type!=null) ? Content_Type : "") +
			((Accept_Encoding!=null) ? Accept_Encoding : "") +
			((User_Agent!=null) ? User_Agent : "") +
			((host!=null) ? "Host: " + host + "\n" : "") +
			((Method.equals("POST")) ? "Content-Length: " + Body.getBytes().length + "\n" : "")+
			((Connection!=null) ? Connection : "") +
			((Cache_Control!=null) ? Cache_Control : "" ) +
			((Cookie!=null) ? "Cookie: " + Cookie : "") +
					"\n"	;
					
		return this.Header;
			
			
	}
	public void makeHttpGet(String Host, String URI){
		set("GET", Host, URI);
		
	}
	public void makeHttpGet(String URL){
		int idx = URL.indexOf("/");
		set("GET", URL.substring(0,idx-1), URL.substring(idx));		
	}
	//http://minihp.cyworld.nate.com/pims/main/pims_main_nateon.asp?tid=359561

	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		System.out.println("foo" + null + "bar");
	}


}
