package kfmes.natelib.util;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * 
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: PasswordEncryptor.java,v 1.7 2007/11/19 10:13:36 kfmes Exp $
 */
public class PasswordEncryptor {
	
	private static int keyXORNumber = 0xe7;

	private static int[] highBits	= { 0xf0, 0xf0, 0xe0, 0xe0, 0xe0, 0xe0 };
	private static int[] lowBits	= { 0x00, 0x04, 0x08, 0x0c, 0x00, 0x04 };	

	private static int encodeASC2NSC(char c) {
		int temp = c ^ keyXORNumber;
		int temp1 = (temp & 0xf0) >> 4;
		int temp2 = temp & 0x0f;
		int temp3 = (temp2 << 4);
		temp3 += temp1;
		return temp3;
	}
	
	private static int decodeNSC2ASC(char c) {
		int temp = c & 0xff;
		int temp1 = (temp & 0xf0) >> 4;
		int temp2 = temp & 0x0f;
		int temp3 = (temp2 << 4);
		temp3 += temp1;
		return temp3 ^ keyXORNumber;
	}
	
	private static int getFifthRepeated(int lastasc) {
		int ref = (lastasc - 0x20) / 0x10;
		int highBit = highBits[ref] - 0x40*(lastasc%4);
		int lowBit = lowBits[ref];
		
		return (highBit | lowBit);
	}
	
	private static int getLengthSum(int len) {
		return len ^ keyXORNumber;
	}
	
	public static String encrypt(String plain) {
		StringBuffer encrypted = new StringBuffer();
		
		if(plain != null && plain.length() > 0 && plain.length() <= 20) {
			int[] encoded = new int[24];
			int[] repeated = new int[8];
			
			int last = encodeASC2NSC(plain.charAt(plain.length()-1));
			
			repeated[0] = last / 4;
			repeated[1] = repeated[0]*2;
			repeated[2] = last;
			repeated[3] = repeated[2]*2;
			repeated[4] = getFifthRepeated(plain.charAt(plain.length()-1));
			repeated[5] = repeated[4]*2;
			repeated[6] = last / 16;
			repeated[7] = repeated[6]*2 + 1; 
			
			System.arraycopy(repeated, 0, encoded, 2, 8);
			System.arraycopy(repeated, 0, encoded, 10, 8);
			System.arraycopy(repeated, 0, encoded, 18, 6);
			
			encoded[0] = getLengthSum(plain.length());
			
			for(int i = 0 ; i < plain.length() ; i++) {
				encoded[i+1] = encodeASC2NSC(plain.charAt(i));
			}
			
			for(int i = 0 ; i < encoded.length ; i++) {
				if(encoded[i] == 0) encoded[i] = 1;
			}
			
			for(int i = 0 ; i < encoded.length ; i++) {
				String s = "0" + Integer.toHexString(encoded[i]);
				//MsgUtil.println(s.substring(s.length()-2));
				encrypted.append(s.substring(s.length()-2));
			}
		}
		
		return encrypted.toString();
	}
	
	public static String getMD5String(String string){
		MessageDigest digest =null;
		try {
			digest = MessageDigest.getInstance("MD5");
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		}
		
		digest.update(string.getBytes());
		StringBuffer sb = new StringBuffer(32);
		
		byte key[]= digest.digest();
		int v;
		
		for(int i=0;i<key.length;i++){
			v = (int)key[i];
			v = v<0 ? v+0x100 : v;
			
			if(v<=0xf) //  0f일경우는 그냥 f 가 되었었던 OTL 
				sb.append('0');
			sb.append(Integer.toHexString(v));
		}
		
		return sb.toString();
	}
	public static String getID(String loginEmail){
		return loginEmail.substring(0, loginEmail.indexOf("@"));
	}
	
	public static void main(String[] args) {
		//MsgUtil.println(PasswordEncryptor.encrypt(args[0]));
		System.out.println(PasswordEncryptor.getID("id@dreamwiz.com"));
	}
}

